/*===========================================================================*/
/*   (Llib/mutex.scm)                                                        */
/*   Bigloo (2.6f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Dec 20 10:51:01 CET 2004        */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo2.6f/bin/bigloo -rm -O3 -I Llib -copt -fPIC -copt -I Posix Llib/mutex.scm -o objs/mutex.o -c)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <bglthread.h>


/* Object type definitions */
typedef struct BgL_threadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52mutexesz52;
   obj_t BgL_z52exczd2handlersz80;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_namez00;
   obj_t BgL_specificz00;
   obj_t BgL_schedulerz00;
   obj_t BgL_cleanupz00;
} *BgL_threadz00_bglt;

typedef struct BgL_schedulerz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52mutexesz52;
   obj_t BgL_z52exczd2handlersz80;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_namez00;
   obj_t BgL_specificz00;
   obj_t BgL_schedulerz00;
   obj_t BgL_cleanupz00;
   obj_t BgL_envzb2zb2;
} *BgL_schedulerz00_bglt;

typedef struct BgL_ftenvz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_instantz00;
} *BgL_ftenvz00_bglt;

typedef struct BgL_mutexz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_specificz00;
   obj_t BgL_z52unlockzd2signalz80;
} *BgL_mutexz00_bglt;

typedef struct BgL_conditionzd2variablezd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_specificz00;
} *BgL_conditionzd2variablezd2_bglt;

typedef struct BgL_z52schedulerz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52mutexesz52;
   obj_t BgL_z52exczd2handlersz80;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_namez00;
   obj_t BgL_specificz00;
   obj_t BgL_schedulerz00;
   obj_t BgL_cleanupz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_nextzd2instantzd2;
   obj_t BgL_currentzd2threadzd2;
   int BgL_z52livezd2threadzd2numberz52;
   bool_t BgL_z52threadszd2readyz80;
   obj_t BgL_threadszd2runnablezd2;
   obj_t BgL_asynczd2runnablezd2;
   obj_t BgL_threadszd2timeoutzd2;
   obj_t BgL_threadszd2yieldzd2;
   obj_t BgL_tostartz00;
   obj_t BgL_toterminatez00;
   obj_t BgL_tosuspendzf2resumezf2;
   obj_t BgL_tobroadcastz00;
   obj_t BgL_tospawnz00;
} *BgL_z52schedulerz52_bglt;

typedef struct BgL_z52sigasyncz52_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_spawnedz00;
   obj_t BgL_idz00;
   obj_t BgL_thunkz00;
} *BgL_z52sigasyncz52_bglt;

typedef struct BgL_z52conditionzd2variablez80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_specificz00;
} *BgL_z52conditionzd2variablez80_bglt;

typedef struct BgL_z52mutexz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_specificz00;
   obj_t BgL_z52unlockzd2signalz80;
   bool_t BgL_z52abandonedz52;
   obj_t BgL_z52ownedz52;
   bool_t BgL_z52lockedz52;
} *BgL_z52mutexz52_bglt;

typedef struct BgL_z52uncaughtzd2exceptionz80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_reasonz00;
} *BgL_z52uncaughtzd2exceptionz80_bglt;

typedef struct BgL_z52signalz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_valsz00;
   int BgL_stampz00;
   obj_t BgL_threadsz00;
} *BgL_z52signalz52_bglt;


BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__ft_mutexz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_typesz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_threadz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_exceptionz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52exceptionz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_signalz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(long, char *);
static obj_t BGl__mutexzd2statezd2zz__ft_mutexz00(obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__ft_mutexz00();
BGL_IMPORT obj_t BGl_objectzd2writezd2zz__objectz00(BgL_objectz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_displayza2za2zz__r4_output_6_10_3z00(obj_t);
static obj_t BGl_objectzd2writezd2mutex1432z00zz__ft_mutexz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t open_input_string(obj_t);
static obj_t BGl_objectzd2displayzd2mutex1430z00zz__ft_mutexz00(obj_t, obj_t, obj_t);
extern obj_t BGl_threadz00zz__ft_typesz00;
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t);
BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mutexzd2unlockz12zc0zz__ft_mutexz00(BgL_mutexz00_bglt, obj_t);
static obj_t BGl__mutexzd2lockz12zc0zz__ft_mutexz00(obj_t, obj_t, obj_t);
extern obj_t BGl_z52threadzd2addzd2mutexz12z40zz__ft_z52threadz52(BgL_threadz00_bglt, BgL_mutexz00_bglt);
extern obj_t BGl_broadcastz12z12zz__ft_schedulerz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_mutexzd2statezd2zz__ft_mutexz00(BgL_mutexz00_bglt);
BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00;
extern obj_t BGl_za2abandonedzd2mutexzd2exceptionza2z00zz__ft_z52exceptionz52;
extern obj_t BGl_threadzd2yieldz12zc0zz__ft_threadz00();
static obj_t BGl_zc3anonymousza31743ze3z83zz__ft_mutexz00(obj_t);
BGL_IMPORT obj_t BGl_modulezd2initzd2errorz00zz__errorz00(char *, char *);
BGL_EXPORTED_DECL obj_t BGl_mutexzd2lockz12zc0zz__ft_mutexz00(BgL_mutexz00_bglt, obj_t);
static obj_t BGl_cnstzd2initzd2zz__ft_mutexz00();
static obj_t BGl_objectzd2printzd2mutex1434z00zz__ft_mutexz00(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl__makezd2mutexzd2zz__ft_mutexz00(obj_t, obj_t);
BGL_IMPORT bool_t BGl_zd3fxzd3zz__r4_numbers_6_5_fixnumz00(long, long);
BGL_IMPORT obj_t BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
extern obj_t BGl_mutexz00zz__ft_typesz00;
BGL_EXPORTED_DECL BgL_mutexz00_bglt BGl_makezd2mutexzd2zz__ft_mutexz00(obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__ft_mutexz00();
extern BgL_z52mutexz52_bglt BGl_makezd2z52mutexz80zz__ft_z52typesz52(obj_t, obj_t, obj_t, bool_t, obj_t, bool_t);
static obj_t BGl_requirezd2initializa7ationz75zz__ft_mutexz00 = BUNSPEC;
extern obj_t BGl_raisez00zz__ft_exceptionz00(obj_t);
extern obj_t BGl_z52threadzd2delzd2mutexz12z40zz__ft_z52threadz52(BgL_threadz00_bglt, BgL_mutexz00_bglt);
BGL_IMPORT long BGl_bitzd2andzd2zz__bitz00(long, long);
extern bool_t BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_threadz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_addzd2methodz12zc0zz__objectz00(obj_t, obj_t, obj_t);
static obj_t BGl_zc3anonymousza31705ze3z83zz__ft_mutexz00(obj_t);
extern obj_t BGl_threadzd2awaitz12zc0zz__ft_threadz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_bigloozd2typezd2errorz00zz__errorz00(obj_t, obj_t, obj_t);
extern obj_t BGl_conditionzd2variablezd2zz__ft_typesz00;
static obj_t BGl_libraryzd2moduleszd2initz00zz__ft_mutexz00();
extern obj_t BGl_z52mutexz52zz__ft_z52typesz52;
static obj_t BGl_toplevelzd2initzd2zz__ft_mutexz00();
static obj_t BGl__mutexzd2unlockz12zc0zz__ft_mutexz00(obj_t, obj_t, obj_t);
extern obj_t BGl_currentzd2threadzd2zz__ft_threadz00();
static obj_t __cnst[ 18 ] ;


BGL_IMPORT obj_t BGl_objectzd2writezd2envz00zz__objectz00;
DEFINE_EXPORT_PROCEDURE( BGl_mutexzd2statezd2envz00zz__ft_mutexz00, BgL_bgl__mutexza7d2stateza7d2za7za7__ft_mutexza7002454za7, BGl__mutexzd2statezd2zz__ft_mutexz00, 0L, 1 );
BGL_IMPORT obj_t BGl_objectzd2printzd2envz00zz__objectz00;
DEFINE_EXPORT_PROCEDURE( BGl_makezd2mutexzd2envz00zz__ft_mutexz00, BgL_bgl__makeza7d2mutexza7d2za7za7__ft_mutexza7002455za7, va_generic_entry, BGl__makezd2mutexzd2zz__ft_mutexz00, -1 );
BGL_IMPORT obj_t BGl_objectzd2displayzd2envz00zz__objectz00;
DEFINE_EXPORT_PROCEDURE( BGl_mutexzd2unlockz12zd2envz12zz__ft_mutexz00, BgL_bgl__mutexza7d2unlockza712za7c0za7za7__ft_mutexza7002456z00, va_generic_entry, BGl__mutexzd2unlockz12zc0zz__ft_mutexz00, -2 );
DEFINE_EXPORT_PROCEDURE( BGl_mutexzd2lockz12zd2envz12zz__ft_mutexz00, BgL_bgl__mutexza7d2lockza712za7c0za7za7__ft_mutexza7002457z00, va_generic_entry, BGl__mutexzd2lockz12zc0zz__ft_mutexz00, -2 );
DEFINE_STATIC_PROCEDURE( BGl_proc2403z00zz__ft_mutexz00, BgL_bgl_objectza7d2displayza7d2mutex1430za700za7za7__ft_mutexza7002458z00, va_generic_entry, BGl_objectzd2displayzd2mutex1430z00zz__ft_mutexz00, -2 );
DEFINE_STATIC_PROCEDURE( BGl_proc2404z00zz__ft_mutexz00, BgL_bgl_objectza7d2writeza7d2mutex1432za700za7za7__ft_mutexza7002459z00, va_generic_entry, BGl_objectzd2writezd2mutex1432z00zz__ft_mutexz00, -2 );
DEFINE_STATIC_PROCEDURE( BGl_proc2405z00zz__ft_mutexz00, BgL_bgl_objectza7d2printza7d2mutex1434za700za7za7__ft_mutexza7002460z00, BGl_objectzd2printzd2mutex1434z00zz__ft_mutexz00, 0L, 3 );
DEFINE_STRING( BGl_string2415z00zz__ft_mutexz00, BgL_bgl_string2415za700za7za7__ft_mutexza7002461z00, "<anonymous:1705> object-display-mutex1430 <anonymous:1743> object-write-mutex1432 object-print-mutex1434 _mutex-unlock! mutex-unlock! _mutex-lock! mutex-lock! _mutex-state not-abandoned abandoned not-owned mutex-state unlock (funcall gensym gensym (quote mutex)) mutex make-mutex ", 280 );
DEFINE_STRING( BGl_string2414z00zz__ft_mutexz00, BgL_bgl_string2414za700za7za7__ft_mutexza7002462z00, "__ft_mutex", 10 );
DEFINE_STRING( BGl_string2413z00zz__ft_mutexz00, BgL_bgl_string2413za700za7za7__ft_mutexza7002463z00, "#<mutex:", 8 );
DEFINE_STRING( BGl_string2412z00zz__ft_mutexz00, BgL_bgl_string2412za700za7za7__ft_mutexza7002464z00, ":", 1 );
DEFINE_STRING( BGl_string2411z00zz__ft_mutexz00, BgL_bgl_string2411za700za7za7__ft_mutexza7002465z00, ">", 1 );
DEFINE_STRING( BGl_string2410z00zz__ft_mutexz00, BgL_bgl_string2410za700za7za7__ft_mutexza7002466z00, "not-locked", 10 );
DEFINE_STRING( BGl_string2409z00zz__ft_mutexz00, BgL_bgl_string2409za700za7za7__ft_mutexza7002467z00, "locked", 6 );
DEFINE_STRING( BGl_string2399z00zz__ft_mutexz00, BgL_bgl_string2399za700za7za7__ft_mutexza7002468z00, "Illegal thread", 14 );
DEFINE_STRING( BGl_string2408z00zz__ft_mutexz00, BgL_bgl_string2408za700za7za7__ft_mutexza7002469z00, "not-abandoned/", 14 );
DEFINE_STRING( BGl_string2398z00zz__ft_mutexz00, BgL_bgl_string2398za700za7za7__ft_mutexza7002470z00, "integer", 7 );
DEFINE_STRING( BGl_string2407z00zz__ft_mutexz00, BgL_bgl_string2407za700za7za7__ft_mutexza7002471z00, "abandoned/", 10 );
DEFINE_STRING( BGl_string2397z00zz__ft_mutexz00, BgL_bgl_string2397za700za7za7__ft_mutexza7002472z00, "mutex-lock!", 11 );
DEFINE_STRING( BGl_string2406z00zz__ft_mutexz00, BgL_bgl_string2406za700za7za7__ft_mutexza7002473z00, "output-port", 11 );
DEFINE_STRING( BGl_string2396z00zz__ft_mutexz00, BgL_bgl_string2396za700za7za7__ft_mutexza7002474z00, "thread", 6 );
DEFINE_STRING( BGl_string2395z00zz__ft_mutexz00, BgL_bgl_string2395za700za7za7__ft_mutexza7002475z00, "mutex", 5 );
DEFINE_STRING( BGl_string2394z00zz__ft_mutexz00, BgL_bgl_string2394za700za7za7__ft_mutexza7002476z00, "%mutex", 6 );
DEFINE_STRING( BGl_string2393z00zz__ft_mutexz00, BgL_bgl_string2393za700za7za7__ft_mutexza7002477z00, "make-mutex:Wrong number of arguments", 36 );
DEFINE_STRING( BGl_string2402z00zz__ft_mutexz00, BgL_bgl_string2402za700za7za7__ft_mutexza7002478z00, "condition-variable", 18 );
DEFINE_STRING( BGl_string2392z00zz__ft_mutexz00, BgL_bgl_string2392za700za7za7__ft_mutexza7002479z00, "procedure", 9 );
DEFINE_STRING( BGl_string2401z00zz__ft_mutexz00, BgL_bgl_string2401za700za7za7__ft_mutexza7002480z00, "No current thread", 17 );
DEFINE_STRING( BGl_string2391z00zz__ft_mutexz00, BgL_bgl_string2391za700za7za7__ft_mutexza7002481z00, "pair", 4 );
DEFINE_STRING( BGl_string2400z00zz__ft_mutexz00, BgL_bgl_string2400za700za7za7__ft_mutexza7002482z00, "mutex-unlock!", 13 );



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__ft_mutexz00(long BgL_checksumz00_794, char * BgL_fromz00_795)
{ AN_OBJECT;
{ 
if(
BGl_zd3fxzd3zz__r4_numbers_6_5_fixnumz00(
(long)CINT(
BINT(
BGl_bitzd2andzd2zz__bitz00(BgL_checksumz00_794, ((long)7145)))), BgL_checksumz00_794))
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__ft_mutexz00))
{ 
BGl_requirezd2initializa7ationz75zz__ft_mutexz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zz__ft_mutexz00(); 
BGl_cnstzd2initzd2zz__ft_mutexz00(); 
BGl_importedzd2moduleszd2initz00zz__ft_mutexz00(); 
BGl_methodzd2initzd2zz__ft_mutexz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} }  else 
{ 
return 
BGl_modulezd2initzd2errorz00zz__errorz00(
BSTRING_TO_STRING("__ft_mutex"), BgL_fromz00_795);} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__ft_mutexz00()
{ AN_OBJECT;
{ /* ./Llib/mutex.scm 15 */
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__ft_mutex"); 
BGl_modulezd2initializa7ationz75zz__r4_output_6_10_3z00(((long)0), "__ft_mutex"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__ft_mutex"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "__ft_mutex"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__ft_mutex"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__ft_mutex"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__ft_mutexz00()
{ AN_OBJECT;
{ /* ./Llib/mutex.scm 15 */
{ /* ./Llib/mutex.scm 15 */
obj_t BgL_cportz00_749;
BgL_cportz00_749 = 
open_input_string(BGl_string2415z00zz__ft_mutexz00); 
{ 
long BgL_iz00_750;
BgL_iz00_750 = ((long)17); 
BgL_loopz00_751:
if(
(BgL_iz00_750==((long)-1)))
{ /* ./Llib/mutex.scm 15 */
return BUNSPEC;}  else 
{ /* ./Llib/mutex.scm 15 */
{ /* ./Llib/mutex.scm 15 */
obj_t BgL_arg2419z00_753;
{ /* ./Llib/mutex.scm 15 */
obj_t BgL_list2422z00_754;
BgL_list2422z00_754 = 
MAKE_PAIR(BgL_cportz00_749, BNIL); 
BgL_arg2419z00_753 = 
BGl_readz00zz__readerz00(BgL_list2422z00_754); } 
{ /* ./Llib/mutex.scm 15 */
int BgL_auxz00_823;
BgL_auxz00_823 = 
(int)(BgL_iz00_750); 
CNST_TABLE_SET(BgL_auxz00_823, BgL_arg2419z00_753); } } 
{ /* ./Llib/mutex.scm 15 */
int BgL_auxz00_755;
BgL_auxz00_755 = 
(int)(
(BgL_iz00_750-((long)1))); 
{ 
long BgL_iz00_828;
BgL_iz00_828 = 
(long)(BgL_auxz00_755); 
BgL_iz00_750 = BgL_iz00_828; 
goto BgL_loopz00_751;} } } } } } 
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__ft_mutexz00()
{ AN_OBJECT;
{ /* ./Llib/mutex.scm 15 */
return BUNSPEC;} 
}



/* make-mutex */
BGL_EXPORTED_DEF BgL_mutexz00_bglt BGl_makezd2mutexzd2zz__ft_mutexz00(obj_t BgL_namez00_4)
{ AN_OBJECT;
{ /* ./Llib/mutex.scm 35 */
{ /* ./Llib/mutex.scm 37 */
obj_t BgL_arg1443z00_213;obj_t BgL_arg1445z00_214;
if(
PAIRP(BgL_namez00_4))
{ /* ./Llib/mutex.scm 37 */
obj_t BgL_pairz00_441;
if(
PAIRP(BgL_namez00_4))
{ /* ./Llib/mutex.scm 37 */
BgL_pairz00_441 = BgL_namez00_4; }  else 
{ /* ./Llib/mutex.scm 37 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2391z00zz__ft_mutexz00, BgL_namez00_4); 
exit( -1 );} 
BgL_arg1443z00_213 = 
CAR(BgL_pairz00_441); }  else 
{ /* ./Llib/mutex.scm 37 */
obj_t BgL_funz00_614;
{ /* ./Llib/mutex.scm 37 */
obj_t BgL_aux1857z00_612;
BgL_aux1857z00_612 = BGl_gensymz00zz__r4_symbols_6_4z00; 
if(
PROCEDUREP(BgL_aux1857z00_612))
{ /* ./Llib/mutex.scm 37 */
BgL_funz00_614 = BgL_aux1857z00_612; }  else 
{ /* ./Llib/mutex.scm 37 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2392z00zz__ft_mutexz00, BgL_aux1857z00_612); 
exit( -1 );} } 
if(
PROCEDURE_CORRECT_ARITYP(BgL_funz00_614, ((long)1)))
{ /* ./Llib/mutex.scm 37 */
BgL_arg1443z00_213 = 
PROCEDURE_ENTRY(BgL_funz00_614)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)1)), BEOA); }  else 
{ 
obj_t BgL_auxz00_848;
BgL_auxz00_848 = 
CNST_TABLE_REF(((long)2)); 
FAILURE(BGl_string2393z00zz__ft_mutexz00,BgL_auxz00_848,BgL_funz00_614);} } 
BgL_arg1445z00_214 = 
MAKE_PAIR(
CNST_TABLE_REF(((long)1)), 
CNST_TABLE_REF(((long)3))); 
{ /* ./Llib/mutex.scm 36 */
BgL_z52mutexz52_bglt BgL_auxz00_854;
BgL_auxz00_854 = 
BGl_makezd2z52mutexz80zz__ft_z52typesz52(BgL_arg1443z00_213, BUNSPEC, BgL_arg1445z00_214, ((bool_t)0), BFALSE, ((bool_t)0)); 
return 
(BgL_mutexz00_bglt)(BgL_auxz00_854);} } } 
}



/* _make-mutex */
obj_t BGl__makezd2mutexzd2zz__ft_mutexz00(obj_t BgL_envz00_569, obj_t BgL_namez00_570)
{ AN_OBJECT;
{ /* ./Llib/mutex.scm 35 */
{ /* ./Llib/mutex.scm 37 */
BgL_mutexz00_bglt BgL_auxz00_857;
BgL_auxz00_857 = 
BGl_makezd2mutexzd2zz__ft_mutexz00(BgL_namez00_570); 
return 
(obj_t)(BgL_auxz00_857);} } 
}



/* mutex-state */
BGL_EXPORTED_DEF obj_t BGl_mutexzd2statezd2zz__ft_mutexz00(BgL_mutexz00_bglt BgL_mz00_12)
{ AN_OBJECT;
{ /* ./Llib/mutex.scm 69 */
{ /* ./Llib/mutex.scm 72 */
bool_t BgL_testz00_860;
{ /* ./Llib/mutex.scm 72 */
BgL_z52mutexz52_bglt BgL_obj1354z00_442;
{ /* ./Llib/mutex.scm 72 */
obj_t BgL_aux21871z00_618;
BgL_aux21871z00_618 = 
((obj_t)BgL_mz00_12); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux21871z00_618, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 72 */
BgL_obj1354z00_442 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_12); }  else 
{ /* ./Llib/mutex.scm 72 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)4)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_12)); 
exit( -1 );} } 
BgL_testz00_860 = 
(((BgL_z52mutexz52_bglt)CREF(BgL_obj1354z00_442))->BgL_z52lockedz52); } 
if(BgL_testz00_860)
{ /* ./Llib/mutex.scm 72 */
bool_t BgL_testz00_870;
{ /* ./Llib/mutex.scm 72 */
obj_t BgL_arg1459z00_219;
{ /* ./Llib/mutex.scm 72 */
BgL_z52mutexz52_bglt BgL_obj1351z00_443;
{ /* ./Llib/mutex.scm 72 */
obj_t BgL_aux21881z00_621;
BgL_aux21881z00_621 = 
((obj_t)BgL_mz00_12); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux21881z00_621, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 72 */
BgL_obj1351z00_443 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_12); }  else 
{ /* ./Llib/mutex.scm 72 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)4)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_12)); 
exit( -1 );} } 
BgL_arg1459z00_219 = 
(((BgL_z52mutexz52_bglt)CREF(BgL_obj1351z00_443))->BgL_z52ownedz52); } 
BgL_testz00_870 = 
BGl_iszd2azf3z21zz__objectz00(BgL_arg1459z00_219, BGl_threadz00zz__ft_typesz00); } 
if(BgL_testz00_870)
{ /* ./Llib/mutex.scm 72 */
BgL_z52mutexz52_bglt BgL_obj1351z00_445;
{ /* ./Llib/mutex.scm 72 */
obj_t BgL_aux21891z00_624;
BgL_aux21891z00_624 = 
((obj_t)BgL_mz00_12); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux21891z00_624, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 72 */
BgL_obj1351z00_445 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_12); }  else 
{ /* ./Llib/mutex.scm 72 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)4)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_12)); 
exit( -1 );} } 
return 
(((BgL_z52mutexz52_bglt)CREF(BgL_obj1351z00_445))->BgL_z52ownedz52);}  else 
{ /* ./Llib/mutex.scm 72 */
return 
CNST_TABLE_REF(((long)5));} }  else 
{ /* ./Llib/mutex.scm 73 */
bool_t BgL_testz00_891;
{ /* ./Llib/mutex.scm 73 */
BgL_z52mutexz52_bglt BgL_obj1348z00_446;
{ /* ./Llib/mutex.scm 73 */
obj_t BgL_aux21902z00_627;
BgL_aux21902z00_627 = 
((obj_t)BgL_mz00_12); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux21902z00_627, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 73 */
BgL_obj1348z00_446 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_12); }  else 
{ /* ./Llib/mutex.scm 73 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)4)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_12)); 
exit( -1 );} } 
BgL_testz00_891 = 
(((BgL_z52mutexz52_bglt)CREF(BgL_obj1348z00_446))->BgL_z52abandonedz52); } 
if(BgL_testz00_891)
{ /* ./Llib/mutex.scm 73 */
return 
CNST_TABLE_REF(((long)6));}  else 
{ /* ./Llib/mutex.scm 73 */
return 
CNST_TABLE_REF(((long)7));} } } } 
}



/* _mutex-state */
obj_t BGl__mutexzd2statezd2zz__ft_mutexz00(obj_t BgL_envz00_571, obj_t BgL_mz00_572)
{ AN_OBJECT;
{ /* ./Llib/mutex.scm 69 */
{ /* ./Llib/mutex.scm 70 */
BgL_mutexz00_bglt BgL_auxz00_903;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_mz00_572, BGl_mutexz00zz__ft_typesz00))
{ /* ./Llib/mutex.scm 70 */
BgL_auxz00_903 = 
(BgL_mutexz00_bglt)(BgL_mz00_572)
; }  else 
{ /* ./Llib/mutex.scm 70 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string2395z00zz__ft_mutexz00, BgL_mz00_572); 
exit( -1 );} 
return 
BGl_mutexzd2statezd2zz__ft_mutexz00(BgL_auxz00_903);} } 
}



/* mutex-lock! */
BGL_EXPORTED_DEF obj_t BGl_mutexzd2lockz12zc0zz__ft_mutexz00(BgL_mutexz00_bglt BgL_mz00_13, obj_t BgL_argz00_14)
{ AN_OBJECT;
{ /* ./Llib/mutex.scm 79 */
{ 
obj_t BgL_timeoutz00_247;obj_t BgL_threadz00_248;
{ 
obj_t BgL_timeoutz00_225;obj_t BgL_timeoutz00_222;obj_t BgL_threadz00_223;
if(
PAIRP(BgL_argz00_14))
{ /* ./Llib/mutex.scm 117 */
obj_t BgL_cdrzd2110zd2_230;
{ /* ./Llib/mutex.scm 117 */
obj_t BgL_pairz00_448;
if(
PAIRP(BgL_argz00_14))
{ /* ./Llib/mutex.scm 117 */
BgL_pairz00_448 = BgL_argz00_14; }  else 
{ /* ./Llib/mutex.scm 117 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2391z00zz__ft_mutexz00, BgL_argz00_14); 
exit( -1 );} 
BgL_cdrzd2110zd2_230 = 
CDR(BgL_pairz00_448); } 
if(
PAIRP(BgL_cdrzd2110zd2_230))
{ /* ./Llib/mutex.scm 117 */
bool_t BgL_testz00_921;
{ /* ./Llib/mutex.scm 117 */
obj_t BgL_auxz00_922;
{ /* ./Llib/mutex.scm 117 */
obj_t BgL_pairz00_450;
if(
PAIRP(BgL_cdrzd2110zd2_230))
{ /* ./Llib/mutex.scm 117 */
BgL_pairz00_450 = BgL_cdrzd2110zd2_230; }  else 
{ /* ./Llib/mutex.scm 117 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2391z00zz__ft_mutexz00, BgL_cdrzd2110zd2_230); 
exit( -1 );} 
BgL_auxz00_922 = 
CDR(BgL_pairz00_450); } 
BgL_testz00_921 = 
NULLP(BgL_auxz00_922); } 
if(BgL_testz00_921)
{ /* ./Llib/mutex.scm 117 */
obj_t BgL_arg1469z00_233;obj_t BgL_arg1470z00_234;
{ /* ./Llib/mutex.scm 117 */
obj_t BgL_pairz00_452;
if(
PAIRP(BgL_argz00_14))
{ /* ./Llib/mutex.scm 117 */
BgL_pairz00_452 = BgL_argz00_14; }  else 
{ /* ./Llib/mutex.scm 117 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2391z00zz__ft_mutexz00, BgL_argz00_14); 
exit( -1 );} 
BgL_arg1469z00_233 = 
CAR(BgL_pairz00_452); } 
{ /* ./Llib/mutex.scm 117 */
obj_t BgL_pairz00_453;
if(
PAIRP(BgL_cdrzd2110zd2_230))
{ /* ./Llib/mutex.scm 117 */
BgL_pairz00_453 = BgL_cdrzd2110zd2_230; }  else 
{ /* ./Llib/mutex.scm 117 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2391z00zz__ft_mutexz00, BgL_cdrzd2110zd2_230); 
exit( -1 );} 
BgL_arg1470z00_234 = 
CAR(BgL_pairz00_453); } 
BgL_timeoutz00_222 = BgL_arg1469z00_233; 
BgL_threadz00_223 = BgL_arg1470z00_234; 
{ /* ./Llib/mutex.scm 120 */
bool_t BgL_testz00_942;
if(
CBOOL(BgL_timeoutz00_222))
{ /* ./Llib/mutex.scm 120 */
bool_t BgL_testz00_945;
if(
INTEGERP(BgL_timeoutz00_222))
{ /* ./Llib/mutex.scm 120 */
BgL_testz00_945 = ((bool_t)1)
; }  else 
{ /* ./Llib/mutex.scm 120 */
if(
REALP(BgL_timeoutz00_222))
{ /* ./Llib/mutex.scm 120 */
BgL_testz00_945 = ((bool_t)1)
; }  else 
{ /* ./Llib/mutex.scm 120 */
if(
ELONGP(BgL_timeoutz00_222))
{ /* ./Llib/mutex.scm 120 */
BgL_testz00_945 = ((bool_t)1)
; }  else 
{ /* ./Llib/mutex.scm 120 */
BgL_testz00_945 = 
LLONGP(BgL_timeoutz00_222)
; } } } 
if(BgL_testz00_945)
{ /* ./Llib/mutex.scm 120 */
BgL_testz00_942 = ((bool_t)0)
; }  else 
{ /* ./Llib/mutex.scm 120 */
BgL_testz00_942 = ((bool_t)1)
; } }  else 
{ /* ./Llib/mutex.scm 120 */
BgL_testz00_942 = ((bool_t)0)
; } 
if(BgL_testz00_942)
{ /* ./Llib/mutex.scm 120 */
return 
BGl_bigloozd2typezd2errorz00zz__errorz00(BGl_string2397z00zz__ft_mutexz00, BGl_string2398z00zz__ft_mutexz00, BgL_timeoutz00_222);}  else 
{ /* ./Llib/mutex.scm 122 */
bool_t BgL_testz00_954;
if(
CBOOL(BgL_threadz00_223))
{ /* ./Llib/mutex.scm 122 */
if(
BGl_iszd2azf3z21zz__objectz00(BgL_threadz00_223, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/mutex.scm 122 */
BgL_testz00_954 = ((bool_t)0)
; }  else 
{ /* ./Llib/mutex.scm 122 */
BgL_testz00_954 = ((bool_t)1)
; } }  else 
{ /* ./Llib/mutex.scm 122 */
BgL_testz00_954 = ((bool_t)0)
; } 
if(BgL_testz00_954)
{ /* ./Llib/mutex.scm 122 */
FAILURE(BGl_string2397z00zz__ft_mutexz00,BGl_string2399z00zz__ft_mutexz00,BgL_threadz00_223);}  else 
{ /* ./Llib/mutex.scm 122 */
BgL_timeoutz00_247 = BgL_timeoutz00_222; 
BgL_threadz00_248 = BgL_threadz00_223; 
BgL_zc3anonymousza31519ze3z83_249:
{ /* ./Llib/mutex.scm 83 */
bool_t BgL_testz00_960;
{ /* ./Llib/mutex.scm 83 */
BgL_z52mutexz52_bglt BgL_obj1354z00_483;
{ /* ./Llib/mutex.scm 83 */
obj_t BgL_aux21920z00_632;
BgL_aux21920z00_632 = 
((obj_t)BgL_mz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux21920z00_632, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 83 */
BgL_obj1354z00_483 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_13); }  else 
{ /* ./Llib/mutex.scm 83 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_13)); 
exit( -1 );} } 
BgL_testz00_960 = 
(((BgL_z52mutexz52_bglt)CREF(BgL_obj1354z00_483))->BgL_z52lockedz52); } 
if(BgL_testz00_960)
{ /* ./Llib/mutex.scm 84 */
bool_t BgL_testz00_970;
if(
INTEGERP(BgL_timeoutz00_247))
{ /* ./Llib/mutex.scm 84 */
BgL_testz00_970 = ((bool_t)1)
; }  else 
{ /* ./Llib/mutex.scm 84 */
if(
REALP(BgL_timeoutz00_247))
{ /* ./Llib/mutex.scm 84 */
BgL_testz00_970 = ((bool_t)1)
; }  else 
{ /* ./Llib/mutex.scm 84 */
if(
ELONGP(BgL_timeoutz00_247))
{ /* ./Llib/mutex.scm 84 */
BgL_testz00_970 = ((bool_t)1)
; }  else 
{ /* ./Llib/mutex.scm 84 */
BgL_testz00_970 = 
LLONGP(BgL_timeoutz00_247)
; } } } 
if(BgL_testz00_970)
{ /* ./Llib/mutex.scm 85 */
obj_t BgL_arg1523z00_253;
BgL_arg1523z00_253 = 
(((BgL_mutexz00_bglt)CREF(BgL_mz00_13))->BgL_z52unlockzd2signalz80); 
{ /* ./Llib/mutex.scm 85 */
obj_t BgL_list1525z00_254;
BgL_list1525z00_254 = 
MAKE_PAIR(BgL_timeoutz00_247, BNIL); 
BGl_threadzd2awaitz12zc0zz__ft_threadz00(BgL_arg1523z00_253, BgL_list1525z00_254); } }  else 
{ /* ./Llib/mutex.scm 86 */
obj_t BgL_arg1529z00_255;
BgL_arg1529z00_255 = 
(((BgL_mutexz00_bglt)CREF(BgL_mz00_13))->BgL_z52unlockzd2signalz80); 
BGl_threadzd2awaitz12zc0zz__ft_threadz00(BgL_arg1529z00_255, BNIL); } }  else 
{ /* ./Llib/mutex.scm 83 */BFALSE; } } 
{ /* ./Llib/mutex.scm 89 */
bool_t BgL_testz00_983;
{ /* ./Llib/mutex.scm 89 */
BgL_z52mutexz52_bglt BgL_obj1354z00_495;
{ /* ./Llib/mutex.scm 89 */
obj_t BgL_aux21931z00_635;
BgL_aux21931z00_635 = 
((obj_t)BgL_mz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux21931z00_635, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 89 */
BgL_obj1354z00_495 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_13); }  else 
{ /* ./Llib/mutex.scm 89 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_13)); 
exit( -1 );} } 
BgL_testz00_983 = 
(((BgL_z52mutexz52_bglt)CREF(BgL_obj1354z00_495))->BgL_z52lockedz52); } 
if(BgL_testz00_983)
{ /* ./Llib/mutex.scm 89 */
return BFALSE;}  else 
{ /* ./Llib/mutex.scm 89 */
if(
CBOOL(BgL_threadz00_248))
{ /* ./Llib/mutex.scm 96 */
bool_t BgL_tozd2raisezd2_258;
{ /* ./Llib/mutex.scm 96 */
bool_t BgL_testz00_995;
{ /* ./Llib/mutex.scm 96 */
bool_t BgL_testz00_996;
{ /* ./Llib/mutex.scm 96 */
BgL_z52mutexz52_bglt BgL_obj1354z00_496;
{ /* ./Llib/mutex.scm 96 */
obj_t BgL_aux21944z00_638;
BgL_aux21944z00_638 = 
((obj_t)BgL_mz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux21944z00_638, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 96 */
BgL_obj1354z00_496 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_13); }  else 
{ /* ./Llib/mutex.scm 96 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_13)); 
exit( -1 );} } 
BgL_testz00_996 = 
(((BgL_z52mutexz52_bglt)CREF(BgL_obj1354z00_496))->BgL_z52lockedz52); } 
if(BgL_testz00_996)
{ /* ./Llib/mutex.scm 96 */
BgL_testz00_995 = ((bool_t)0)
; }  else 
{ /* ./Llib/mutex.scm 96 */
BgL_testz00_995 = ((bool_t)1)
; } } 
if(BgL_testz00_995)
{ /* ./Llib/mutex.scm 96 */
BgL_z52mutexz52_bglt BgL_obj1348z00_497;
{ /* ./Llib/mutex.scm 96 */
obj_t BgL_aux21954z00_641;
BgL_aux21954z00_641 = 
((obj_t)BgL_mz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux21954z00_641, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 96 */
BgL_obj1348z00_497 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_13); }  else 
{ /* ./Llib/mutex.scm 96 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_13)); 
exit( -1 );} } 
BgL_tozd2raisezd2_258 = 
(((BgL_z52mutexz52_bglt)CREF(BgL_obj1348z00_497))->BgL_z52abandonedz52); }  else 
{ /* ./Llib/mutex.scm 96 */
BgL_tozd2raisezd2_258 = ((bool_t)0); } } 
{ /* ./Llib/mutex.scm 97 */
bool_t BgL_testz00_1015;
{ /* ./Llib/mutex.scm 97 */
BgL_threadz00_bglt BgL_auxz00_1016;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_threadz00_248, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/mutex.scm 97 */
BgL_auxz00_1016 = 
(BgL_threadz00_bglt)(BgL_threadz00_248)
; }  else 
{ /* ./Llib/mutex.scm 97 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2396z00zz__ft_mutexz00, BgL_threadz00_248); 
exit( -1 );} 
BgL_testz00_1015 = 
BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_auxz00_1016, BNIL); } 
if(BgL_testz00_1015)
{ /* ./Llib/mutex.scm 97 */
{ /* ./Llib/mutex.scm 99 */
BgL_z52mutexz52_bglt BgL_obj1350z00_498;bool_t BgL_val1349z00_499;
{ /* ./Llib/mutex.scm 99 */
obj_t BgL_aux21973z00_646;
BgL_aux21973z00_646 = 
((obj_t)BgL_mz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux21973z00_646, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 99 */
BgL_obj1350z00_498 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_13); }  else 
{ /* ./Llib/mutex.scm 99 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_13)); 
exit( -1 );} } 
BgL_val1349z00_499 = ((bool_t)1); 
((((BgL_z52mutexz52_bglt)CREF(BgL_obj1350z00_498))->BgL_z52abandonedz52) = ((bool_t)BgL_val1349z00_499), BUNSPEC); } 
{ /* ./Llib/mutex.scm 100 */
BgL_z52mutexz52_bglt BgL_obj1356z00_500;bool_t BgL_val1355z00_501;
{ /* ./Llib/mutex.scm 100 */
obj_t BgL_aux21983z00_649;
BgL_aux21983z00_649 = 
((obj_t)BgL_mz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux21983z00_649, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 100 */
BgL_obj1356z00_500 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_13); }  else 
{ /* ./Llib/mutex.scm 100 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_13)); 
exit( -1 );} } 
BgL_val1355z00_501 = ((bool_t)0); 
((((BgL_z52mutexz52_bglt)CREF(BgL_obj1356z00_500))->BgL_z52lockedz52) = ((bool_t)BgL_val1355z00_501), BUNSPEC); } 
{ /* ./Llib/mutex.scm 101 */
BgL_z52mutexz52_bglt BgL_obj1353z00_502;obj_t BgL_val1352z00_503;
{ /* ./Llib/mutex.scm 101 */
obj_t BgL_aux21993z00_652;
BgL_aux21993z00_652 = 
((obj_t)BgL_mz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux21993z00_652, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 101 */
BgL_obj1353z00_502 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_13); }  else 
{ /* ./Llib/mutex.scm 101 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_13)); 
exit( -1 );} } 
BgL_val1352z00_503 = BFALSE; 
((((BgL_z52mutexz52_bglt)CREF(BgL_obj1353z00_502))->BgL_z52ownedz52) = ((obj_t)BgL_val1352z00_503), BUNSPEC); } 
if(BgL_tozd2raisezd2_258)
{ /* ./Llib/mutex.scm 102 */
return 
BGl_raisez00zz__ft_exceptionz00(BGl_za2abandonedzd2mutexzd2exceptionza2z00zz__ft_z52exceptionz52);}  else 
{ /* ./Llib/mutex.scm 102 */
return BTRUE;} }  else 
{ /* ./Llib/mutex.scm 97 */
{ /* ./Llib/mutex.scm 106 */
BgL_z52mutexz52_bglt BgL_obj1350z00_504;bool_t BgL_val1349z00_505;
{ /* ./Llib/mutex.scm 106 */
obj_t BgL_aux22005z00_655;
BgL_aux22005z00_655 = 
((obj_t)BgL_mz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22005z00_655, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 106 */
BgL_obj1350z00_504 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_13); }  else 
{ /* ./Llib/mutex.scm 106 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_13)); 
exit( -1 );} } 
BgL_val1349z00_505 = ((bool_t)0); 
((((BgL_z52mutexz52_bglt)CREF(BgL_obj1350z00_504))->BgL_z52abandonedz52) = ((bool_t)BgL_val1349z00_505), BUNSPEC); } 
{ /* ./Llib/mutex.scm 107 */
BgL_z52mutexz52_bglt BgL_obj1356z00_506;bool_t BgL_val1355z00_507;
{ /* ./Llib/mutex.scm 107 */
obj_t BgL_aux22015z00_658;
BgL_aux22015z00_658 = 
((obj_t)BgL_mz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22015z00_658, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 107 */
BgL_obj1356z00_506 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_13); }  else 
{ /* ./Llib/mutex.scm 107 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_13)); 
exit( -1 );} } 
BgL_val1355z00_507 = ((bool_t)1); 
((((BgL_z52mutexz52_bglt)CREF(BgL_obj1356z00_506))->BgL_z52lockedz52) = ((bool_t)BgL_val1355z00_507), BUNSPEC); } 
{ /* ./Llib/mutex.scm 108 */
bool_t BgL_testz00_1071;
{ /* ./Llib/mutex.scm 108 */
bool_t BgL_testz00_1072;
{ /* ./Llib/mutex.scm 108 */
obj_t BgL_arg1559z00_265;
{ /* ./Llib/mutex.scm 108 */
BgL_z52mutexz52_bglt BgL_obj1351z00_508;
{ /* ./Llib/mutex.scm 108 */
obj_t BgL_aux22025z00_661;
BgL_aux22025z00_661 = 
((obj_t)BgL_mz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22025z00_661, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 108 */
BgL_obj1351z00_508 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_13); }  else 
{ /* ./Llib/mutex.scm 108 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_13)); 
exit( -1 );} } 
BgL_arg1559z00_265 = 
(((BgL_z52mutexz52_bglt)CREF(BgL_obj1351z00_508))->BgL_z52ownedz52); } 
BgL_testz00_1072 = 
BGl_iszd2azf3z21zz__objectz00(BgL_arg1559z00_265, BGl_threadz00zz__ft_typesz00); } 
if(BgL_testz00_1072)
{ /* ./Llib/mutex.scm 108 */
bool_t BgL_testz00_1083;
{ /* ./Llib/mutex.scm 108 */
obj_t BgL_auxz00_1084;
{ /* ./Llib/mutex.scm 108 */
BgL_z52mutexz52_bglt BgL_obj1351z00_510;
{ /* ./Llib/mutex.scm 108 */
obj_t BgL_aux22035z00_664;
BgL_aux22035z00_664 = 
((obj_t)BgL_mz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22035z00_664, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 108 */
BgL_obj1351z00_510 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_13); }  else 
{ /* ./Llib/mutex.scm 108 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_13)); 
exit( -1 );} } 
BgL_auxz00_1084 = 
(((BgL_z52mutexz52_bglt)CREF(BgL_obj1351z00_510))->BgL_z52ownedz52); } 
BgL_testz00_1083 = 
(BgL_auxz00_1084==BgL_threadz00_248); } 
if(BgL_testz00_1083)
{ /* ./Llib/mutex.scm 108 */
BgL_testz00_1071 = ((bool_t)0)
; }  else 
{ /* ./Llib/mutex.scm 108 */
BgL_testz00_1071 = ((bool_t)1)
; } }  else 
{ /* ./Llib/mutex.scm 108 */
BgL_testz00_1071 = ((bool_t)0)
; } } 
if(BgL_testz00_1071)
{ /* ./Llib/mutex.scm 108 */
{ /* ./Llib/mutex.scm 110 */
obj_t BgL_arg1546z00_261;
{ /* ./Llib/mutex.scm 110 */
BgL_z52mutexz52_bglt BgL_obj1351z00_511;
{ /* ./Llib/mutex.scm 110 */
obj_t BgL_aux22045z00_667;
BgL_aux22045z00_667 = 
((obj_t)BgL_mz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22045z00_667, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 110 */
BgL_obj1351z00_511 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_13); }  else 
{ /* ./Llib/mutex.scm 110 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_13)); 
exit( -1 );} } 
BgL_arg1546z00_261 = 
(((BgL_z52mutexz52_bglt)CREF(BgL_obj1351z00_511))->BgL_z52ownedz52); } 
{ /* ./Llib/mutex.scm 110 */
BgL_threadz00_bglt BgL_auxz00_1104;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_arg1546z00_261, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/mutex.scm 110 */
BgL_auxz00_1104 = 
(BgL_threadz00_bglt)(BgL_arg1546z00_261)
; }  else 
{ /* ./Llib/mutex.scm 110 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2396z00zz__ft_mutexz00, BgL_arg1546z00_261); 
exit( -1 );} 
BGl_z52threadzd2delzd2mutexz12z40zz__ft_z52threadz52(BgL_auxz00_1104, BgL_mz00_13); } } 
{ /* ./Llib/mutex.scm 111 */
BgL_z52mutexz52_bglt BgL_obj1353z00_512;obj_t BgL_val1352z00_513;
{ /* ./Llib/mutex.scm 111 */
obj_t BgL_aux22063z00_672;
BgL_aux22063z00_672 = 
((obj_t)BgL_mz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22063z00_672, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 111 */
BgL_obj1353z00_512 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_13); }  else 
{ /* ./Llib/mutex.scm 111 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_13)); 
exit( -1 );} } 
BgL_val1352z00_513 = BgL_threadz00_248; 
((((BgL_z52mutexz52_bglt)CREF(BgL_obj1353z00_512))->BgL_z52ownedz52) = ((obj_t)BgL_val1352z00_513), BUNSPEC); } 
{ /* ./Llib/mutex.scm 112 */
BgL_threadz00_bglt BgL_auxz00_1121;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_threadz00_248, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/mutex.scm 112 */
BgL_auxz00_1121 = 
(BgL_threadz00_bglt)(BgL_threadz00_248)
; }  else 
{ /* ./Llib/mutex.scm 112 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2396z00zz__ft_mutexz00, BgL_threadz00_248); 
exit( -1 );} 
BGl_z52threadzd2addzd2mutexz12z40zz__ft_z52threadz52(BgL_auxz00_1121, BgL_mz00_13); } }  else 
{ /* ./Llib/mutex.scm 108 */BFALSE; } } 
{ /* ./Llib/mutex.scm 113 */
BgL_z52mutexz52_bglt BgL_obj1353z00_514;obj_t BgL_val1352z00_515;
{ /* ./Llib/mutex.scm 113 */
obj_t BgL_aux22082z00_677;
BgL_aux22082z00_677 = 
((obj_t)BgL_mz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22082z00_677, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 113 */
BgL_obj1353z00_514 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_13); }  else 
{ /* ./Llib/mutex.scm 113 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_13)); 
exit( -1 );} } 
BgL_val1352z00_515 = BgL_threadz00_248; 
((((BgL_z52mutexz52_bglt)CREF(BgL_obj1353z00_514))->BgL_z52ownedz52) = ((obj_t)BgL_val1352z00_515), BUNSPEC); } 
if(BgL_tozd2raisezd2_258)
{ /* ./Llib/mutex.scm 114 */
return 
BGl_raisez00zz__ft_exceptionz00(BGl_za2abandonedzd2mutexzd2exceptionza2z00zz__ft_z52exceptionz52);}  else 
{ /* ./Llib/mutex.scm 114 */
return BTRUE;} } } }  else 
{ /* ./Llib/mutex.scm 91 */
{ /* ./Llib/mutex.scm 92 */
BgL_z52mutexz52_bglt BgL_obj1356z00_516;bool_t BgL_val1355z00_517;
{ /* ./Llib/mutex.scm 92 */
obj_t BgL_aux22093z00_680;
BgL_aux22093z00_680 = 
((obj_t)BgL_mz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22093z00_680, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 92 */
BgL_obj1356z00_516 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_13); }  else 
{ /* ./Llib/mutex.scm 92 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_13)); 
exit( -1 );} } 
BgL_val1355z00_517 = ((bool_t)1); 
((((BgL_z52mutexz52_bglt)CREF(BgL_obj1356z00_516))->BgL_z52lockedz52) = ((bool_t)BgL_val1355z00_517), BUNSPEC); } 
{ /* ./Llib/mutex.scm 93 */
BgL_z52mutexz52_bglt BgL_obj1353z00_518;obj_t BgL_val1352z00_519;
{ /* ./Llib/mutex.scm 93 */
obj_t BgL_aux22103z00_683;
BgL_aux22103z00_683 = 
((obj_t)BgL_mz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22103z00_683, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 93 */
BgL_obj1353z00_518 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_13); }  else 
{ /* ./Llib/mutex.scm 93 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_13)); 
exit( -1 );} } 
BgL_val1352z00_519 = BFALSE; 
((((BgL_z52mutexz52_bglt)CREF(BgL_obj1353z00_518))->BgL_z52ownedz52) = ((obj_t)BgL_val1352z00_519), BUNSPEC); } 
return BTRUE;} } } } } } }  else 
{ 
obj_t BgL_threadz00_1159;obj_t BgL_timeoutz00_1158;
BgL_timeoutz00_1158 = BFALSE; 
BgL_threadz00_1159 = 
BGl_currentzd2threadzd2zz__ft_threadz00(); 
BgL_threadz00_248 = BgL_threadz00_1159; 
BgL_timeoutz00_247 = BgL_timeoutz00_1158; 
goto BgL_zc3anonymousza31519ze3z83_249;} }  else 
{ /* ./Llib/mutex.scm 117 */
bool_t BgL_testz00_1161;
{ /* ./Llib/mutex.scm 117 */
obj_t BgL_auxz00_1162;
{ /* ./Llib/mutex.scm 117 */
obj_t BgL_pairz00_455;
if(
PAIRP(BgL_argz00_14))
{ /* ./Llib/mutex.scm 117 */
BgL_pairz00_455 = BgL_argz00_14; }  else 
{ /* ./Llib/mutex.scm 117 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2391z00zz__ft_mutexz00, BgL_argz00_14); 
exit( -1 );} 
BgL_auxz00_1162 = 
CDR(BgL_pairz00_455); } 
BgL_testz00_1161 = 
NULLP(BgL_auxz00_1162); } 
if(BgL_testz00_1161)
{ /* ./Llib/mutex.scm 117 */
obj_t BgL_arg1484z00_237;
{ /* ./Llib/mutex.scm 117 */
obj_t BgL_pairz00_457;
if(
PAIRP(BgL_argz00_14))
{ /* ./Llib/mutex.scm 117 */
BgL_pairz00_457 = BgL_argz00_14; }  else 
{ /* ./Llib/mutex.scm 117 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2391z00zz__ft_mutexz00, BgL_argz00_14); 
exit( -1 );} 
BgL_arg1484z00_237 = 
CAR(BgL_pairz00_457); } 
BgL_timeoutz00_225 = BgL_arg1484z00_237; 
{ /* ./Llib/mutex.scm 127 */
bool_t BgL_testz00_1176;
if(
CBOOL(BgL_timeoutz00_225))
{ /* ./Llib/mutex.scm 127 */
bool_t BgL_testz00_1179;
if(
INTEGERP(BgL_timeoutz00_225))
{ /* ./Llib/mutex.scm 127 */
BgL_testz00_1179 = ((bool_t)1)
; }  else 
{ /* ./Llib/mutex.scm 127 */
if(
REALP(BgL_timeoutz00_225))
{ /* ./Llib/mutex.scm 127 */
BgL_testz00_1179 = ((bool_t)1)
; }  else 
{ /* ./Llib/mutex.scm 127 */
if(
ELONGP(BgL_timeoutz00_225))
{ /* ./Llib/mutex.scm 127 */
BgL_testz00_1179 = ((bool_t)1)
; }  else 
{ /* ./Llib/mutex.scm 127 */
BgL_testz00_1179 = 
LLONGP(BgL_timeoutz00_225)
; } } } 
if(BgL_testz00_1179)
{ /* ./Llib/mutex.scm 127 */
BgL_testz00_1176 = ((bool_t)0)
; }  else 
{ /* ./Llib/mutex.scm 127 */
BgL_testz00_1176 = ((bool_t)1)
; } }  else 
{ /* ./Llib/mutex.scm 127 */
BgL_testz00_1176 = ((bool_t)0)
; } 
if(BgL_testz00_1176)
{ /* ./Llib/mutex.scm 127 */
return 
BGl_bigloozd2typezd2errorz00zz__errorz00(BGl_string2397z00zz__ft_mutexz00, BGl_string2398z00zz__ft_mutexz00, BgL_timeoutz00_225);}  else 
{ 
obj_t BgL_threadz00_1189;obj_t BgL_timeoutz00_1188;
BgL_timeoutz00_1188 = BgL_timeoutz00_225; 
BgL_threadz00_1189 = 
BGl_currentzd2threadzd2zz__ft_threadz00(); 
BgL_threadz00_248 = BgL_threadz00_1189; 
BgL_timeoutz00_247 = BgL_timeoutz00_1188; 
goto BgL_zc3anonymousza31519ze3z83_249;} } }  else 
{ 
obj_t BgL_threadz00_1192;obj_t BgL_timeoutz00_1191;
BgL_timeoutz00_1191 = BFALSE; 
BgL_threadz00_1192 = 
BGl_currentzd2threadzd2zz__ft_threadz00(); 
BgL_threadz00_248 = BgL_threadz00_1192; 
BgL_timeoutz00_247 = BgL_timeoutz00_1191; 
goto BgL_zc3anonymousza31519ze3z83_249;} } }  else 
{ 
obj_t BgL_threadz00_1195;obj_t BgL_timeoutz00_1194;
BgL_timeoutz00_1194 = BFALSE; 
BgL_threadz00_1195 = 
BGl_currentzd2threadzd2zz__ft_threadz00(); 
BgL_threadz00_248 = BgL_threadz00_1195; 
BgL_timeoutz00_247 = BgL_timeoutz00_1194; 
goto BgL_zc3anonymousza31519ze3z83_249;} } } } 
}



/* _mutex-lock! */
obj_t BGl__mutexzd2lockz12zc0zz__ft_mutexz00(obj_t BgL_envz00_573, obj_t BgL_mz00_574, obj_t BgL_argz00_575)
{ AN_OBJECT;
{ /* ./Llib/mutex.scm 79 */
{ /* ./Llib/mutex.scm 116 */
BgL_mutexz00_bglt BgL_auxz00_1197;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_mz00_574, BGl_mutexz00zz__ft_typesz00))
{ /* ./Llib/mutex.scm 116 */
BgL_auxz00_1197 = 
(BgL_mutexz00_bglt)(BgL_mz00_574)
; }  else 
{ /* ./Llib/mutex.scm 116 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)10)), BGl_string2395z00zz__ft_mutexz00, BgL_mz00_574); 
exit( -1 );} 
return 
BGl_mutexzd2lockz12zc0zz__ft_mutexz00(BgL_auxz00_1197, BgL_argz00_575);} } 
}



/* mutex-unlock! */
BGL_EXPORTED_DEF obj_t BGl_mutexzd2unlockz12zc0zz__ft_mutexz00(BgL_mutexz00_bglt BgL_mz00_15, obj_t BgL_argz00_16)
{ AN_OBJECT;
{ /* ./Llib/mutex.scm 136 */
{ 
obj_t BgL_cvz00_291;obj_t BgL_timeoutz00_292;
{ 
obj_t BgL_cvz00_271;obj_t BgL_timeoutz00_272;
if(
PAIRP(BgL_argz00_16))
{ /* ./Llib/mutex.scm 154 */
obj_t BgL_cdrzd2137zd2_279;
{ /* ./Llib/mutex.scm 154 */
obj_t BgL_pairz00_521;
if(
PAIRP(BgL_argz00_16))
{ /* ./Llib/mutex.scm 154 */
BgL_pairz00_521 = BgL_argz00_16; }  else 
{ /* ./Llib/mutex.scm 154 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)11)), BGl_string2391z00zz__ft_mutexz00, BgL_argz00_16); 
exit( -1 );} 
BgL_cdrzd2137zd2_279 = 
CDR(BgL_pairz00_521); } 
if(
PAIRP(BgL_cdrzd2137zd2_279))
{ /* ./Llib/mutex.scm 154 */
bool_t BgL_testz00_1215;
{ /* ./Llib/mutex.scm 154 */
obj_t BgL_auxz00_1216;
{ /* ./Llib/mutex.scm 154 */
obj_t BgL_pairz00_523;
if(
PAIRP(BgL_cdrzd2137zd2_279))
{ /* ./Llib/mutex.scm 154 */
BgL_pairz00_523 = BgL_cdrzd2137zd2_279; }  else 
{ /* ./Llib/mutex.scm 154 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)11)), BGl_string2391z00zz__ft_mutexz00, BgL_cdrzd2137zd2_279); 
exit( -1 );} 
BgL_auxz00_1216 = 
CDR(BgL_pairz00_523); } 
BgL_testz00_1215 = 
NULLP(BgL_auxz00_1216); } 
if(BgL_testz00_1215)
{ /* ./Llib/mutex.scm 154 */
obj_t BgL_arg1576z00_282;obj_t BgL_arg1577z00_283;
{ /* ./Llib/mutex.scm 154 */
obj_t BgL_pairz00_525;
if(
PAIRP(BgL_argz00_16))
{ /* ./Llib/mutex.scm 154 */
BgL_pairz00_525 = BgL_argz00_16; }  else 
{ /* ./Llib/mutex.scm 154 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)11)), BGl_string2391z00zz__ft_mutexz00, BgL_argz00_16); 
exit( -1 );} 
BgL_arg1576z00_282 = 
CAR(BgL_pairz00_525); } 
{ /* ./Llib/mutex.scm 154 */
obj_t BgL_pairz00_526;
if(
PAIRP(BgL_cdrzd2137zd2_279))
{ /* ./Llib/mutex.scm 154 */
BgL_pairz00_526 = BgL_cdrzd2137zd2_279; }  else 
{ /* ./Llib/mutex.scm 154 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)11)), BGl_string2391z00zz__ft_mutexz00, BgL_cdrzd2137zd2_279); 
exit( -1 );} 
BgL_arg1577z00_283 = 
CAR(BgL_pairz00_526); } 
BgL_cvz00_271 = BgL_arg1576z00_282; 
BgL_timeoutz00_272 = BgL_arg1577z00_283; 
{ /* ./Llib/mutex.scm 157 */
bool_t BgL_testz00_1236;
if(
INTEGERP(BgL_timeoutz00_272))
{ /* ./Llib/mutex.scm 157 */
BgL_testz00_1236 = ((bool_t)1)
; }  else 
{ /* ./Llib/mutex.scm 157 */
if(
REALP(BgL_timeoutz00_272))
{ /* ./Llib/mutex.scm 157 */
BgL_testz00_1236 = ((bool_t)1)
; }  else 
{ /* ./Llib/mutex.scm 157 */
if(
ELONGP(BgL_timeoutz00_272))
{ /* ./Llib/mutex.scm 157 */
BgL_testz00_1236 = ((bool_t)1)
; }  else 
{ /* ./Llib/mutex.scm 157 */
BgL_testz00_1236 = 
LLONGP(BgL_timeoutz00_272)
; } } } 
if(BgL_testz00_1236)
{ /* ./Llib/mutex.scm 157 */
if(
BGl_iszd2azf3z21zz__objectz00(BgL_cvz00_271, BGl_conditionzd2variablezd2zz__ft_typesz00))
{ /* ./Llib/mutex.scm 159 */
BgL_cvz00_291 = BgL_cvz00_271; 
BgL_timeoutz00_292 = BgL_timeoutz00_272; 
BgL_zc3anonymousza31612ze3z83_293:
{ /* ./Llib/mutex.scm 139 */
bool_t BgL_testz00_1246;
{ /* ./Llib/mutex.scm 139 */
obj_t BgL_arg1620z00_297;
{ /* ./Llib/mutex.scm 139 */
BgL_z52mutexz52_bglt BgL_obj1351z00_545;
{ /* ./Llib/mutex.scm 139 */
obj_t BgL_aux22171z00_700;
BgL_aux22171z00_700 = 
((obj_t)BgL_mz00_15); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22171z00_700, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 139 */
BgL_obj1351z00_545 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_15); }  else 
{ /* ./Llib/mutex.scm 139 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)11)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_15)); 
exit( -1 );} } 
BgL_arg1620z00_297 = 
(((BgL_z52mutexz52_bglt)CREF(BgL_obj1351z00_545))->BgL_z52ownedz52); } 
BgL_testz00_1246 = 
BGl_iszd2azf3z21zz__objectz00(BgL_arg1620z00_297, BGl_threadz00zz__ft_typesz00); } 
if(BgL_testz00_1246)
{ /* ./Llib/mutex.scm 139 */
obj_t BgL_arg1615z00_296;
{ /* ./Llib/mutex.scm 139 */
BgL_z52mutexz52_bglt BgL_obj1351z00_547;
{ /* ./Llib/mutex.scm 139 */
obj_t BgL_aux22181z00_703;
BgL_aux22181z00_703 = 
((obj_t)BgL_mz00_15); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22181z00_703, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 139 */
BgL_obj1351z00_547 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_15); }  else 
{ /* ./Llib/mutex.scm 139 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)11)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_15)); 
exit( -1 );} } 
BgL_arg1615z00_296 = 
(((BgL_z52mutexz52_bglt)CREF(BgL_obj1351z00_547))->BgL_z52ownedz52); } 
{ /* ./Llib/mutex.scm 139 */
BgL_threadz00_bglt BgL_auxz00_1266;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_arg1615z00_296, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/mutex.scm 139 */
BgL_auxz00_1266 = 
(BgL_threadz00_bglt)(BgL_arg1615z00_296)
; }  else 
{ /* ./Llib/mutex.scm 139 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)11)), BGl_string2396z00zz__ft_mutexz00, BgL_arg1615z00_296); 
exit( -1 );} 
BGl_z52threadzd2delzd2mutexz12z40zz__ft_z52threadz52(BgL_auxz00_1266, BgL_mz00_15); } }  else 
{ /* ./Llib/mutex.scm 139 */BFALSE; } } 
{ /* ./Llib/mutex.scm 140 */
BgL_z52mutexz52_bglt BgL_obj1353z00_548;obj_t BgL_val1352z00_549;
{ /* ./Llib/mutex.scm 140 */
obj_t BgL_aux22200z00_708;
BgL_aux22200z00_708 = 
((obj_t)BgL_mz00_15); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22200z00_708, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 140 */
BgL_obj1353z00_548 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_15); }  else 
{ /* ./Llib/mutex.scm 140 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)11)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_15)); 
exit( -1 );} } 
BgL_val1352z00_549 = BFALSE; 
((((BgL_z52mutexz52_bglt)CREF(BgL_obj1353z00_548))->BgL_z52ownedz52) = ((obj_t)BgL_val1352z00_549), BUNSPEC); } 
{ /* ./Llib/mutex.scm 141 */
BgL_z52mutexz52_bglt BgL_obj1356z00_550;bool_t BgL_val1355z00_551;
{ /* ./Llib/mutex.scm 141 */
obj_t BgL_aux22211z00_711;
BgL_aux22211z00_711 = 
((obj_t)BgL_mz00_15); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22211z00_711, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 141 */
BgL_obj1356z00_550 = 
(BgL_z52mutexz52_bglt)(BgL_mz00_15); }  else 
{ /* ./Llib/mutex.scm 141 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)11)), BGl_string2394z00zz__ft_mutexz00, 
(obj_t)(BgL_mz00_15)); 
exit( -1 );} } 
BgL_val1355z00_551 = ((bool_t)0); 
((((BgL_z52mutexz52_bglt)CREF(BgL_obj1356z00_550))->BgL_z52lockedz52) = ((bool_t)BgL_val1355z00_551), BUNSPEC); } 
{ /* ./Llib/mutex.scm 142 */
obj_t BgL_arg1627z00_298;
BgL_arg1627z00_298 = 
(((BgL_mutexz00_bglt)CREF(BgL_mz00_15))->BgL_z52unlockzd2signalz80); 
BGl_broadcastz12z12zz__ft_schedulerz00(BgL_arg1627z00_298, BNIL); } 
{ /* ./Llib/mutex.scm 143 */
obj_t BgL_tz00_300;
BgL_tz00_300 = 
BGl_currentzd2threadzd2zz__ft_threadz00(); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_cvz00_291, BGl_conditionzd2variablezd2zz__ft_typesz00))
{ /* ./Llib/mutex.scm 144 */
if(
BGl_iszd2azf3z21zz__objectz00(BgL_tz00_300, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/mutex.scm 145 */
if(
CBOOL(BgL_timeoutz00_292))
{ /* ./Llib/mutex.scm 147 */
obj_t BgL_arg1634z00_303;
{ /* ./Llib/mutex.scm 147 */
obj_t BgL_list1637z00_304;
BgL_list1637z00_304 = 
MAKE_PAIR(BgL_timeoutz00_292, BNIL); 
BgL_arg1634z00_303 = 
BGl_threadzd2awaitz12zc0zz__ft_threadz00(BgL_cvz00_291, BgL_list1637z00_304); } 
return 
BBOOL(
PAIRP(BgL_arg1634z00_303));}  else 
{ /* ./Llib/mutex.scm 146 */
BGl_threadzd2awaitz12zc0zz__ft_threadz00(BgL_cvz00_291, BNIL); 
return BTRUE;} }  else 
{ /* ./Llib/mutex.scm 151 */
obj_t BgL_objectz00_558;
BgL_objectz00_558 = 
(obj_t)(BgL_mz00_15); 
FAILURE(BGl_string2400z00zz__ft_mutexz00,BGl_string2401z00zz__ft_mutexz00,BgL_objectz00_558);} }  else 
{ /* ./Llib/mutex.scm 144 */
if(
BGl_iszd2azf3z21zz__objectz00(BgL_tz00_300, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/mutex.scm 152 */
return 
BGl_threadzd2yieldz12zc0zz__ft_threadz00();}  else 
{ /* ./Llib/mutex.scm 152 */
return BFALSE;} } } }  else 
{ /* ./Llib/mutex.scm 159 */
return 
BGl_bigloozd2typezd2errorz00zz__errorz00(BGl_string2400z00zz__ft_mutexz00, BGl_string2402z00zz__ft_mutexz00, BgL_cvz00_271);} }  else 
{ /* ./Llib/mutex.scm 157 */
return 
BGl_bigloozd2typezd2errorz00zz__errorz00(BGl_string2400z00zz__ft_mutexz00, BGl_string2398z00zz__ft_mutexz00, BgL_timeoutz00_272);} } }  else 
{ 
obj_t BgL_timeoutz00_1314;obj_t BgL_cvz00_1313;
BgL_cvz00_1313 = BFALSE; 
BgL_timeoutz00_1314 = BFALSE; 
BgL_timeoutz00_292 = BgL_timeoutz00_1314; 
BgL_cvz00_291 = BgL_cvz00_1313; 
goto BgL_zc3anonymousza31612ze3z83_293;} }  else 
{ /* ./Llib/mutex.scm 154 */
bool_t BgL_testz00_1315;
{ /* ./Llib/mutex.scm 154 */
obj_t BgL_auxz00_1316;
{ /* ./Llib/mutex.scm 154 */
obj_t BgL_pairz00_527;
if(
PAIRP(BgL_argz00_16))
{ /* ./Llib/mutex.scm 154 */
BgL_pairz00_527 = BgL_argz00_16; }  else 
{ /* ./Llib/mutex.scm 154 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)11)), BGl_string2391z00zz__ft_mutexz00, BgL_argz00_16); 
exit( -1 );} 
BgL_auxz00_1316 = 
CDR(BgL_pairz00_527); } 
BgL_testz00_1315 = 
NULLP(BgL_auxz00_1316); } 
if(BgL_testz00_1315)
{ /* ./Llib/mutex.scm 154 */
obj_t BgL_arg1588z00_286;
{ /* ./Llib/mutex.scm 154 */
obj_t BgL_pairz00_529;
if(
PAIRP(BgL_argz00_16))
{ /* ./Llib/mutex.scm 154 */
BgL_pairz00_529 = BgL_argz00_16; }  else 
{ /* ./Llib/mutex.scm 154 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)11)), BGl_string2391z00zz__ft_mutexz00, BgL_argz00_16); 
exit( -1 );} 
BgL_arg1588z00_286 = 
CAR(BgL_pairz00_529); } 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_arg1588z00_286, BGl_conditionzd2variablezd2zz__ft_typesz00))
{ 
obj_t BgL_timeoutz00_1333;obj_t BgL_cvz00_1332;
BgL_cvz00_1332 = BgL_arg1588z00_286; 
BgL_timeoutz00_1333 = BFALSE; 
BgL_timeoutz00_292 = BgL_timeoutz00_1333; 
BgL_cvz00_291 = BgL_cvz00_1332; 
goto BgL_zc3anonymousza31612ze3z83_293;}  else 
{ /* ./Llib/mutex.scm 154 */
return 
BGl_bigloozd2typezd2errorz00zz__errorz00(BGl_string2400z00zz__ft_mutexz00, BGl_string2402z00zz__ft_mutexz00, BgL_arg1588z00_286);} }  else 
{ 
obj_t BgL_timeoutz00_1336;obj_t BgL_cvz00_1335;
BgL_cvz00_1335 = BFALSE; 
BgL_timeoutz00_1336 = BFALSE; 
BgL_timeoutz00_292 = BgL_timeoutz00_1336; 
BgL_cvz00_291 = BgL_cvz00_1335; 
goto BgL_zc3anonymousza31612ze3z83_293;} } }  else 
{ 
obj_t BgL_timeoutz00_1338;obj_t BgL_cvz00_1337;
BgL_cvz00_1337 = BFALSE; 
BgL_timeoutz00_1338 = BFALSE; 
BgL_timeoutz00_292 = BgL_timeoutz00_1338; 
BgL_cvz00_291 = BgL_cvz00_1337; 
goto BgL_zc3anonymousza31612ze3z83_293;} } } } 
}



/* _mutex-unlock! */
obj_t BGl__mutexzd2unlockz12zc0zz__ft_mutexz00(obj_t BgL_envz00_576, obj_t BgL_mz00_577, obj_t BgL_argz00_578)
{ AN_OBJECT;
{ /* ./Llib/mutex.scm 136 */
{ /* ./Llib/mutex.scm 153 */
BgL_mutexz00_bglt BgL_auxz00_1339;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_mz00_577, BGl_mutexz00zz__ft_typesz00))
{ /* ./Llib/mutex.scm 153 */
BgL_auxz00_1339 = 
(BgL_mutexz00_bglt)(BgL_mz00_577)
; }  else 
{ /* ./Llib/mutex.scm 153 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)12)), BGl_string2395z00zz__ft_mutexz00, BgL_mz00_577); 
exit( -1 );} 
return 
BGl_mutexzd2unlockz12zc0zz__ft_mutexz00(BgL_auxz00_1339, BgL_argz00_578);} } 
}



/* method-init */
obj_t BGl_methodzd2initzd2zz__ft_mutexz00()
{ AN_OBJECT;
{ /* ./Llib/mutex.scm 15 */
BGl_addzd2methodz12zc0zz__objectz00(BGl_objectzd2displayzd2envz00zz__objectz00, BGl_mutexz00zz__ft_typesz00, BGl_proc2403z00zz__ft_mutexz00); 
BGl_addzd2methodz12zc0zz__objectz00(BGl_objectzd2writezd2envz00zz__objectz00, BGl_mutexz00zz__ft_typesz00, BGl_proc2404z00zz__ft_mutexz00); 
return 
BGl_addzd2methodz12zc0zz__objectz00(BGl_objectzd2printzd2envz00zz__objectz00, BGl_mutexz00zz__ft_typesz00, BGl_proc2405z00zz__ft_mutexz00);} 
}



/* object-print-mutex1434 */
obj_t BGl_objectzd2printzd2mutex1434z00zz__ft_mutexz00(obj_t BgL_envz00_584, obj_t BgL_oz00_585, obj_t BgL_portz00_586, obj_t BgL_printzd2slotzd2_587)
{ AN_OBJECT;
{ /* ./Llib/mutex.scm 63 */
{ 
BgL_mutexz00_bglt BgL_oz00_420;obj_t BgL_portz00_421;obj_t BgL_printzd2slotzd2_422;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_oz00_585, BGl_mutexz00zz__ft_typesz00))
{ /* ./Llib/mutex.scm 64 */
BgL_oz00_420 = 
(BgL_mutexz00_bglt)(BgL_oz00_585); }  else 
{ /* ./Llib/mutex.scm 64 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)13)), BGl_string2395z00zz__ft_mutexz00, BgL_oz00_585); 
exit( -1 );} 
BgL_portz00_421 = BgL_portz00_586; 
BgL_printzd2slotzd2_422 = BgL_printzd2slotzd2_587; 
{ /* ./Llib/mutex.scm 64 */
obj_t BgL_list1790z00_568;
BgL_list1790z00_568 = 
MAKE_PAIR(BgL_portz00_421, BNIL); 
return 
BGl_objectzd2writezd2zz__objectz00(
(BgL_objectz00_bglt)(BgL_oz00_420), BgL_list1790z00_568);} } } 
}



/* object-write-mutex1432 */
obj_t BGl_objectzd2writezd2mutex1432z00zz__ft_mutexz00(obj_t BgL_envz00_588, obj_t BgL_oz00_589, obj_t BgL_portz00_590)
{ AN_OBJECT;
{ /* ./Llib/mutex.scm 51 */
{ 
BgL_mutexz00_bglt BgL_oz00_390;obj_t BgL_portz00_391;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_oz00_589, BGl_mutexz00zz__ft_typesz00))
{ /* ./Llib/mutex.scm 52 */
BgL_oz00_390 = 
(BgL_mutexz00_bglt)(BgL_oz00_589); }  else 
{ /* ./Llib/mutex.scm 52 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)14)), BGl_string2395z00zz__ft_mutexz00, BgL_oz00_589); 
exit( -1 );} 
BgL_portz00_391 = BgL_portz00_590; 
{ /* ./Llib/mutex.scm 52 */
obj_t BgL_arg1736z00_394;
if(
PAIRP(BgL_portz00_391))
{ /* ./Llib/mutex.scm 52 */
obj_t BgL_pairz00_564;
if(
PAIRP(BgL_portz00_391))
{ /* ./Llib/mutex.scm 52 */
BgL_pairz00_564 = BgL_portz00_391; }  else 
{ /* ./Llib/mutex.scm 52 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)14)), BGl_string2391z00zz__ft_mutexz00, BgL_portz00_391); 
exit( -1 );} 
BgL_arg1736z00_394 = 
CAR(BgL_pairz00_564); }  else 
{ /* ./Llib/mutex.scm 52 */
BgL_arg1736z00_394 = 
BGL_CURRENT_OUTPUT_PORT(); } 
{ /* ./Llib/mutex.scm 54 */
obj_t BgL_zc3anonymousza31743ze3z83_580;
BgL_zc3anonymousza31743ze3z83_580 = 
make_fx_procedure(BGl_zc3anonymousza31743ze3z83zz__ft_mutexz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza31743ze3z83_580, 
(int)(((long)0)), 
(obj_t)(BgL_oz00_390)); 
{ /* ./Llib/mutex.scm 52 */
obj_t BgL_auxz00_1374;
if(
OUTPUT_PORTP(BgL_arg1736z00_394))
{ /* ./Llib/mutex.scm 52 */
BgL_auxz00_1374 = BgL_arg1736z00_394
; }  else 
{ /* ./Llib/mutex.scm 52 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)14)), BGl_string2406z00zz__ft_mutexz00, BgL_arg1736z00_394); 
exit( -1 );} 
return 
BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(BgL_auxz00_1374, BgL_zc3anonymousza31743ze3z83_580);} } } } } 
}



/* <anonymous:1743> */
obj_t BGl_zc3anonymousza31743ze3z83zz__ft_mutexz00(obj_t BgL_envz00_591)
{ AN_OBJECT;
{ /* ./Llib/mutex.scm 53 */
{ /* ./Llib/mutex.scm 54 */
obj_t BgL_oz00_592;
BgL_oz00_592 = 
PROCEDURE_REF(BgL_envz00_591, 
(int)(((long)0))); 
{ 

{ /* ./Llib/mutex.scm 55 */
obj_t BgL_arg1746z00_400;obj_t BgL_arg1748z00_402;obj_t BgL_arg1749z00_403;
{ /* ./Llib/mutex.scm 55 */
BgL_mutexz00_bglt BgL_obj1110z00_565;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_oz00_592, BGl_mutexz00zz__ft_typesz00))
{ /* ./Llib/mutex.scm 55 */
BgL_obj1110z00_565 = 
(BgL_mutexz00_bglt)(BgL_oz00_592); }  else 
{ /* ./Llib/mutex.scm 55 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)15)), BGl_string2395z00zz__ft_mutexz00, BgL_oz00_592); 
exit( -1 );} 
BgL_arg1746z00_400 = 
(((BgL_mutexz00_bglt)CREF(BgL_obj1110z00_565))->BgL_namez00); } 
{ /* ./Llib/mutex.scm 56 */
bool_t BgL_testz00_1396;
{ /* ./Llib/mutex.scm 56 */
BgL_z52mutexz52_bglt BgL_obj1348z00_566;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_oz00_592, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 56 */
BgL_obj1348z00_566 = 
(BgL_z52mutexz52_bglt)(BgL_oz00_592); }  else 
{ /* ./Llib/mutex.scm 56 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)15)), BGl_string2394z00zz__ft_mutexz00, BgL_oz00_592); 
exit( -1 );} 
BgL_testz00_1396 = 
(((BgL_z52mutexz52_bglt)CREF(BgL_obj1348z00_566))->BgL_z52abandonedz52); } 
if(BgL_testz00_1396)
{ /* ./Llib/mutex.scm 56 */
BgL_arg1748z00_402 = BGl_string2407z00zz__ft_mutexz00; }  else 
{ /* ./Llib/mutex.scm 56 */
BgL_arg1748z00_402 = BGl_string2408z00zz__ft_mutexz00; } } 
{ /* ./Llib/mutex.scm 57 */
bool_t BgL_testz00_1404;
{ /* ./Llib/mutex.scm 57 */
BgL_z52mutexz52_bglt BgL_obj1354z00_567;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_oz00_592, BGl_z52mutexz52zz__ft_z52typesz52))
{ /* ./Llib/mutex.scm 57 */
BgL_obj1354z00_567 = 
(BgL_z52mutexz52_bglt)(BgL_oz00_592); }  else 
{ /* ./Llib/mutex.scm 57 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)15)), BGl_string2394z00zz__ft_mutexz00, BgL_oz00_592); 
exit( -1 );} 
BgL_testz00_1404 = 
(((BgL_z52mutexz52_bglt)CREF(BgL_obj1354z00_567))->BgL_z52lockedz52); } 
if(BgL_testz00_1404)
{ /* ./Llib/mutex.scm 57 */
BgL_arg1749z00_403 = BGl_string2409z00zz__ft_mutexz00; }  else 
{ /* ./Llib/mutex.scm 57 */
BgL_arg1749z00_403 = BGl_string2410z00zz__ft_mutexz00; } } 
{ /* ./Llib/mutex.scm 55 */
obj_t BgL_list1752z00_405;
{ /* ./Llib/mutex.scm 55 */
obj_t BgL_arg1754z00_406;
{ /* ./Llib/mutex.scm 55 */
obj_t BgL_arg1757z00_407;
{ /* ./Llib/mutex.scm 55 */
obj_t BgL_arg1760z00_408;
{ /* ./Llib/mutex.scm 55 */
obj_t BgL_arg1763z00_409;
{ /* ./Llib/mutex.scm 55 */
obj_t BgL_arg1766z00_410;
BgL_arg1766z00_410 = 
MAKE_PAIR(BGl_string2411z00zz__ft_mutexz00, BNIL); 
BgL_arg1763z00_409 = 
MAKE_PAIR(BgL_arg1749z00_403, BgL_arg1766z00_410); } 
BgL_arg1760z00_408 = 
MAKE_PAIR(BgL_arg1748z00_402, BgL_arg1763z00_409); } 
BgL_arg1757z00_407 = 
MAKE_PAIR(BGl_string2412z00zz__ft_mutexz00, BgL_arg1760z00_408); } 
BgL_arg1754z00_406 = 
MAKE_PAIR(BgL_arg1746z00_400, BgL_arg1757z00_407); } 
BgL_list1752z00_405 = 
MAKE_PAIR(BGl_string2413z00zz__ft_mutexz00, BgL_arg1754z00_406); } 
return 
BGl_displayza2za2zz__r4_output_6_10_3z00(BgL_list1752z00_405);} } } } } 
}



/* object-display-mutex1430 */
obj_t BGl_objectzd2displayzd2mutex1430z00zz__ft_mutexz00(obj_t BgL_envz00_593, obj_t BgL_oz00_594, obj_t BgL_portz00_595)
{ AN_OBJECT;
{ /* ./Llib/mutex.scm 42 */
{ 
BgL_mutexz00_bglt BgL_oz00_368;obj_t BgL_portz00_369;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_oz00_594, BGl_mutexz00zz__ft_typesz00))
{ /* ./Llib/mutex.scm 43 */
BgL_oz00_368 = 
(BgL_mutexz00_bglt)(BgL_oz00_594); }  else 
{ /* ./Llib/mutex.scm 43 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)16)), BGl_string2395z00zz__ft_mutexz00, BgL_oz00_594); 
exit( -1 );} 
BgL_portz00_369 = BgL_portz00_595; 
{ /* ./Llib/mutex.scm 43 */
obj_t BgL_arg1698z00_372;
if(
PAIRP(BgL_portz00_369))
{ /* ./Llib/mutex.scm 43 */
obj_t BgL_pairz00_561;
if(
PAIRP(BgL_portz00_369))
{ /* ./Llib/mutex.scm 43 */
BgL_pairz00_561 = BgL_portz00_369; }  else 
{ /* ./Llib/mutex.scm 43 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)16)), BGl_string2391z00zz__ft_mutexz00, BgL_portz00_369); 
exit( -1 );} 
BgL_arg1698z00_372 = 
CAR(BgL_pairz00_561); }  else 
{ /* ./Llib/mutex.scm 43 */
BgL_arg1698z00_372 = 
BGL_CURRENT_OUTPUT_PORT(); } 
{ /* ./Llib/mutex.scm 45 */
obj_t BgL_zc3anonymousza31705ze3z83_582;
BgL_zc3anonymousza31705ze3z83_582 = 
make_fx_procedure(BGl_zc3anonymousza31705ze3z83zz__ft_mutexz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza31705ze3z83_582, 
(int)(((long)0)), 
(obj_t)(BgL_oz00_368)); 
{ /* ./Llib/mutex.scm 43 */
obj_t BgL_auxz00_1434;
if(
OUTPUT_PORTP(BgL_arg1698z00_372))
{ /* ./Llib/mutex.scm 43 */
BgL_auxz00_1434 = BgL_arg1698z00_372
; }  else 
{ /* ./Llib/mutex.scm 43 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)16)), BGl_string2406z00zz__ft_mutexz00, BgL_arg1698z00_372); 
exit( -1 );} 
return 
BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(BgL_auxz00_1434, BgL_zc3anonymousza31705ze3z83_582);} } } } } 
}



/* <anonymous:1705> */
obj_t BGl_zc3anonymousza31705ze3z83zz__ft_mutexz00(obj_t BgL_envz00_596)
{ AN_OBJECT;
{ /* ./Llib/mutex.scm 44 */
{ /* ./Llib/mutex.scm 45 */
obj_t BgL_oz00_597;
BgL_oz00_597 = 
PROCEDURE_REF(BgL_envz00_596, 
(int)(((long)0))); 
{ 

{ /* ./Llib/mutex.scm 46 */
obj_t BgL_arg1709z00_378;
{ /* ./Llib/mutex.scm 46 */
BgL_mutexz00_bglt BgL_obj1110z00_562;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_oz00_597, BGl_mutexz00zz__ft_typesz00))
{ /* ./Llib/mutex.scm 46 */
BgL_obj1110z00_562 = 
(BgL_mutexz00_bglt)(BgL_oz00_597); }  else 
{ /* ./Llib/mutex.scm 46 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)17)), BGl_string2395z00zz__ft_mutexz00, BgL_oz00_597); 
exit( -1 );} 
BgL_arg1709z00_378 = 
(((BgL_mutexz00_bglt)CREF(BgL_obj1110z00_562))->BgL_namez00); } 
{ /* ./Llib/mutex.scm 46 */
obj_t BgL_list1712z00_380;
{ /* ./Llib/mutex.scm 46 */
obj_t BgL_arg1714z00_381;
{ /* ./Llib/mutex.scm 46 */
obj_t BgL_arg1717z00_382;
BgL_arg1717z00_382 = 
MAKE_PAIR(BGl_string2411z00zz__ft_mutexz00, BNIL); 
BgL_arg1714z00_381 = 
MAKE_PAIR(BgL_arg1709z00_378, BgL_arg1717z00_382); } 
BgL_list1712z00_380 = 
MAKE_PAIR(BGl_string2413z00zz__ft_mutexz00, BgL_arg1714z00_381); } 
return 
BGl_displayza2za2zz__r4_output_6_10_3z00(BgL_list1712z00_380);} } } } } 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__ft_mutexz00()
{ AN_OBJECT;
{ /* ./Llib/mutex.scm 15 */
BGl_modulezd2initializa7ationz75zz__ft_typesz00(((long)55409), 
BSTRING_TO_STRING(BGl_string2414z00zz__ft_mutexz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(((long)35069), 
BSTRING_TO_STRING(BGl_string2414z00zz__ft_mutexz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(((long)38854), 
BSTRING_TO_STRING(BGl_string2414z00zz__ft_mutexz00)); 
BGl_modulezd2initializa7ationz75zz__ft_threadz00(((long)18657), 
BSTRING_TO_STRING(BGl_string2414z00zz__ft_mutexz00)); 
BGl_modulezd2initializa7ationz75zz__ft_exceptionz00(((long)35632), 
BSTRING_TO_STRING(BGl_string2414z00zz__ft_mutexz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52exceptionz52(((long)38532), 
BSTRING_TO_STRING(BGl_string2414z00zz__ft_mutexz00)); 
BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(((long)58241), 
BSTRING_TO_STRING(BGl_string2414z00zz__ft_mutexz00)); 
return 
BGl_modulezd2initializa7ationz75zz__ft_signalz00(((long)5725), 
BSTRING_TO_STRING(BGl_string2414z00zz__ft_mutexz00));} 
}

