/*===========================================================================*/
/*   (Llib/scheduler.scm)                                                    */
/*   Bigloo (2.6f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Dec 20 10:51:01 CET 2004        */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo2.6f/bin/bigloo -rm -O3 -I Llib -copt -fPIC -copt -I Posix Llib/scheduler.scm -o objs/scheduler.o -c)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <bglthread.h>


/* Object type definitions */
typedef struct BgL_threadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52mutexesz52;
   obj_t BgL_z52exczd2handlersz80;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_namez00;
   obj_t BgL_specificz00;
   obj_t BgL_schedulerz00;
   obj_t BgL_cleanupz00;
} *BgL_threadz00_bglt;

typedef struct BgL_schedulerz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52mutexesz52;
   obj_t BgL_z52exczd2handlersz80;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_namez00;
   obj_t BgL_specificz00;
   obj_t BgL_schedulerz00;
   obj_t BgL_cleanupz00;
   obj_t BgL_envzb2zb2;
} *BgL_schedulerz00_bglt;

typedef struct BgL_ftenvz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_instantz00;
} *BgL_ftenvz00_bglt;

typedef struct BgL_mutexz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_specificz00;
   obj_t BgL_z52unlockzd2signalz80;
} *BgL_mutexz00_bglt;

typedef struct BgL_conditionzd2variablezd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_specificz00;
} *BgL_conditionzd2variablezd2_bglt;

typedef struct BgL_z52schedulerz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52mutexesz52;
   obj_t BgL_z52exczd2handlersz80;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_namez00;
   obj_t BgL_specificz00;
   obj_t BgL_schedulerz00;
   obj_t BgL_cleanupz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_nextzd2instantzd2;
   obj_t BgL_currentzd2threadzd2;
   int BgL_z52livezd2threadzd2numberz52;
   bool_t BgL_z52threadszd2readyz80;
   obj_t BgL_threadszd2runnablezd2;
   obj_t BgL_asynczd2runnablezd2;
   obj_t BgL_threadszd2timeoutzd2;
   obj_t BgL_threadszd2yieldzd2;
   obj_t BgL_tostartz00;
   obj_t BgL_toterminatez00;
   obj_t BgL_tosuspendzf2resumezf2;
   obj_t BgL_tobroadcastz00;
   obj_t BgL_tospawnz00;
} *BgL_z52schedulerz52_bglt;

typedef struct BgL_z52sigasyncz52_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_spawnedz00;
   obj_t BgL_idz00;
   obj_t BgL_thunkz00;
} *BgL_z52sigasyncz52_bglt;

typedef struct BgL_z52conditionzd2variablez80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_specificz00;
} *BgL_z52conditionzd2variablez80_bglt;

typedef struct BgL_z52mutexz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_specificz00;
   obj_t BgL_z52unlockzd2signalz80;
   bool_t BgL_z52abandonedz52;
   obj_t BgL_z52ownedz52;
   bool_t BgL_z52lockedz52;
} *BgL_z52mutexz52_bglt;

typedef struct BgL_z52uncaughtzd2exceptionz80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_reasonz00;
} *BgL_z52uncaughtzd2exceptionz80_bglt;

typedef struct BgL_z52envz52_bgl {
   header_t header;
   obj_t widening;
   long BgL_instantz00;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52lastzd2signalsz80;
} *BgL_z52envz52_bglt;

typedef struct BgL_z52signalz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_valsz00;
   int BgL_stampz00;
   obj_t BgL_threadsz00;
} *BgL_z52signalz52_bglt;


static obj_t BGl_zc3anonymousza31568ze3z83zz__ft_schedulerz00(obj_t);
static obj_t BGl_methodzd2initzd2zz__ft_schedulerz00();
BGL_EXPORTED_DECL obj_t BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(obj_t);
static obj_t BGl_zc3anonymousza31717ze3z83zz__ft_schedulerz00(obj_t, obj_t);
BGL_IMPORT obj_t open_input_string(obj_t);
extern obj_t BGl_z52schedulerzd2timez80zz__ft_z52schedulerz52(BgL_schedulerz00_bglt);
static obj_t BGl_zc3anonymousza31719ze3z83zz__ft_schedulerz00(obj_t, obj_t);
static obj_t BGl__schedulerzd2instantzd2zz__ft_schedulerz00(obj_t, obj_t);
static obj_t BGl_zc3anonymousza31576ze3z83zz__ft_schedulerz00(obj_t, obj_t);
static obj_t BGl__withzd2schedulerzd2zz__ft_schedulerz00(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t);
BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_withzd2schedulerzd2zz__ft_schedulerz00(BgL_schedulerz00_bglt, obj_t);
BGL_EXPORTED_DECL obj_t BGl_schedulerzd2broadcastz12zc0zz__ft_schedulerz00(BgL_schedulerz00_bglt, obj_t, obj_t);
static obj_t BGl_zc3anonymousza31733ze3z83zz__ft_schedulerz00(obj_t, obj_t);
extern obj_t BGl_z52schedulerzd2waitingzd2threadsz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
static obj_t BGl_zc3anonymousza31588ze3z83zz__ft_schedulerz00(obj_t, obj_t, obj_t);
static obj_t BGl_schedulez00zz__ft_schedulerz00(BgL_z52schedulerz52_bglt);
extern obj_t BGl_z52broadcastz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, obj_t, obj_t);
extern obj_t BGl_ftenvz00zz__ft_typesz00;
BGL_EXPORTED_DECL obj_t BGl_broadcastz12z12zz__ft_schedulerz00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_gensymz00zz__r4_symbols_6_4z00;
extern BgL_z52envz52_bglt BGl_makezd2z52envz80zz__ft_z52envz52(long, obj_t, obj_t);
BGL_IMPORT obj_t BGl_modulezd2initzd2errorz00zz__errorz00(char *, char *);
BGL_EXPORTED_DECL obj_t BGl_schedulerzd2terminatez12zc0zz__ft_schedulerz00(obj_t);
BGL_EXPORTED_DECL int BGl_schedulerzd2instantzd2zz__ft_schedulerz00(obj_t);
static obj_t BGl_cnstzd2initzd2zz__ft_schedulerz00();
BGL_EXPORTED_DECL BgL_schedulerz00_bglt BGl_makezd2schedulerzd2zz__ft_schedulerz00(obj_t);
static obj_t BGl_za2currentzd2schedulerza2zd2zz__ft_schedulerz00 = BUNSPEC;
static obj_t BGl_importedzd2moduleszd2initz00zz__ft_schedulerz00();
BGL_EXPORTED_DECL obj_t BGl_schedulerzd2startz12zc0zz__ft_schedulerz00(obj_t);
BGL_IMPORT long BGl_bitzd2andzd2zz__bitz00(long, long);
extern obj_t BGl_z52schedulerz52zz__ft_z52typesz52;
extern bool_t BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_threadz00_bglt, obj_t);
extern obj_t BGl_z52schedulerzd2addzd2broadcastz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, obj_t, obj_t);
BGL_IMPORT obj_t BGl_valzd2fromzd2exitzf3zf3zz__bexitz00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_schedulerzd2reactz12zc0zz__ft_schedulerz00(obj_t);
static obj_t BGl_zc3anonymousza31635ze3z83zz__ft_schedulerz00(obj_t, obj_t, obj_t);
static obj_t BGl_toplevelzd2initzd2zz__ft_schedulerz00();
BGL_IMPORT obj_t BGl_2zb2zb2zz__r4_numbers_6_5z00(obj_t, obj_t);
extern obj_t BGl_currentzd2threadzd2zz__ft_threadz00();
static obj_t BGl__makezd2schedulerzd2zz__ft_schedulerz00(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_debugz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_typesz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52envz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_threadz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_signalz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__bexitz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(long, char *);
extern BgL_z52schedulerz52_bglt BGl_makezd2z52schedulerz80zz__ft_z52typesz52(obj_t, int, obj_t, bool_t, obj_t, obj_t, obj_t, bool_t, int, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, int, bool_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t, obj_t);
extern obj_t BGl_threadzd2terminatez12zc0zz__ft_threadz00(BgL_threadz00_bglt);
BGL_IMPORT bool_t BGl_2ze3zd3z30zz__r4_numbers_6_5z00(obj_t, obj_t);
extern bool_t BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(BgL_threadz00_bglt);
static obj_t BGl_za2defaultzd2schedulerza2zd2zz__ft_schedulerz00 = BUNSPEC;
extern obj_t BGl_threadz00zz__ft_typesz00;
static obj_t BGl_schedulerzd2statezd2zz__ft_schedulerz00(BgL_schedulerz00_bglt);
static obj_t BGl_zc3exitza31510ze3z83zz__ft_schedulerz00(obj_t, BgL_schedulerz00_bglt);
BGL_IMPORT obj_t BGl_unwindzd2untilz12zc0zz__bexitz00(obj_t, obj_t);
static obj_t BGl__schedulerzd2terminatez12zc0zz__ft_schedulerz00(obj_t, obj_t);
extern obj_t BGl_schedulerz00zz__ft_typesz00;
extern obj_t BGl_z52schedulezd2instantz80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
static obj_t BGl_busyzd2waitingzd2nextzd2instantzd2zz__ft_schedulerz00(obj_t, obj_t, obj_t);
static obj_t BGl__defaultzd2schedulerzd2zz__ft_schedulerz00(obj_t, obj_t);
extern obj_t BGl_z52threadzd2setupz12z92zz__ft_z52threadz52(BgL_threadz00_bglt);
static obj_t BGl__currentzd2schedulerzd2zz__ft_schedulerz00(obj_t);
extern BgL_schedulerz00_bglt BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(obj_t, obj_t);
BGL_IMPORT bool_t BGl_zd3fxzd3zz__r4_numbers_6_5_fixnumz00(long, long);
BGL_IMPORT obj_t bgl_append2(obj_t, obj_t);
static obj_t BGl__schedulerzd2startz12zc0zz__ft_schedulerz00(obj_t, obj_t);
static obj_t BGl_nozd2busyzd2waitingzd2nextzd2instantz00zz__ft_schedulerz00(obj_t, obj_t, obj_t);
static obj_t BGl__broadcastz12z12zz__ft_schedulerz00(obj_t, obj_t, obj_t);
static obj_t BGl_requirezd2initializa7ationz75zz__ft_schedulerz00 = BUNSPEC;
static obj_t BGl__schedulerzd2reactz12zc0zz__ft_schedulerz00(obj_t, obj_t);
static obj_t BGl__schedulerzd2broadcastz12zc0zz__ft_schedulerz00(obj_t, obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_bigloozd2typezd2errorz00zz__errorz00(obj_t, obj_t, obj_t);
BGL_IMPORT bool_t BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(obj_t, obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zz__ft_schedulerz00();
BGL_EXPORTED_DECL obj_t BGl_currentzd2schedulerzd2zz__ft_schedulerz00();
static obj_t __cnst[ 30 ] ;


BGL_IMPORT obj_t BGl_listzd2envzd2zz__r4_pairs_and_lists_6_3z00;
DEFINE_EXPORT_PROCEDURE( BGl_schedulerzd2terminatez12zd2envz12zz__ft_schedulerz00, BgL_bgl__schedulerza7d2terminateza712za7c0za7za7__ft_schedulerza7003054z00, va_generic_entry, BGl__schedulerzd2terminatez12zc0zz__ft_schedulerz00, -1 );
DEFINE_EXPORT_PROCEDURE( BGl_schedulerzd2startz12zd2envz12zz__ft_schedulerz00, BgL_bgl__schedulerza7d2startza712za7c0za7za7__ft_schedulerza7003055z00, va_generic_entry, BGl__schedulerzd2startz12zc0zz__ft_schedulerz00, -1 );
DEFINE_EXPORT_PROCEDURE( BGl_schedulerzd2broadcastz12zd2envz12zz__ft_schedulerz00, BgL_bgl__schedulerza7d2broadcastza712za7c0za7za7__ft_schedulerza7003056z00, va_generic_entry, BGl__schedulerzd2broadcastz12zc0zz__ft_schedulerz00, -3 );
DEFINE_EXPORT_PROCEDURE( BGl_currentzd2schedulerzd2envz00zz__ft_schedulerz00, BgL_bgl__currentza7d2schedulerza7d2za7za7__ft_schedulerza7003057za7, BGl__currentzd2schedulerzd2zz__ft_schedulerz00, 0L, 0 );
DEFINE_STATIC_PROCEDURE( BGl_proc2989z00zz__ft_schedulerz00, BgL_bgl_za7c3anonymousza7a31576za7e3za783za7za7__ft_schedulerza7003058za7, BGl_zc3anonymousza31576ze3z83zz__ft_schedulerz00, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc2991z00zz__ft_schedulerz00, BgL_bgl_za7c3anonymousza7a31588za7e3za783za7za7__ft_schedulerza7003059za7, BGl_zc3anonymousza31588ze3z83zz__ft_schedulerz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc2996z00zz__ft_schedulerz00, BgL_bgl_za7c3anonymousza7a31635za7e3za783za7za7__ft_schedulerza7003060za7, BGl_zc3anonymousza31635ze3z83zz__ft_schedulerz00, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc2997z00zz__ft_schedulerz00, BgL_bgl_za7c3anonymousza7a31717za7e3za783za7za7__ft_schedulerza7003061za7, BGl_zc3anonymousza31717ze3z83zz__ft_schedulerz00, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl_makezd2schedulerzd2envz00zz__ft_schedulerz00, BgL_bgl__makeza7d2schedulerza7d2za7za7__ft_schedulerza7003062za7, va_generic_entry, BGl__makezd2schedulerzd2zz__ft_schedulerz00, -1 );
DEFINE_STRING( BGl_string2999z00zz__ft_schedulerz00, BgL_bgl_string2999za700za7za7__ft_schedulerza7003063z00, "Illegal optional parameter", 26 );
DEFINE_STRING( BGl_string2998z00zz__ft_schedulerz00, BgL_bgl_string2998za700za7za7__ft_schedulerza7003064z00, "scheduler-start!", 16 );
DEFINE_STRING( BGl_string2995z00zz__ft_schedulerz00, BgL_bgl_string2995za700za7za7__ft_schedulerza7003065z00, "schedule:Wrong number of arguments", 34 );
DEFINE_STRING( BGl_string2994z00zz__ft_schedulerz00, BgL_bgl_string2994za700za7za7__ft_schedulerza7003066z00, "%scheduler", 10 );
DEFINE_STRING( BGl_string2993z00zz__ft_schedulerz00, BgL_bgl_string2993za700za7za7__ft_schedulerza7003067z00, "$bglthread", 10 );
DEFINE_STRING( BGl_string2992z00zz__ft_schedulerz00, BgL_bgl_string2992za700za7za7__ft_schedulerza7003068z00, "thread", 6 );
DEFINE_STRING( BGl_string2990z00zz__ft_schedulerz00, BgL_bgl_string2990za700za7za7__ft_schedulerza7003069z00, "pair-nil", 8 );
DEFINE_STRING( BGl_string2988z00zz__ft_schedulerz00, BgL_bgl_string2988za700za7za7__ft_schedulerza7003070z00, "symbol", 6 );
DEFINE_STRING( BGl_string2987z00zz__ft_schedulerz00, BgL_bgl_string2987za700za7za7__ft_schedulerza7003071z00, "make-scheduler:Wrong number of arguments", 40 );
DEFINE_STRING( BGl_string2986z00zz__ft_schedulerz00, BgL_bgl_string2986za700za7za7__ft_schedulerza7003072z00, "procedure", 9 );
DEFINE_STRING( BGl_string2985z00zz__ft_schedulerz00, BgL_bgl_string2985za700za7za7__ft_schedulerza7003073z00, "scheduler", 9 );
DEFINE_STRING( BGl_string2984z00zz__ft_schedulerz00, BgL_bgl_string2984za700za7za7__ft_schedulerza7003074z00, "<exit:1510>:Wrong number of arguments", 37 );
DEFINE_STRING( BGl_string2983z00zz__ft_schedulerz00, BgL_bgl_string2983za700za7za7__ft_schedulerza7003075z00, "Illegal scheduler", 17 );
DEFINE_STRING( BGl_string2982z00zz__ft_schedulerz00, BgL_bgl_string2982za700za7za7__ft_schedulerza7003076z00, "default-scheduler", 17 );
DEFINE_STRING( BGl_string2981z00zz__ft_schedulerz00, BgL_bgl_string2981za700za7za7__ft_schedulerza7003077z00, "pair", 4 );
DEFINE_STRING( BGl_string2980z00zz__ft_schedulerz00, BgL_bgl_string2980za700za7za7__ft_schedulerza7003078z00, "foreign", 7 );
DEFINE_STRING( BGl_string3010z00zz__ft_schedulerz00, BgL_bgl_string3010za700za7za7__ft_schedulerza7003079z00, "scheduler-instant scheduler-terminate! _scheduler-broadcast! scheduler-broadcast! broadcast! (funcall fun1736 fun1736 i) <anonymous:1733> no-busy-waiting-next-instant (funcall stop stop i) busy-waiting-next-instant scheduler-start! <anonymous:1635> scheduler-react! (funcall fun1621 fun1621 scdl i) await dead ready done scheduler-state <anonymous:1568> unattached (funcall gensym gensym (quote scheduler)) scheduler make-scheduler _with-scheduler (funcall thunk thunk) with-scheduler default-scheduler b$bglthread $bglthread? ", 527 );
DEFINE_STRING( BGl_string3009z00zz__ft_schedulerz00, BgL_bgl_string3009za700za7za7__ft_schedulerza7003080z00, "__ft_scheduler", 14 );
DEFINE_STRING( BGl_string3008z00zz__ft_schedulerz00, BgL_bgl_string3008za700za7za7__ft_schedulerza7003081z00, "ftenv", 5 );
DEFINE_STRING( BGl_string3007z00zz__ft_schedulerz00, BgL_bgl_string3007za700za7za7__ft_schedulerza7003082z00, "argument not a list", 19 );
DEFINE_STRING( BGl_string3006z00zz__ft_schedulerz00, BgL_bgl_string3006za700za7za7__ft_schedulerza7003083z00, "for-each", 8 );
DEFINE_STRING( BGl_string3005z00zz__ft_schedulerz00, BgL_bgl_string3005za700za7za7__ft_schedulerza7003084z00, "scheduler-react!", 16 );
DEFINE_STRING( BGl_string3004z00zz__ft_schedulerz00, BgL_bgl_string3004za700za7za7__ft_schedulerza7003085z00, "Unattached thread", 17 );
DEFINE_STRING( BGl_string3003z00zz__ft_schedulerz00, BgL_bgl_string3003za700za7za7__ft_schedulerza7003086z00, "broadcast!", 10 );
DEFINE_STRING( BGl_string3002z00zz__ft_schedulerz00, BgL_bgl_string3002za700za7za7__ft_schedulerza7003087z00, "<anonymous:1733>:Wrong number of arguments", 42 );
DEFINE_STRING( BGl_string3001z00zz__ft_schedulerz00, BgL_bgl_string3001za700za7za7__ft_schedulerza7003088z00, "no-busy-waiting-next-instant:Wrong number of arguments", 54 );
DEFINE_STRING( BGl_string3000z00zz__ft_schedulerz00, BgL_bgl_string3000za700za7za7__ft_schedulerza7003089z00, "busy-waiting-next-instant:Wrong number of arguments", 51 );
DEFINE_EXPORT_PROCEDURE( BGl_schedulerzd2instantzd2envz00zz__ft_schedulerz00, BgL_bgl__schedulerza7d2instantza7d2za7za7__ft_schedulerza7003090za7, va_generic_entry, BGl__schedulerzd2instantzd2zz__ft_schedulerz00, -1 );
DEFINE_EXPORT_PROCEDURE( BGl_defaultzd2schedulerzd2envz00zz__ft_schedulerz00, BgL_bgl__defaultza7d2schedulerza7d2za7za7__ft_schedulerza7003091za7, va_generic_entry, BGl__defaultzd2schedulerzd2zz__ft_schedulerz00, -1 );
DEFINE_EXPORT_PROCEDURE( BGl_schedulerzd2reactz12zd2envz12zz__ft_schedulerz00, BgL_bgl__schedulerza7d2reactza712za7c0za7za7__ft_schedulerza7003092z00, va_generic_entry, BGl__schedulerzd2reactz12zc0zz__ft_schedulerz00, -1 );
DEFINE_EXPORT_PROCEDURE( BGl_broadcastz12zd2envzc0zz__ft_schedulerz00, BgL_bgl__broadcastza712za712za7za7__ft_schedulerza7003093za7, va_generic_entry, BGl__broadcastz12z12zz__ft_schedulerz00, -2 );
DEFINE_EXPORT_PROCEDURE( BGl_withzd2schedulerzd2envz00zz__ft_schedulerz00, BgL_bgl__withza7d2schedulerza7d2za7za7__ft_schedulerza7003094za7, BGl__withzd2schedulerzd2zz__ft_schedulerz00, 0L, 2 );



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(long BgL_checksumz00_1111, char * BgL_fromz00_1112)
{ AN_OBJECT;
{ 
if(
BGl_zd3fxzd3zz__r4_numbers_6_5_fixnumz00(
(long)CINT(
BINT(
BGl_bitzd2andzd2zz__bitz00(BgL_checksumz00_1111, ((long)58241)))), BgL_checksumz00_1111))
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__ft_schedulerz00))
{ 
BGl_requirezd2initializa7ationz75zz__ft_schedulerz00 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zz__ft_schedulerz00(); 
BGl_cnstzd2initzd2zz__ft_schedulerz00(); 
BGl_importedzd2moduleszd2initz00zz__ft_schedulerz00(); 
BGl_toplevelzd2initzd2zz__ft_schedulerz00(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} }  else 
{ 
return 
BGl_modulezd2initzd2errorz00zz__errorz00(
BSTRING_TO_STRING("__ft_scheduler"), BgL_fromz00_1112);} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__ft_schedulerz00()
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 15 */
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__ft_scheduler"); 
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__ft_scheduler"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__ft_scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_symbols_6_4z00(((long)0), "__ft_scheduler"); 
BGl_modulezd2initializa7ationz75zz__bexitz00(((long)0), "__ft_scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_numbers_6_5z00(((long)0), "__ft_scheduler"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__ft_scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_equivalence_6_2z00(((long)0), "__ft_scheduler"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__ft_schedulerz00()
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 15 */
{ /* ./Llib/scheduler.scm 15 */
obj_t BgL_cportz00_1002;
BgL_cportz00_1002 = 
open_input_string(BGl_string3010z00zz__ft_schedulerz00); 
{ 
long BgL_iz00_1003;
BgL_iz00_1003 = ((long)29); 
BgL_loopz00_1004:
if(
(BgL_iz00_1003==((long)-1)))
{ /* ./Llib/scheduler.scm 15 */
return BUNSPEC;}  else 
{ /* ./Llib/scheduler.scm 15 */
{ /* ./Llib/scheduler.scm 15 */
obj_t BgL_arg3014z00_1006;
{ /* ./Llib/scheduler.scm 15 */
obj_t BgL_list3017z00_1007;
BgL_list3017z00_1007 = 
MAKE_PAIR(BgL_cportz00_1002, BNIL); 
BgL_arg3014z00_1006 = 
BGl_readz00zz__readerz00(BgL_list3017z00_1007); } 
{ /* ./Llib/scheduler.scm 15 */
int BgL_auxz00_1142;
BgL_auxz00_1142 = 
(int)(BgL_iz00_1003); 
CNST_TABLE_SET(BgL_auxz00_1142, BgL_arg3014z00_1006); } } 
{ /* ./Llib/scheduler.scm 15 */
int BgL_auxz00_1008;
BgL_auxz00_1008 = 
(int)(
(BgL_iz00_1003-((long)1))); 
{ 
long BgL_iz00_1147;
BgL_iz00_1147 = 
(long)(BgL_auxz00_1008); 
BgL_iz00_1003 = BgL_iz00_1147; 
goto BgL_loopz00_1004;} } } } } } 
}



/* toplevel-init */
obj_t BGl_toplevelzd2initzd2zz__ft_schedulerz00()
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 15 */
BGl_za2currentzd2schedulerza2zd2zz__ft_schedulerz00 = BFALSE; 
return ( 
BGl_za2defaultzd2schedulerza2zd2zz__ft_schedulerz00 = BFALSE, BUNSPEC) ;} 
}



/* current-scheduler */
BGL_EXPORTED_DEF obj_t BGl_currentzd2schedulerzd2zz__ft_schedulerz00()
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 49 */
return BGl_za2currentzd2schedulerza2zd2zz__ft_schedulerz00;} 
}



/* _current-scheduler */
obj_t BGl__currentzd2schedulerzd2zz__ft_schedulerz00(obj_t BgL_envz00_691)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 49 */
return BGl_za2currentzd2schedulerza2zd2zz__ft_schedulerz00;} 
}



/* default-scheduler */
BGL_EXPORTED_DEF obj_t BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(obj_t BgL_scdlz00_4)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 54 */
if(
NULLP(BgL_scdlz00_4))
{ /* ./Llib/scheduler.scm 56 */
return BGl_za2defaultzd2schedulerza2zd2zz__ft_schedulerz00;}  else 
{ /* ./Llib/scheduler.scm 58 */
bool_t BgL_testz00_1151;
{ /* ./Llib/scheduler.scm 58 */
obj_t BgL_arg1494z00_233;
{ /* ./Llib/scheduler.scm 58 */
obj_t BgL_pairz00_530;
if(
PAIRP(BgL_scdlz00_4))
{ /* ./Llib/scheduler.scm 58 */
BgL_pairz00_530 = BgL_scdlz00_4; }  else 
{ /* ./Llib/scheduler.scm 58 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)2)), BGl_string2981z00zz__ft_schedulerz00, BgL_scdlz00_4); 
exit( -1 );} 
BgL_arg1494z00_233 = 
CAR(BgL_pairz00_530); } 
BgL_testz00_1151 = 
BGl_iszd2azf3z21zz__objectz00(BgL_arg1494z00_233, BGl_schedulerz00zz__ft_typesz00); } 
if(BgL_testz00_1151)
{ /* ./Llib/scheduler.scm 58 */
{ /* ./Llib/scheduler.scm 59 */
obj_t BgL_pairz00_532;
if(
PAIRP(BgL_scdlz00_4))
{ /* ./Llib/scheduler.scm 59 */
BgL_pairz00_532 = BgL_scdlz00_4; }  else 
{ /* ./Llib/scheduler.scm 59 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)2)), BGl_string2981z00zz__ft_schedulerz00, BgL_scdlz00_4); 
exit( -1 );} 
BGl_za2defaultzd2schedulerza2zd2zz__ft_schedulerz00 = 
CAR(BgL_pairz00_532); } 
{ /* ./Llib/scheduler.scm 60 */
obj_t BgL_pairz00_533;
if(
PAIRP(BgL_scdlz00_4))
{ /* ./Llib/scheduler.scm 60 */
BgL_pairz00_533 = BgL_scdlz00_4; }  else 
{ /* ./Llib/scheduler.scm 60 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)2)), BGl_string2981z00zz__ft_schedulerz00, BgL_scdlz00_4); 
exit( -1 );} 
return 
CAR(BgL_pairz00_533);} }  else 
{ /* ./Llib/scheduler.scm 62 */
obj_t BgL_arg1490z00_232;
{ /* ./Llib/scheduler.scm 62 */
obj_t BgL_pairz00_534;
if(
PAIRP(BgL_scdlz00_4))
{ /* ./Llib/scheduler.scm 62 */
BgL_pairz00_534 = BgL_scdlz00_4; }  else 
{ /* ./Llib/scheduler.scm 62 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)2)), BGl_string2981z00zz__ft_schedulerz00, BgL_scdlz00_4); 
exit( -1 );} 
BgL_arg1490z00_232 = 
CAR(BgL_pairz00_534); } 
FAILURE(BGl_string2982z00zz__ft_schedulerz00,BGl_string2983z00zz__ft_schedulerz00,BgL_arg1490z00_232);} } } 
}



/* _default-scheduler */
obj_t BGl__defaultzd2schedulerzd2zz__ft_schedulerz00(obj_t BgL_envz00_692, obj_t BgL_scdlz00_693)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 54 */
return 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BgL_scdlz00_693);} 
}



/* with-scheduler */
BGL_EXPORTED_DEF obj_t BGl_withzd2schedulerzd2zz__ft_schedulerz00(BgL_schedulerz00_bglt BgL_sz00_5, obj_t BgL_thunkz00_6)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 67 */
{ /* ./Llib/scheduler.scm 68 */
obj_t BgL_oldz00_234;
BgL_oldz00_234 = 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BNIL); 
{ /* ./Llib/scheduler.scm 69 */
obj_t BgL_val1435z00_235;
BgL_val1435z00_235 = 
BGl_zc3exitza31510ze3z83zz__ft_schedulerz00(BgL_thunkz00_6, BgL_sz00_5); 
{ /* ./Llib/scheduler.scm 73 */
obj_t BgL_list1499z00_236;
BgL_list1499z00_236 = 
MAKE_PAIR(BgL_oldz00_234, BNIL); 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BgL_list1499z00_236); } 
if(
CBOOL(
BGl_valzd2fromzd2exitzf3zf3zz__bexitz00(BgL_val1435z00_235)))
{ /* ./Llib/scheduler.scm 73 */
obj_t BgL_arg1503z00_238;obj_t BgL_arg1505z00_239;
{ /* ./Llib/scheduler.scm 73 */
obj_t BgL_pairz00_538;
if(
PAIRP(BgL_val1435z00_235))
{ /* ./Llib/scheduler.scm 73 */
BgL_pairz00_538 = BgL_val1435z00_235; }  else 
{ /* ./Llib/scheduler.scm 73 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)3)), BGl_string2981z00zz__ft_schedulerz00, BgL_val1435z00_235); 
exit( -1 );} 
BgL_arg1503z00_238 = 
CAR(BgL_pairz00_538); } 
{ /* ./Llib/scheduler.scm 73 */
obj_t BgL_pairz00_539;
if(
PAIRP(BgL_val1435z00_235))
{ /* ./Llib/scheduler.scm 73 */
BgL_pairz00_539 = BgL_val1435z00_235; }  else 
{ /* ./Llib/scheduler.scm 73 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)3)), BGl_string2981z00zz__ft_schedulerz00, BgL_val1435z00_235); 
exit( -1 );} 
BgL_arg1505z00_239 = 
CDR(BgL_pairz00_539); } 
return 
BGl_unwindzd2untilz12zc0zz__bexitz00(BgL_arg1503z00_238, BgL_arg1505z00_239);}  else 
{ /* ./Llib/scheduler.scm 73 */
return BgL_val1435z00_235;} } } } 
}



/* <exit:1510> */
obj_t BGl_zc3exitza31510ze3z83zz__ft_schedulerz00(obj_t BgL_thunkz00_753, BgL_schedulerz00_bglt BgL_sz00_752)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 73 */
jmp_buf jmpbuf; 
obj_t BgL_an_exit1436z00_241;
{BGL_STORE_TRACE(); if( SET_EXIT(BgL_an_exit1436z00_241) ) { BGL_RESTORE_TRACE(); 
return 
_exit_value_;
} else {
BgL_an_exit1436z00_241 = 
(obj_t)jmpbuf; 
{ /* ./Llib/scheduler.scm 73 */

PUSH_EXIT(BgL_an_exit1436z00_241, ((long)0)); 
{ /* ./Llib/scheduler.scm 71 */
obj_t BgL_val1437z00_242;
{ /* ./Llib/scheduler.scm 71 */
obj_t BgL_list1515z00_243;
BgL_list1515z00_243 = 
MAKE_PAIR(
(obj_t)(BgL_sz00_752), BNIL); 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BgL_list1515z00_243); } 
if(
PROCEDURE_CORRECT_ARITYP(BgL_thunkz00_753, ((long)0)))
{ /* ./Llib/scheduler.scm 72 */
BgL_val1437z00_242 = 
PROCEDURE_ENTRY(BgL_thunkz00_753)(BgL_thunkz00_753, BEOA); }  else 
{ 
obj_t BgL_auxz00_1209;
BgL_auxz00_1209 = 
CNST_TABLE_REF(((long)4)); 
FAILURE(BGl_string2984z00zz__ft_schedulerz00,BgL_auxz00_1209,BgL_thunkz00_753);} 
POP_EXIT(); 
return BgL_val1437z00_242;} } 
}} } 
}



/* _with-scheduler */
obj_t BGl__withzd2schedulerzd2zz__ft_schedulerz00(obj_t BgL_envz00_694, obj_t BgL_sz00_695, obj_t BgL_thunkz00_696)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 67 */
{ /* ./Llib/scheduler.scm 68 */
obj_t BgL_auxz00_1220;BgL_schedulerz00_bglt BgL_auxz00_1213;
if(
PROCEDUREP(BgL_thunkz00_696))
{ /* ./Llib/scheduler.scm 68 */
BgL_auxz00_1220 = BgL_thunkz00_696
; }  else 
{ /* ./Llib/scheduler.scm 68 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)5)), BGl_string2986z00zz__ft_schedulerz00, BgL_thunkz00_696); 
exit( -1 );} 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_sz00_695, BGl_schedulerz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 68 */
BgL_auxz00_1213 = 
(BgL_schedulerz00_bglt)(BgL_sz00_695)
; }  else 
{ /* ./Llib/scheduler.scm 68 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)5)), BGl_string2985z00zz__ft_schedulerz00, BgL_sz00_695); 
exit( -1 );} 
return 
BGl_withzd2schedulerzd2zz__ft_schedulerz00(BgL_auxz00_1213, BgL_auxz00_1220);} } 
}



/* make-scheduler */
BGL_EXPORTED_DEF BgL_schedulerz00_bglt BGl_makezd2schedulerzd2zz__ft_schedulerz00(obj_t BgL_envsz00_9)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 88 */
{ /* ./Llib/scheduler.scm 89 */
obj_t BgL_idz00_247;
{ /* ./Llib/scheduler.scm 89 */
obj_t BgL_funz00_777;
{ /* ./Llib/scheduler.scm 89 */
obj_t BgL_aux2097z00_775;
BgL_aux2097z00_775 = BGl_gensymz00zz__r4_symbols_6_4z00; 
if(
PROCEDUREP(BgL_aux2097z00_775))
{ /* ./Llib/scheduler.scm 89 */
BgL_funz00_777 = BgL_aux2097z00_775; }  else 
{ /* ./Llib/scheduler.scm 89 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)6)), BGl_string2986z00zz__ft_schedulerz00, BgL_aux2097z00_775); 
exit( -1 );} } 
if(
PROCEDURE_CORRECT_ARITYP(BgL_funz00_777, ((long)1)))
{ /* ./Llib/scheduler.scm 89 */
BgL_idz00_247 = 
PROCEDURE_ENTRY(BgL_funz00_777)(BGl_gensymz00zz__r4_symbols_6_4z00, 
CNST_TABLE_REF(((long)7)), BEOA); }  else 
{ 
obj_t BgL_auxz00_1237;
BgL_auxz00_1237 = 
CNST_TABLE_REF(((long)8)); 
FAILURE(BGl_string2987z00zz__ft_schedulerz00,BgL_auxz00_1237,BgL_funz00_777);} } 
{ /* ./Llib/scheduler.scm 90 */
obj_t BgL_sz00_248;
BgL_sz00_248 = 
MAKE_CELL(BUNSPEC); 
{ /* ./Llib/scheduler.scm 92 */
obj_t BgL_auxz00_711;
{ /* ./Llib/scheduler.scm 92 */
bglthread_t BgL_arg1534z00_253;obj_t BgL_arg1537z00_255;obj_t BgL_arg1542z00_258;obj_t BgL_arg1544z00_260;obj_t BgL_arg1546z00_261;
{ /* ./Llib/scheduler.scm 92 */
obj_t BgL_zc3anonymousza31568ze3z83_699;
BgL_zc3anonymousza31568ze3z83_699 = 
make_fx_procedure(BGl_zc3anonymousza31568ze3z83zz__ft_schedulerz00, 
(int)(((long)0)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza31568ze3z83_699, 
(int)(((long)0)), BgL_sz00_248); 
{ /* ./Llib/scheduler.scm 91 */
obj_t BgL_auxz00_1245;
if(
SYMBOLP(BgL_idz00_247))
{ /* ./Llib/scheduler.scm 93 */
BgL_auxz00_1245 = BgL_idz00_247
; }  else 
{ /* ./Llib/scheduler.scm 93 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)6)), BGl_string2988z00zz__ft_schedulerz00, BgL_idz00_247); 
exit( -1 );} 
BgL_arg1534z00_253 = 
bglthread_new_with_name(BgL_zc3anonymousza31568ze3z83_699, BgL_auxz00_1245); } } 
BgL_arg1537z00_255 = 
CNST_TABLE_REF(((long)9)); 
{ /* ./Llib/scheduler.scm 96 */
obj_t BgL_list1574z00_277;
BgL_list1574z00_277 = 
MAKE_PAIR(BGl_proc2989z00zz__ft_schedulerz00, BNIL); 
BgL_arg1542z00_258 = BgL_list1574z00_277; } 
BgL_arg1544z00_260 = BgL_idz00_247; 
{ /* ./Llib/scheduler.scm 95 */
obj_t BgL_arg1579z00_281;
{ /* ./Llib/scheduler.scm 95 */
BgL_z52envz52_bglt BgL_arg1583z00_282;
BgL_arg1583z00_282 = 
BGl_makezd2z52envz80zz__ft_z52envz52(((long)0), BNIL, BNIL); 
{ /* ./Llib/scheduler.scm 95 */
obj_t BgL_list1585z00_283;
BgL_list1585z00_283 = 
MAKE_PAIR(
(obj_t)(BgL_arg1583z00_282), BNIL); 
BgL_arg1579z00_281 = BgL_list1585z00_283; } } 
{ /* ./Llib/scheduler.scm 95 */
obj_t BgL_auxz00_1257;
{ /* ./Llib/scheduler.scm 95 */
bool_t BgL_testz00_1258;
if(
PAIRP(BgL_envsz00_9))
{ /* ./Llib/scheduler.scm 95 */
BgL_testz00_1258 = ((bool_t)1)
; }  else 
{ /* ./Llib/scheduler.scm 95 */
BgL_testz00_1258 = 
NULLP(BgL_envsz00_9)
; } 
if(BgL_testz00_1258)
{ /* ./Llib/scheduler.scm 95 */
BgL_auxz00_1257 = BgL_envsz00_9
; }  else 
{ /* ./Llib/scheduler.scm 95 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)6)), BGl_string2990z00zz__ft_schedulerz00, BgL_envsz00_9); 
exit( -1 );} } 
BgL_arg1546z00_261 = 
bgl_append2(BgL_auxz00_1257, BgL_arg1579z00_281); } } 
{ /* ./Llib/scheduler.scm 90 */
BgL_z52schedulerz52_bglt BgL_auxz00_1266;
{ /* ./Llib/scheduler.scm 90 */
obj_t BgL_auxz00_1271;obj_t BgL_auxz00_1267;
if(
PAIRP(BgL_arg1546z00_261))
{ /* ./Llib/scheduler.scm 95 */
BgL_auxz00_1271 = BgL_arg1546z00_261
; }  else 
{ /* ./Llib/scheduler.scm 95 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)6)), BGl_string2981z00zz__ft_schedulerz00, BgL_arg1546z00_261); 
exit( -1 );} 
{ /* ./Llib/scheduler.scm 91 */
obj_t BgL_auxz00_1268;
BgL_auxz00_1268 = 
CNST_TABLE_REF(((long)1)); 
BgL_auxz00_1267 = 
cobj_to_foreign(BgL_auxz00_1268, BgL_arg1534z00_253); } 
BgL_auxz00_1266 = 
BGl_makezd2z52schedulerz80zz__ft_z52typesz52(BgL_auxz00_1267, 
(int)(((long)1)), BgL_arg1537z00_255, ((bool_t)0), BGl_listzd2envzd2zz__r4_pairs_and_lists_6_3z00, BUNSPEC, BUNSPEC, ((bool_t)0), 
(int)(((long)0)), BNIL, BgL_arg1542z00_258, BNIL, BFALSE, BFALSE, BgL_arg1544z00_260, BUNSPEC, BFALSE, BFALSE, BgL_auxz00_1271, BGl_proc2991z00zz__ft_schedulerz00, BFALSE, 
(int)(((long)0)), ((bool_t)0), BNIL, BNIL, BNIL, BNIL, BNIL, BNIL, BNIL, BNIL, BNIL); } 
BgL_auxz00_711 = 
(obj_t)(BgL_auxz00_1266); } } 
CELL_SET(BgL_sz00_248, BgL_auxz00_711); } 
{ /* ./Llib/scheduler.scm 98 */
BgL_threadz00_bglt BgL_auxz00_1282;
{ /* ./Llib/scheduler.scm 98 */
obj_t BgL_aux2147z00_787;
BgL_aux2147z00_787 = 
CELL_REF(BgL_sz00_248); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux2147z00_787, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 98 */
BgL_auxz00_1282 = 
(BgL_threadz00_bglt)(BgL_aux2147z00_787)
; }  else 
{ /* ./Llib/scheduler.scm 98 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)6)), BGl_string2992z00zz__ft_schedulerz00, BgL_aux2147z00_787); 
exit( -1 );} } 
BGl_z52threadzd2setupz12z92zz__ft_z52threadz52(BgL_auxz00_1282); } 
{ /* ./Llib/scheduler.scm 100 */
obj_t BgL_arg1524z00_249;
{ /* ./Llib/scheduler.scm 100 */
BgL_threadz00_bglt BgL_obj1003z00_546;
{ /* ./Llib/scheduler.scm 100 */
obj_t BgL_aux2155z00_789;
BgL_aux2155z00_789 = 
CELL_REF(BgL_sz00_248); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux2155z00_789, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 100 */
BgL_obj1003z00_546 = 
(BgL_threadz00_bglt)(BgL_aux2155z00_789); }  else 
{ /* ./Llib/scheduler.scm 100 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)6)), BGl_string2992z00zz__ft_schedulerz00, BgL_aux2155z00_789); 
exit( -1 );} } 
BgL_arg1524z00_249 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_546))->BgL_z52builtinz52); } 
{ /* ./Llib/scheduler.scm 100 */
bglthread_t BgL_auxz00_1297;
{ /* ./Llib/scheduler.scm 100 */
obj_t BgL_auxz00_1298;
{ /* ./Llib/scheduler.scm 100 */
obj_t BgL_aux2170z00_793;
if(
FOREIGNP(BgL_arg1524z00_249))
{ /* ./Llib/scheduler.scm 100 */
BgL_aux2170z00_793 = BgL_arg1524z00_249; }  else 
{ /* ./Llib/scheduler.scm 100 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)6)), BGl_string2993z00zz__ft_schedulerz00, BgL_arg1524z00_249); 
exit( -1 );} 
{ /* ./Llib/scheduler.scm 100 */
bool_t BgL_testz00_1304;
if(
FOREIGNP(BgL_aux2170z00_793))
{ /* ./Llib/scheduler.scm 100 */
obj_t BgL_arg1478z00_1020;obj_t BgL_arg1479z00_1021;
{ /* ./Llib/scheduler.scm 100 */
obj_t BgL_auxz00_1307;
if(
FOREIGNP(BgL_aux2170z00_793))
{ /* ./Llib/scheduler.scm 100 */
BgL_auxz00_1307 = BgL_aux2170z00_793
; }  else 
{ /* ./Llib/scheduler.scm 100 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2980z00zz__ft_schedulerz00, BgL_aux2170z00_793); 
exit( -1 );} 
BgL_arg1478z00_1020 = 
FOREIGN_ID(BgL_auxz00_1307); } 
BgL_arg1479z00_1021 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_1304 = 
(BgL_arg1478z00_1020==BgL_arg1479z00_1021); }  else 
{ /* ./Llib/scheduler.scm 100 */
BgL_testz00_1304 = ((bool_t)0)
; } 
if(BgL_testz00_1304)
{ /* ./Llib/scheduler.scm 100 */
BgL_auxz00_1298 = BgL_aux2170z00_793
; }  else 
{ /* ./Llib/scheduler.scm 100 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)6)), BGl_string2993z00zz__ft_schedulerz00, BgL_aux2170z00_793); 
exit( -1 );} } } 
BgL_auxz00_1297 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_1298); } 
bglthread_start(BgL_auxz00_1297); } } 
if(
CBOOL(
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BNIL)))
{ /* ./Llib/scheduler.scm 102 */BFALSE; }  else 
{ /* ./Llib/scheduler.scm 102 */
obj_t BgL_list1529z00_251;
BgL_list1529z00_251 = 
MAKE_PAIR(
CELL_REF(BgL_sz00_248), BNIL); 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BgL_list1529z00_251); } 
{ /* ./Llib/scheduler.scm 104 */
obj_t BgL_aux2180z00_795;
BgL_aux2180z00_795 = 
CELL_REF(BgL_sz00_248); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux2180z00_795, BGl_schedulerz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 104 */
return 
(BgL_schedulerz00_bglt)(BgL_aux2180z00_795);}  else 
{ /* ./Llib/scheduler.scm 104 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)6)), BGl_string2985z00zz__ft_schedulerz00, BgL_aux2180z00_795); 
exit( -1 );} } } } } 
}



/* _make-scheduler */
obj_t BGl__makezd2schedulerzd2zz__ft_schedulerz00(obj_t BgL_envz00_700, obj_t BgL_envsz00_701)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 88 */
{ /* ./Llib/scheduler.scm 89 */
BgL_schedulerz00_bglt BgL_auxz00_1332;
BgL_auxz00_1332 = 
BGl_makezd2schedulerzd2zz__ft_schedulerz00(BgL_envsz00_701); 
return 
(obj_t)(BgL_auxz00_1332);} } 
}



/* <anonymous:1588> */
obj_t BGl_zc3anonymousza31588ze3z83zz__ft_schedulerz00(obj_t BgL_envz00_702, obj_t BgL_sz00_703, obj_t BgL_iz00_704)
{ AN_OBJECT;
{ /* ./Llib/_types.scm 21 */
return 
BBOOL(((bool_t)0));} 
}



/* <anonymous:1576> */
obj_t BGl_zc3anonymousza31576ze3z83zz__ft_schedulerz00(obj_t BgL_envz00_705, obj_t BgL_xz00_706)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 96 */
return BgL_xz00_706;} 
}



/* <anonymous:1568> */
obj_t BGl_zc3anonymousza31568ze3z83zz__ft_schedulerz00(obj_t BgL_envz00_707)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 92 */
{ /* ./Llib/scheduler.scm 92 */
obj_t BgL_sz00_708;
BgL_sz00_708 = 
PROCEDURE_REF(BgL_envz00_707, 
(int)(((long)0))); 
{ 

{ /* ./Llib/scheduler.scm 92 */
BgL_z52schedulerz52_bglt BgL_auxz00_1338;
{ /* ./Llib/scheduler.scm 92 */
obj_t BgL_aux2191z00_797;
BgL_aux2191z00_797 = 
CELL_REF(BgL_sz00_708); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux2191z00_797, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/scheduler.scm 92 */
BgL_auxz00_1338 = 
(BgL_z52schedulerz52_bglt)(BgL_aux2191z00_797)
; }  else 
{ /* ./Llib/scheduler.scm 92 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)10)), BGl_string2994z00zz__ft_schedulerz00, BgL_aux2191z00_797); 
exit( -1 );} } 
return 
BGl_schedulez00zz__ft_schedulerz00(BgL_auxz00_1338);} } } } 
}



/* scheduler-state */
obj_t BGl_schedulerzd2statezd2zz__ft_schedulerz00(BgL_schedulerz00_bglt BgL_sz00_10)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 109 */
{ /* ./Llib/scheduler.scm 117 */
bool_t BgL_testz00_1346;
{ /* ./Llib/scheduler.scm 117 */
long BgL_n1z00_548;
{ /* ./Llib/scheduler.scm 117 */
BgL_z52schedulerz52_bglt BgL_obj1178z00_547;
{ /* ./Llib/scheduler.scm 117 */
obj_t BgL_aux22200z00_800;
BgL_aux22200z00_800 = 
((obj_t)BgL_sz00_10); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22200z00_800, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/scheduler.scm 117 */
BgL_obj1178z00_547 = 
(BgL_z52schedulerz52_bglt)(BgL_sz00_10); }  else 
{ /* ./Llib/scheduler.scm 117 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)11)), BGl_string2994z00zz__ft_schedulerz00, 
(obj_t)(BgL_sz00_10)); 
exit( -1 );} } 
BgL_n1z00_548 = 
(long)(
(((BgL_z52schedulerz52_bglt)CREF(BgL_obj1178z00_547))->BgL_z52livezd2threadzd2numberz52)); } 
BgL_testz00_1346 = 
(BgL_n1z00_548==((long)0)); } 
if(BgL_testz00_1346)
{ /* ./Llib/scheduler.scm 117 */
return 
CNST_TABLE_REF(((long)12));}  else 
{ /* ./Llib/scheduler.scm 119 */
bool_t BgL_testz00_1359;
{ /* ./Llib/scheduler.scm 119 */
bool_t BgL_testz00_1360;
{ /* ./Llib/scheduler.scm 119 */
BgL_z52schedulerz52_bglt BgL_obj1181z00_550;
{ /* ./Llib/scheduler.scm 119 */
obj_t BgL_aux22211z00_803;
BgL_aux22211z00_803 = 
((obj_t)BgL_sz00_10); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22211z00_803, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/scheduler.scm 119 */
BgL_obj1181z00_550 = 
(BgL_z52schedulerz52_bglt)(BgL_sz00_10); }  else 
{ /* ./Llib/scheduler.scm 119 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)11)), BGl_string2994z00zz__ft_schedulerz00, 
(obj_t)(BgL_sz00_10)); 
exit( -1 );} } 
BgL_testz00_1360 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_obj1181z00_550))->BgL_z52threadszd2readyz80); } 
if(BgL_testz00_1360)
{ /* ./Llib/scheduler.scm 119 */
BgL_testz00_1359 = ((bool_t)1)
; }  else 
{ /* ./Llib/scheduler.scm 120 */
bool_t BgL_testz00_1370;
{ /* ./Llib/scheduler.scm 120 */
obj_t BgL_auxz00_1371;
{ /* ./Llib/scheduler.scm 120 */
BgL_z52schedulerz52_bglt BgL_obj1196z00_551;
{ /* ./Llib/scheduler.scm 120 */
obj_t BgL_aux22221z00_806;
BgL_aux22221z00_806 = 
((obj_t)BgL_sz00_10); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22221z00_806, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/scheduler.scm 120 */
BgL_obj1196z00_551 = 
(BgL_z52schedulerz52_bglt)(BgL_sz00_10); }  else 
{ /* ./Llib/scheduler.scm 120 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)11)), BGl_string2994z00zz__ft_schedulerz00, 
(obj_t)(BgL_sz00_10)); 
exit( -1 );} } 
BgL_auxz00_1371 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_obj1196z00_551))->BgL_tostartz00); } 
BgL_testz00_1370 = 
PAIRP(BgL_auxz00_1371); } 
if(BgL_testz00_1370)
{ /* ./Llib/scheduler.scm 120 */
BgL_testz00_1359 = ((bool_t)1)
; }  else 
{ /* ./Llib/scheduler.scm 121 */
bool_t BgL_testz00_1382;
{ /* ./Llib/scheduler.scm 121 */
obj_t BgL_auxz00_1383;
{ /* ./Llib/scheduler.scm 121 */
BgL_z52schedulerz52_bglt BgL_obj1199z00_553;
{ /* ./Llib/scheduler.scm 121 */
obj_t BgL_aux22231z00_809;
BgL_aux22231z00_809 = 
((obj_t)BgL_sz00_10); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22231z00_809, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/scheduler.scm 121 */
BgL_obj1199z00_553 = 
(BgL_z52schedulerz52_bglt)(BgL_sz00_10); }  else 
{ /* ./Llib/scheduler.scm 121 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)11)), BGl_string2994z00zz__ft_schedulerz00, 
(obj_t)(BgL_sz00_10)); 
exit( -1 );} } 
BgL_auxz00_1383 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_obj1199z00_553))->BgL_toterminatez00); } 
BgL_testz00_1382 = 
PAIRP(BgL_auxz00_1383); } 
if(BgL_testz00_1382)
{ /* ./Llib/scheduler.scm 121 */
BgL_testz00_1359 = ((bool_t)1)
; }  else 
{ /* ./Llib/scheduler.scm 122 */
obj_t BgL_auxz00_1394;
{ /* ./Llib/scheduler.scm 122 */
BgL_z52schedulerz52_bglt BgL_obj1202z00_555;
{ /* ./Llib/scheduler.scm 122 */
obj_t BgL_aux22241z00_812;
BgL_aux22241z00_812 = 
((obj_t)BgL_sz00_10); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22241z00_812, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/scheduler.scm 122 */
BgL_obj1202z00_555 = 
(BgL_z52schedulerz52_bglt)(BgL_sz00_10); }  else 
{ /* ./Llib/scheduler.scm 122 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)11)), BGl_string2994z00zz__ft_schedulerz00, 
(obj_t)(BgL_sz00_10)); 
exit( -1 );} } 
BgL_auxz00_1394 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_obj1202z00_555))->BgL_tosuspendzf2resumezf2); } 
BgL_testz00_1359 = 
PAIRP(BgL_auxz00_1394); } } } } 
if(BgL_testz00_1359)
{ /* ./Llib/scheduler.scm 119 */
return 
CNST_TABLE_REF(((long)13));}  else 
{ /* ./Llib/scheduler.scm 119 */
if(
BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(
(BgL_threadz00_bglt)(BgL_sz00_10), BNIL))
{ /* ./Llib/scheduler.scm 125 */
return 
CNST_TABLE_REF(((long)14));}  else 
{ /* ./Llib/scheduler.scm 125 */
return 
CNST_TABLE_REF(((long)15));} } } } } 
}



/* schedule */
obj_t BGl_schedulez00zz__ft_schedulerz00(BgL_z52schedulerz52_bglt BgL_scdlz00_11)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 136 */
{ 
long BgL_iz00_302;
BgL_iz00_302 = ((long)0); 
BgL_loopz00_303:
BGl_z52schedulezd2instantz80zz__ft_z52schedulerz52(BgL_scdlz00_11); 
{ /* ./Llib/scheduler.scm 140 */
obj_t BgL_fun1621z00_304;
BgL_fun1621z00_304 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_11))->BgL_nextzd2instantzd2); 
if(
PROCEDURE_CORRECT_ARITYP(BgL_fun1621z00_304, ((long)2)))
{ /* ./Llib/scheduler.scm 140 */
PROCEDURE_ENTRY(BgL_fun1621z00_304)(BgL_fun1621z00_304, 
(obj_t)(BgL_scdlz00_11), 
BINT(BgL_iz00_302), BEOA); }  else 
{ 
obj_t BgL_auxz00_1419;
BgL_auxz00_1419 = 
CNST_TABLE_REF(((long)16)); 
FAILURE(BGl_string2995z00zz__ft_schedulerz00,BgL_auxz00_1419,BgL_fun1621z00_304);} } 
{ 
long BgL_iz00_1422;
BgL_iz00_1422 = 
(BgL_iz00_302+((long)1)); 
BgL_iz00_302 = BgL_iz00_1422; 
goto BgL_loopz00_303;} } 
return BUNSPEC;} 
}



/* scheduler-react! */
BGL_EXPORTED_DEF obj_t BGl_schedulerzd2reactz12zc0zz__ft_schedulerz00(obj_t BgL_oz00_12)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 150 */
{ /* ./Llib/scheduler.scm 152 */
BgL_schedulerz00_bglt BgL_scdlz00_306;
{ /* ./Llib/scheduler.scm 152 */
obj_t BgL_auxz00_1424;
{ /* ./Llib/scheduler.scm 152 */
bool_t BgL_testz00_1426;
if(
PAIRP(BgL_oz00_12))
{ /* ./Llib/scheduler.scm 152 */
BgL_testz00_1426 = ((bool_t)1)
; }  else 
{ /* ./Llib/scheduler.scm 152 */
BgL_testz00_1426 = 
NULLP(BgL_oz00_12)
; } 
if(BgL_testz00_1426)
{ /* ./Llib/scheduler.scm 152 */
BgL_auxz00_1424 = BgL_oz00_12
; }  else 
{ /* ./Llib/scheduler.scm 152 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)17)), BGl_string2990z00zz__ft_schedulerz00, BgL_oz00_12); 
exit( -1 );} } 
BgL_scdlz00_306 = 
BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(
CNST_TABLE_REF(((long)17)), BgL_auxz00_1424); } 
{ 
BgL_schedulerz00_bglt BgL_scdlz00_308;
{ /* ./Llib/scheduler.scm 154 */
obj_t BgL_csz00_561;
BgL_csz00_561 = BGl_za2currentzd2schedulerza2zd2zz__ft_schedulerz00; 
BGl_za2currentzd2schedulerza2zd2zz__ft_schedulerz00 = 
(obj_t)(BgL_scdlz00_306); 
{ /* ./Llib/scheduler.scm 154 */
obj_t BgL_rz00_562;
BgL_scdlz00_308 = BgL_scdlz00_306; 
{ /* ./Llib/scheduler.scm 158 */
BgL_z52schedulerz52_bglt BgL_obj1174z00_563;obj_t BgL_val1173z00_564;
{ /* ./Llib/scheduler.scm 158 */
obj_t BgL_aux22266z00_820;
BgL_aux22266z00_820 = 
((obj_t)BgL_scdlz00_308); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22266z00_820, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/scheduler.scm 158 */
BgL_obj1174z00_563 = 
(BgL_z52schedulerz52_bglt)(BgL_scdlz00_308); }  else 
{ /* ./Llib/scheduler.scm 158 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)17)), BGl_string2994z00zz__ft_schedulerz00, 
(obj_t)(BgL_scdlz00_308)); 
exit( -1 );} } 
BgL_val1173z00_564 = BGl_proc2996z00zz__ft_schedulerz00; 
((((BgL_z52schedulerz52_bglt)CREF(BgL_obj1174z00_563))->BgL_nextzd2instantzd2) = ((obj_t)BgL_val1173z00_564), BUNSPEC); } 
{ /* ./Llib/scheduler.scm 163 */
obj_t BgL_arg1641z00_317;
{ /* ./Llib/scheduler.scm 163 */
BgL_threadz00_bglt BgL_obj1003z00_567;
BgL_obj1003z00_567 = 
(BgL_threadz00_bglt)(BgL_scdlz00_308); 
BgL_arg1641z00_317 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_567))->BgL_z52builtinz52); } 
{ /* ./Llib/scheduler.scm 163 */
bglthread_t BgL_auxz00_1446;
{ /* ./Llib/scheduler.scm 163 */
obj_t BgL_auxz00_1447;
{ /* ./Llib/scheduler.scm 163 */
obj_t BgL_aux2283z00_824;
if(
FOREIGNP(BgL_arg1641z00_317))
{ /* ./Llib/scheduler.scm 163 */
BgL_aux2283z00_824 = BgL_arg1641z00_317; }  else 
{ /* ./Llib/scheduler.scm 163 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)17)), BGl_string2993z00zz__ft_schedulerz00, BgL_arg1641z00_317); 
exit( -1 );} 
{ /* ./Llib/scheduler.scm 163 */
bool_t BgL_testz00_1453;
if(
FOREIGNP(BgL_aux2283z00_824))
{ /* ./Llib/scheduler.scm 163 */
obj_t BgL_arg1478z00_1039;obj_t BgL_arg1479z00_1040;
{ /* ./Llib/scheduler.scm 163 */
obj_t BgL_auxz00_1456;
if(
FOREIGNP(BgL_aux2283z00_824))
{ /* ./Llib/scheduler.scm 163 */
BgL_auxz00_1456 = BgL_aux2283z00_824
; }  else 
{ /* ./Llib/scheduler.scm 163 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2980z00zz__ft_schedulerz00, BgL_aux2283z00_824); 
exit( -1 );} 
BgL_arg1478z00_1039 = 
FOREIGN_ID(BgL_auxz00_1456); } 
BgL_arg1479z00_1040 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_1453 = 
(BgL_arg1478z00_1039==BgL_arg1479z00_1040); }  else 
{ /* ./Llib/scheduler.scm 163 */
BgL_testz00_1453 = ((bool_t)0)
; } 
if(BgL_testz00_1453)
{ /* ./Llib/scheduler.scm 163 */
BgL_auxz00_1447 = BgL_aux2283z00_824
; }  else 
{ /* ./Llib/scheduler.scm 163 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)17)), BGl_string2993z00zz__ft_schedulerz00, BgL_aux2283z00_824); 
exit( -1 );} } } 
BgL_auxz00_1446 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_1447); } 
bglthread_enter_scheduler(BgL_auxz00_1446); } } 
BgL_rz00_562 = 
BGl_schedulerzd2statezd2zz__ft_schedulerz00(BgL_scdlz00_308); 
BGl_za2currentzd2schedulerza2zd2zz__ft_schedulerz00 = BgL_csz00_561; 
return BgL_rz00_562;} } } } } 
}



/* _scheduler-react! */
obj_t BGl__schedulerzd2reactz12zc0zz__ft_schedulerz00(obj_t BgL_envz00_713, obj_t BgL_oz00_714)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 150 */
return 
BGl_schedulerzd2reactz12zc0zz__ft_schedulerz00(BgL_oz00_714);} 
}



/* <anonymous:1635> */
obj_t BGl_zc3anonymousza31635ze3z83zz__ft_schedulerz00(obj_t BgL_envz00_715, obj_t BgL_scdlz00_716, obj_t BgL_iz00_717)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 159 */
{ 
obj_t BgL_scdlz00_312;obj_t BgL_iz00_313;
{ /* ./Llib/scheduler.scm 160 */
bool_t BgL_auxz00_1472;
BgL_scdlz00_312 = BgL_scdlz00_716; 
BgL_iz00_313 = BgL_iz00_717; 
{ /* ./Llib/scheduler.scm 160 */
obj_t BgL_arg1637z00_565;
{ /* ./Llib/scheduler.scm 160 */
BgL_threadz00_bglt BgL_obj1003z00_566;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_312, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 160 */
BgL_obj1003z00_566 = 
(BgL_threadz00_bglt)(BgL_scdlz00_312); }  else 
{ /* ./Llib/scheduler.scm 160 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)18)), BGl_string2992z00zz__ft_schedulerz00, BgL_scdlz00_312); 
exit( -1 );} 
BgL_arg1637z00_565 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_566))->BgL_z52builtinz52); } 
{ /* ./Llib/scheduler.scm 160 */
bglthread_t BgL_auxz00_1480;
{ /* ./Llib/scheduler.scm 160 */
obj_t BgL_auxz00_1481;
{ /* ./Llib/scheduler.scm 160 */
obj_t BgL_aux2307z00_830;
if(
FOREIGNP(BgL_arg1637z00_565))
{ /* ./Llib/scheduler.scm 160 */
BgL_aux2307z00_830 = BgL_arg1637z00_565; }  else 
{ /* ./Llib/scheduler.scm 160 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)18)), BGl_string2993z00zz__ft_schedulerz00, BgL_arg1637z00_565); 
exit( -1 );} 
{ /* ./Llib/scheduler.scm 160 */
bool_t BgL_testz00_1487;
if(
FOREIGNP(BgL_aux2307z00_830))
{ /* ./Llib/scheduler.scm 160 */
obj_t BgL_arg1478z00_1043;obj_t BgL_arg1479z00_1044;
{ /* ./Llib/scheduler.scm 160 */
obj_t BgL_auxz00_1490;
if(
FOREIGNP(BgL_aux2307z00_830))
{ /* ./Llib/scheduler.scm 160 */
BgL_auxz00_1490 = BgL_aux2307z00_830
; }  else 
{ /* ./Llib/scheduler.scm 160 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2980z00zz__ft_schedulerz00, BgL_aux2307z00_830); 
exit( -1 );} 
BgL_arg1478z00_1043 = 
FOREIGN_ID(BgL_auxz00_1490); } 
BgL_arg1479z00_1044 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_1487 = 
(BgL_arg1478z00_1043==BgL_arg1479z00_1044); }  else 
{ /* ./Llib/scheduler.scm 160 */
BgL_testz00_1487 = ((bool_t)0)
; } 
if(BgL_testz00_1487)
{ /* ./Llib/scheduler.scm 160 */
BgL_auxz00_1481 = BgL_aux2307z00_830
; }  else 
{ /* ./Llib/scheduler.scm 160 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)18)), BGl_string2993z00zz__ft_schedulerz00, BgL_aux2307z00_830); 
exit( -1 );} } } 
BgL_auxz00_1480 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_1481); } 
bglthread_leave_scheduler(BgL_auxz00_1480); } } 
BgL_auxz00_1472 = ((bool_t)1); 
return 
BBOOL(BgL_auxz00_1472);} } } 
}



/* scheduler-start! */
BGL_EXPORTED_DEF obj_t BGl_schedulerzd2startz12zc0zz__ft_schedulerz00(obj_t BgL_argsz00_13)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 170 */
{ /* ./Llib/scheduler.scm 171 */
bool_t BgL_iterpz00_319;
if(
PAIRP(BgL_argsz00_13))
{ /* ./Llib/scheduler.scm 171 */
obj_t BgL_arg1758z00_385;
{ /* ./Llib/scheduler.scm 171 */
obj_t BgL_pairz00_569;
if(
PAIRP(BgL_argsz00_13))
{ /* ./Llib/scheduler.scm 171 */
BgL_pairz00_569 = BgL_argsz00_13; }  else 
{ /* ./Llib/scheduler.scm 171 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)19)), BGl_string2981z00zz__ft_schedulerz00, BgL_argsz00_13); 
exit( -1 );} 
BgL_arg1758z00_385 = 
CAR(BgL_pairz00_569); } 
if(
INTEGERP(BgL_arg1758z00_385))
{ /* ./Llib/scheduler.scm 171 */
BgL_iterpz00_319 = ((bool_t)1); }  else 
{ /* ./Llib/scheduler.scm 171 */
if(
REALP(BgL_arg1758z00_385))
{ /* ./Llib/scheduler.scm 171 */
BgL_iterpz00_319 = ((bool_t)1); }  else 
{ /* ./Llib/scheduler.scm 171 */
if(
ELONGP(BgL_arg1758z00_385))
{ /* ./Llib/scheduler.scm 171 */
BgL_iterpz00_319 = ((bool_t)1); }  else 
{ /* ./Llib/scheduler.scm 171 */
BgL_iterpz00_319 = 
LLONGP(BgL_arg1758z00_385); } } } }  else 
{ /* ./Llib/scheduler.scm 171 */
BgL_iterpz00_319 = ((bool_t)0); } 
{ /* ./Llib/scheduler.scm 171 */
obj_t BgL_scdlz00_320;
if(
NULLP(BgL_argsz00_13))
{ /* ./Llib/scheduler.scm 172 */
BgL_scdlz00_320 = 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BNIL); }  else 
{ /* ./Llib/scheduler.scm 174 */
obj_t BgL_arg1752z00_382;obj_t BgL_arg1753z00_383;
BgL_arg1752z00_382 = 
CNST_TABLE_REF(((long)19)); 
{ /* ./Llib/scheduler.scm 174 */
obj_t BgL_pairz00_580;
if(
PAIRP(BgL_argsz00_13))
{ /* ./Llib/scheduler.scm 174 */
BgL_pairz00_580 = BgL_argsz00_13; }  else 
{ /* ./Llib/scheduler.scm 174 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)19)), BGl_string2981z00zz__ft_schedulerz00, BgL_argsz00_13); 
exit( -1 );} 
BgL_arg1753z00_383 = 
CDR(BgL_pairz00_580); } 
{ /* ./Llib/scheduler.scm 174 */
BgL_schedulerz00_bglt BgL_auxz00_1530;
{ /* ./Llib/scheduler.scm 174 */
obj_t BgL_auxz00_1531;
{ /* ./Llib/scheduler.scm 174 */
bool_t BgL_testz00_1532;
if(
PAIRP(BgL_arg1753z00_383))
{ /* ./Llib/scheduler.scm 174 */
BgL_testz00_1532 = ((bool_t)1)
; }  else 
{ /* ./Llib/scheduler.scm 174 */
BgL_testz00_1532 = 
NULLP(BgL_arg1753z00_383)
; } 
if(BgL_testz00_1532)
{ /* ./Llib/scheduler.scm 174 */
BgL_auxz00_1531 = BgL_arg1753z00_383
; }  else 
{ /* ./Llib/scheduler.scm 174 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)19)), BGl_string2990z00zz__ft_schedulerz00, BgL_arg1753z00_383); 
exit( -1 );} } 
BgL_auxz00_1530 = 
BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(BgL_arg1752z00_382, BgL_auxz00_1531); } 
BgL_scdlz00_320 = 
(obj_t)(BgL_auxz00_1530); } } 
{ /* ./Llib/scheduler.scm 172 */
obj_t BgL_stopz00_321;
if(
NULLP(BgL_argsz00_13))
{ /* ./Llib/scheduler.scm 176 */
BgL_stopz00_321 = BGl_proc2997z00zz__ft_schedulerz00; }  else 
{ /* ./Llib/scheduler.scm 179 */
bool_t BgL_testz00_1543;
{ /* ./Llib/scheduler.scm 179 */
obj_t BgL_arg1744z00_379;
{ /* ./Llib/scheduler.scm 179 */
obj_t BgL_pairz00_582;
if(
PAIRP(BgL_argsz00_13))
{ /* ./Llib/scheduler.scm 179 */
BgL_pairz00_582 = BgL_argsz00_13; }  else 
{ /* ./Llib/scheduler.scm 179 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)19)), BGl_string2981z00zz__ft_schedulerz00, BgL_argsz00_13); 
exit( -1 );} 
BgL_arg1744z00_379 = 
CAR(BgL_pairz00_582); } 
if(
INTEGERP(BgL_arg1744z00_379))
{ /* ./Llib/scheduler.scm 179 */
BgL_testz00_1543 = ((bool_t)1)
; }  else 
{ /* ./Llib/scheduler.scm 179 */
if(
REALP(BgL_arg1744z00_379))
{ /* ./Llib/scheduler.scm 179 */
BgL_testz00_1543 = ((bool_t)1)
; }  else 
{ /* ./Llib/scheduler.scm 179 */
if(
ELONGP(BgL_arg1744z00_379))
{ /* ./Llib/scheduler.scm 179 */
BgL_testz00_1543 = ((bool_t)1)
; }  else 
{ /* ./Llib/scheduler.scm 179 */
BgL_testz00_1543 = 
LLONGP(BgL_arg1744z00_379)
; } } } } 
if(BgL_testz00_1543)
{ /* ./Llib/scheduler.scm 180 */
obj_t BgL_stz00_367;
{ /* ./Llib/scheduler.scm 180 */
obj_t BgL_arg1723z00_370;obj_t BgL_arg1724z00_371;
{ /* ./Llib/scheduler.scm 180 */
obj_t BgL_pairz00_592;
if(
PAIRP(BgL_argsz00_13))
{ /* ./Llib/scheduler.scm 180 */
BgL_pairz00_592 = BgL_argsz00_13; }  else 
{ /* ./Llib/scheduler.scm 180 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)19)), BGl_string2981z00zz__ft_schedulerz00, BgL_argsz00_13); 
exit( -1 );} 
BgL_arg1723z00_370 = 
CAR(BgL_pairz00_592); } 
{ /* ./Llib/scheduler.scm 180 */
obj_t BgL_arg1728z00_372;
{ /* ./Llib/scheduler.scm 180 */
BgL_schedulerz00_bglt BgL_auxz00_1563;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_320, BGl_schedulerz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 180 */
BgL_auxz00_1563 = 
(BgL_schedulerz00_bglt)(BgL_scdlz00_320)
; }  else 
{ /* ./Llib/scheduler.scm 180 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)19)), BGl_string2985z00zz__ft_schedulerz00, BgL_scdlz00_320); 
exit( -1 );} 
BgL_arg1728z00_372 = 
BGl_z52schedulerzd2timez80zz__ft_z52schedulerz52(BgL_auxz00_1563); } 
BgL_arg1724z00_371 = 
BGl_2zb2zb2zz__r4_numbers_6_5z00(BgL_arg1728z00_372, 
BINT(((long)-1))); } 
BgL_stz00_367 = 
BGl_2zb2zb2zz__r4_numbers_6_5z00(BgL_arg1723z00_370, BgL_arg1724z00_371); } 
{ /* ./Llib/scheduler.scm 181 */
obj_t BgL_zc3anonymousza31719ze3z83_721;
BgL_zc3anonymousza31719ze3z83_721 = 
make_fx_procedure(BGl_zc3anonymousza31719ze3z83zz__ft_schedulerz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza31719ze3z83_721, 
(int)(((long)0)), BgL_stz00_367); 
BgL_stopz00_321 = BgL_zc3anonymousza31719ze3z83_721; } }  else 
{ /* ./Llib/scheduler.scm 183 */
bool_t BgL_testz00_1579;
{ /* ./Llib/scheduler.scm 183 */
obj_t BgL_auxz00_1580;
{ /* ./Llib/scheduler.scm 183 */
obj_t BgL_pairz00_593;
if(
PAIRP(BgL_argsz00_13))
{ /* ./Llib/scheduler.scm 183 */
BgL_pairz00_593 = BgL_argsz00_13; }  else 
{ /* ./Llib/scheduler.scm 183 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)19)), BGl_string2981z00zz__ft_schedulerz00, BgL_argsz00_13); 
exit( -1 );} 
BgL_auxz00_1580 = 
CAR(BgL_pairz00_593); } 
BgL_testz00_1579 = 
PROCEDUREP(BgL_auxz00_1580); } 
if(BgL_testz00_1579)
{ /* ./Llib/scheduler.scm 184 */
obj_t BgL_zc3anonymousza31733ze3z83_722;
BgL_zc3anonymousza31733ze3z83_722 = 
make_fx_procedure(BGl_zc3anonymousza31733ze3z83zz__ft_schedulerz00, 
(int)(((long)1)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_zc3anonymousza31733ze3z83_722, 
(int)(((long)0)), BgL_argsz00_13); 
BgL_stopz00_321 = BgL_zc3anonymousza31733ze3z83_722; }  else 
{ /* ./Llib/scheduler.scm 183 */
FAILURE(BGl_string2998z00zz__ft_schedulerz00,BGl_string2999z00zz__ft_schedulerz00,BgL_argsz00_13);} } } 
{ /* ./Llib/scheduler.scm 175 */

{ /* ./Llib/scheduler.scm 208 */
obj_t BgL_busyzd2waitingzd2nextzd2instantzd2_718;obj_t BgL_nozd2busyzd2waitingzd2nextzd2instantz00_719;
BgL_busyzd2waitingzd2nextzd2instantzd2_718 = 
make_fx_procedure(BGl_busyzd2waitingzd2nextzd2instantzd2zz__ft_schedulerz00, 
(int)(((long)2)), 
(int)(((long)1))); 
BgL_nozd2busyzd2waitingzd2nextzd2instantz00_719 = 
make_fx_procedure(BGl_nozd2busyzd2waitingzd2nextzd2instantz00zz__ft_schedulerz00, 
(int)(((long)2)), 
(int)(((long)1))); 
PROCEDURE_SET(BgL_busyzd2waitingzd2nextzd2instantzd2_718, 
(int)(((long)0)), BgL_stopz00_321); 
PROCEDURE_SET(BgL_nozd2busyzd2waitingzd2nextzd2instantz00_719, 
(int)(((long)0)), BgL_stopz00_321); 
{ 
obj_t BgL_scdlz00_325;
{ /* ./Llib/scheduler.scm 235 */
obj_t BgL_csz00_601;
BgL_csz00_601 = BGl_za2currentzd2schedulerza2zd2zz__ft_schedulerz00; 
BGl_za2currentzd2schedulerza2zd2zz__ft_schedulerz00 = BgL_scdlz00_320; 
{ /* ./Llib/scheduler.scm 235 */
obj_t BgL_rz00_602;
BgL_scdlz00_325 = BgL_scdlz00_320; 
{ /* ./Llib/scheduler.scm 240 */
obj_t BgL_arg1651z00_328;
if(BgL_iterpz00_319)
{ /* ./Llib/scheduler.scm 240 */
BgL_arg1651z00_328 = BgL_busyzd2waitingzd2nextzd2instantzd2_718; }  else 
{ /* ./Llib/scheduler.scm 240 */
BgL_arg1651z00_328 = BgL_nozd2busyzd2waitingzd2nextzd2instantz00_719; } 
{ /* ./Llib/scheduler.scm 239 */
BgL_z52schedulerz52_bglt BgL_obj1174z00_603;obj_t BgL_val1173z00_604;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_325, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/scheduler.scm 239 */
BgL_obj1174z00_603 = 
(BgL_z52schedulerz52_bglt)(BgL_scdlz00_325); }  else 
{ /* ./Llib/scheduler.scm 239 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)19)), BGl_string2994z00zz__ft_schedulerz00, BgL_scdlz00_325); 
exit( -1 );} 
BgL_val1173z00_604 = BgL_arg1651z00_328; 
((((BgL_z52schedulerz52_bglt)CREF(BgL_obj1174z00_603))->BgL_nextzd2instantzd2) = ((obj_t)BgL_val1173z00_604), BUNSPEC); } } 
{ /* ./Llib/scheduler.scm 244 */
obj_t BgL_arg1654z00_329;
{ /* ./Llib/scheduler.scm 244 */
BgL_threadz00_bglt BgL_obj1003z00_605;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_325, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 244 */
BgL_obj1003z00_605 = 
(BgL_threadz00_bglt)(BgL_scdlz00_325); }  else 
{ /* ./Llib/scheduler.scm 244 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)19)), BGl_string2992z00zz__ft_schedulerz00, BgL_scdlz00_325); 
exit( -1 );} 
BgL_arg1654z00_329 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_605))->BgL_z52builtinz52); } 
{ /* ./Llib/scheduler.scm 244 */
bglthread_t BgL_auxz00_1619;
{ /* ./Llib/scheduler.scm 244 */
obj_t BgL_auxz00_1620;
{ /* ./Llib/scheduler.scm 244 */
obj_t BgL_aux2405z00_852;
if(
FOREIGNP(BgL_arg1654z00_329))
{ /* ./Llib/scheduler.scm 244 */
BgL_aux2405z00_852 = BgL_arg1654z00_329; }  else 
{ /* ./Llib/scheduler.scm 244 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)19)), BGl_string2993z00zz__ft_schedulerz00, BgL_arg1654z00_329); 
exit( -1 );} 
{ /* ./Llib/scheduler.scm 244 */
bool_t BgL_testz00_1626;
if(
FOREIGNP(BgL_aux2405z00_852))
{ /* ./Llib/scheduler.scm 244 */
obj_t BgL_arg1478z00_1054;obj_t BgL_arg1479z00_1055;
{ /* ./Llib/scheduler.scm 244 */
obj_t BgL_auxz00_1629;
if(
FOREIGNP(BgL_aux2405z00_852))
{ /* ./Llib/scheduler.scm 244 */
BgL_auxz00_1629 = BgL_aux2405z00_852
; }  else 
{ /* ./Llib/scheduler.scm 244 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2980z00zz__ft_schedulerz00, BgL_aux2405z00_852); 
exit( -1 );} 
BgL_arg1478z00_1054 = 
FOREIGN_ID(BgL_auxz00_1629); } 
BgL_arg1479z00_1055 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_1626 = 
(BgL_arg1478z00_1054==BgL_arg1479z00_1055); }  else 
{ /* ./Llib/scheduler.scm 244 */
BgL_testz00_1626 = ((bool_t)0)
; } 
if(BgL_testz00_1626)
{ /* ./Llib/scheduler.scm 244 */
BgL_auxz00_1620 = BgL_aux2405z00_852
; }  else 
{ /* ./Llib/scheduler.scm 244 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)19)), BGl_string2993z00zz__ft_schedulerz00, BgL_aux2405z00_852); 
exit( -1 );} } } 
BgL_auxz00_1619 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_1620); } 
bglthread_enter_scheduler(BgL_auxz00_1619); } } 
BgL_rz00_602 = BUNSPEC; 
BGl_za2currentzd2schedulerza2zd2zz__ft_schedulerz00 = BgL_csz00_601; 
return BgL_rz00_602;} } } } } } } } } 
}



/* _scheduler-start! */
obj_t BGl__schedulerzd2startz12zc0zz__ft_schedulerz00(obj_t BgL_envz00_723, obj_t BgL_argsz00_724)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 170 */
return 
BGl_schedulerzd2startz12zc0zz__ft_schedulerz00(BgL_argsz00_724);} 
}



/* busy-waiting-next-instant */
obj_t BGl_busyzd2waitingzd2nextzd2instantzd2zz__ft_schedulerz00(obj_t BgL_envz00_725, obj_t BgL_scdlz00_727, obj_t BgL_iz00_728)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 206 */
{ /* ./Llib/scheduler.scm 191 */
obj_t BgL_stopz00_726;
BgL_stopz00_726 = 
PROCEDURE_REF(BgL_envz00_725, 
(int)(((long)0))); 
{ 
obj_t BgL_scdlz00_351;obj_t BgL_iz00_352;
BgL_scdlz00_351 = BgL_scdlz00_727; 
BgL_iz00_352 = BgL_iz00_728; 
{ /* ./Llib/scheduler.scm 191 */
bool_t BgL_testz00_1646;
{ /* ./Llib/scheduler.scm 191 */
obj_t BgL_funz00_856;
if(
PROCEDUREP(BgL_stopz00_726))
{ /* ./Llib/scheduler.scm 191 */
BgL_funz00_856 = BgL_stopz00_726; }  else 
{ /* ./Llib/scheduler.scm 191 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)20)), BGl_string2986z00zz__ft_schedulerz00, BgL_stopz00_726); 
exit( -1 );} 
if(
PROCEDURE_CORRECT_ARITYP(BgL_funz00_856, ((long)1)))
{ /* ./Llib/scheduler.scm 191 */
BgL_testz00_1646 = 
CBOOL(
PROCEDURE_ENTRY(BgL_funz00_856)(BgL_stopz00_726, BgL_iz00_352, BEOA))
; }  else 
{ 
obj_t BgL_auxz00_1657;
BgL_auxz00_1657 = 
CNST_TABLE_REF(((long)21)); 
FAILURE(BGl_string3000z00zz__ft_schedulerz00,BgL_auxz00_1657,BgL_funz00_856);} } 
if(BgL_testz00_1646)
{ /* ./Llib/scheduler.scm 191 */
{ /* ./Llib/scheduler.scm 193 */
obj_t BgL_arg1702z00_355;
{ /* ./Llib/scheduler.scm 193 */
BgL_threadz00_bglt BgL_obj1003z00_615;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_351, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 193 */
BgL_obj1003z00_615 = 
(BgL_threadz00_bglt)(BgL_scdlz00_351); }  else 
{ /* ./Llib/scheduler.scm 193 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)20)), BGl_string2992z00zz__ft_schedulerz00, BgL_scdlz00_351); 
exit( -1 );} 
BgL_arg1702z00_355 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_615))->BgL_z52builtinz52); } 
{ /* ./Llib/scheduler.scm 193 */
bglthread_t BgL_auxz00_1667;
{ /* ./Llib/scheduler.scm 193 */
obj_t BgL_auxz00_1668;
{ /* ./Llib/scheduler.scm 193 */
obj_t BgL_aux2440z00_863;
if(
FOREIGNP(BgL_arg1702z00_355))
{ /* ./Llib/scheduler.scm 193 */
BgL_aux2440z00_863 = BgL_arg1702z00_355; }  else 
{ /* ./Llib/scheduler.scm 193 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)20)), BGl_string2993z00zz__ft_schedulerz00, BgL_arg1702z00_355); 
exit( -1 );} 
{ /* ./Llib/scheduler.scm 193 */
bool_t BgL_testz00_1674;
if(
FOREIGNP(BgL_aux2440z00_863))
{ /* ./Llib/scheduler.scm 193 */
obj_t BgL_arg1478z00_1058;obj_t BgL_arg1479z00_1059;
{ /* ./Llib/scheduler.scm 193 */
obj_t BgL_auxz00_1677;
if(
FOREIGNP(BgL_aux2440z00_863))
{ /* ./Llib/scheduler.scm 193 */
BgL_auxz00_1677 = BgL_aux2440z00_863
; }  else 
{ /* ./Llib/scheduler.scm 193 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2980z00zz__ft_schedulerz00, BgL_aux2440z00_863); 
exit( -1 );} 
BgL_arg1478z00_1058 = 
FOREIGN_ID(BgL_auxz00_1677); } 
BgL_arg1479z00_1059 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_1674 = 
(BgL_arg1478z00_1058==BgL_arg1479z00_1059); }  else 
{ /* ./Llib/scheduler.scm 193 */
BgL_testz00_1674 = ((bool_t)0)
; } 
if(BgL_testz00_1674)
{ /* ./Llib/scheduler.scm 193 */
BgL_auxz00_1668 = BgL_aux2440z00_863
; }  else 
{ /* ./Llib/scheduler.scm 193 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)20)), BGl_string2993z00zz__ft_schedulerz00, BgL_aux2440z00_863); 
exit( -1 );} } } 
BgL_auxz00_1667 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_1668); } 
bglthread_leave_scheduler(BgL_auxz00_1667); } } 
return BUNSPEC;}  else 
{ /* ./Llib/scheduler.scm 195 */
obj_t BgL_statez00_356;
{ /* ./Llib/scheduler.scm 195 */
BgL_schedulerz00_bglt BgL_auxz00_1691;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_351, BGl_schedulerz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 195 */
BgL_auxz00_1691 = 
(BgL_schedulerz00_bglt)(BgL_scdlz00_351)
; }  else 
{ /* ./Llib/scheduler.scm 195 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)20)), BGl_string2985z00zz__ft_schedulerz00, BgL_scdlz00_351); 
exit( -1 );} 
BgL_statez00_356 = 
BGl_schedulerzd2statezd2zz__ft_schedulerz00(BgL_auxz00_1691); } 
if(
BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(BgL_statez00_356, 
CNST_TABLE_REF(((long)13))))
{ /* ./Llib/scheduler.scm 198 */
return BTRUE;}  else 
{ /* ./Llib/scheduler.scm 198 */
if(
BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(BgL_statez00_356, 
CNST_TABLE_REF(((long)15))))
{ /* ./Llib/scheduler.scm 198 */
return BTRUE;}  else 
{ /* ./Llib/scheduler.scm 198 */
{ /* ./Llib/scheduler.scm 205 */
obj_t BgL_arg1709z00_360;
{ /* ./Llib/scheduler.scm 205 */
BgL_threadz00_bglt BgL_obj1003z00_616;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_351, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 205 */
BgL_obj1003z00_616 = 
(BgL_threadz00_bglt)(BgL_scdlz00_351); }  else 
{ /* ./Llib/scheduler.scm 205 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)20)), BGl_string2992z00zz__ft_schedulerz00, BgL_scdlz00_351); 
exit( -1 );} 
BgL_arg1709z00_360 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_616))->BgL_z52builtinz52); } 
{ /* ./Llib/scheduler.scm 205 */
bglthread_t BgL_auxz00_1712;
{ /* ./Llib/scheduler.scm 205 */
obj_t BgL_auxz00_1713;
{ /* ./Llib/scheduler.scm 205 */
obj_t BgL_aux2473z00_871;
if(
FOREIGNP(BgL_arg1709z00_360))
{ /* ./Llib/scheduler.scm 205 */
BgL_aux2473z00_871 = BgL_arg1709z00_360; }  else 
{ /* ./Llib/scheduler.scm 205 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)20)), BGl_string2993z00zz__ft_schedulerz00, BgL_arg1709z00_360); 
exit( -1 );} 
{ /* ./Llib/scheduler.scm 205 */
bool_t BgL_testz00_1719;
if(
FOREIGNP(BgL_aux2473z00_871))
{ /* ./Llib/scheduler.scm 205 */
obj_t BgL_arg1478z00_1063;obj_t BgL_arg1479z00_1064;
{ /* ./Llib/scheduler.scm 205 */
obj_t BgL_auxz00_1722;
if(
FOREIGNP(BgL_aux2473z00_871))
{ /* ./Llib/scheduler.scm 205 */
BgL_auxz00_1722 = BgL_aux2473z00_871
; }  else 
{ /* ./Llib/scheduler.scm 205 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2980z00zz__ft_schedulerz00, BgL_aux2473z00_871); 
exit( -1 );} 
BgL_arg1478z00_1063 = 
FOREIGN_ID(BgL_auxz00_1722); } 
BgL_arg1479z00_1064 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_1719 = 
(BgL_arg1478z00_1063==BgL_arg1479z00_1064); }  else 
{ /* ./Llib/scheduler.scm 205 */
BgL_testz00_1719 = ((bool_t)0)
; } 
if(BgL_testz00_1719)
{ /* ./Llib/scheduler.scm 205 */
BgL_auxz00_1713 = BgL_aux2473z00_871
; }  else 
{ /* ./Llib/scheduler.scm 205 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)20)), BGl_string2993z00zz__ft_schedulerz00, BgL_aux2473z00_871); 
exit( -1 );} } } 
BgL_auxz00_1712 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_1713); } 
bglthread_leave_scheduler(BgL_auxz00_1712); } } 
return BTRUE;} } } } } } } 
}



/* no-busy-waiting-next-instant */
obj_t BGl_nozd2busyzd2waitingzd2nextzd2instantz00zz__ft_schedulerz00(obj_t BgL_envz00_729, obj_t BgL_scdlz00_731, obj_t BgL_iz00_732)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 234 */
{ /* ./Llib/scheduler.scm 208 */
obj_t BgL_stopz00_730;
BgL_stopz00_730 = 
PROCEDURE_REF(BgL_envz00_729, 
(int)(((long)0))); 
{ 
obj_t BgL_scdlz00_331;obj_t BgL_iz00_332;
BgL_scdlz00_331 = BgL_scdlz00_731; 
BgL_iz00_332 = BgL_iz00_732; 
{ /* ./Llib/scheduler.scm 208 */
bool_t BgL_testz00_1738;
{ /* ./Llib/scheduler.scm 208 */
obj_t BgL_funz00_875;
if(
PROCEDUREP(BgL_stopz00_730))
{ /* ./Llib/scheduler.scm 208 */
BgL_funz00_875 = BgL_stopz00_730; }  else 
{ /* ./Llib/scheduler.scm 208 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string2986z00zz__ft_schedulerz00, BgL_stopz00_730); 
exit( -1 );} 
if(
PROCEDURE_CORRECT_ARITYP(BgL_funz00_875, ((long)1)))
{ /* ./Llib/scheduler.scm 208 */
BgL_testz00_1738 = 
CBOOL(
PROCEDURE_ENTRY(BgL_funz00_875)(BgL_stopz00_730, BgL_iz00_332, BEOA))
; }  else 
{ 
obj_t BgL_auxz00_1749;
BgL_auxz00_1749 = 
CNST_TABLE_REF(((long)21)); 
FAILURE(BGl_string3001z00zz__ft_schedulerz00,BgL_auxz00_1749,BgL_funz00_875);} } 
if(BgL_testz00_1738)
{ /* ./Llib/scheduler.scm 208 */
{ /* ./Llib/scheduler.scm 210 */
obj_t BgL_arg1660z00_335;
{ /* ./Llib/scheduler.scm 210 */
BgL_threadz00_bglt BgL_obj1003z00_606;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_331, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 210 */
BgL_obj1003z00_606 = 
(BgL_threadz00_bglt)(BgL_scdlz00_331); }  else 
{ /* ./Llib/scheduler.scm 210 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string2992z00zz__ft_schedulerz00, BgL_scdlz00_331); 
exit( -1 );} 
BgL_arg1660z00_335 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_606))->BgL_z52builtinz52); } 
{ /* ./Llib/scheduler.scm 210 */
bglthread_t BgL_auxz00_1759;
{ /* ./Llib/scheduler.scm 210 */
obj_t BgL_auxz00_1760;
{ /* ./Llib/scheduler.scm 210 */
obj_t BgL_aux2509z00_882;
if(
FOREIGNP(BgL_arg1660z00_335))
{ /* ./Llib/scheduler.scm 210 */
BgL_aux2509z00_882 = BgL_arg1660z00_335; }  else 
{ /* ./Llib/scheduler.scm 210 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string2993z00zz__ft_schedulerz00, BgL_arg1660z00_335); 
exit( -1 );} 
{ /* ./Llib/scheduler.scm 210 */
bool_t BgL_testz00_1766;
if(
FOREIGNP(BgL_aux2509z00_882))
{ /* ./Llib/scheduler.scm 210 */
obj_t BgL_arg1478z00_1067;obj_t BgL_arg1479z00_1068;
{ /* ./Llib/scheduler.scm 210 */
obj_t BgL_auxz00_1769;
if(
FOREIGNP(BgL_aux2509z00_882))
{ /* ./Llib/scheduler.scm 210 */
BgL_auxz00_1769 = BgL_aux2509z00_882
; }  else 
{ /* ./Llib/scheduler.scm 210 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2980z00zz__ft_schedulerz00, BgL_aux2509z00_882); 
exit( -1 );} 
BgL_arg1478z00_1067 = 
FOREIGN_ID(BgL_auxz00_1769); } 
BgL_arg1479z00_1068 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_1766 = 
(BgL_arg1478z00_1067==BgL_arg1479z00_1068); }  else 
{ /* ./Llib/scheduler.scm 210 */
BgL_testz00_1766 = ((bool_t)0)
; } 
if(BgL_testz00_1766)
{ /* ./Llib/scheduler.scm 210 */
BgL_auxz00_1760 = BgL_aux2509z00_882
; }  else 
{ /* ./Llib/scheduler.scm 210 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string2993z00zz__ft_schedulerz00, BgL_aux2509z00_882); 
exit( -1 );} } } 
BgL_auxz00_1759 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_1760); } 
bglthread_leave_scheduler(BgL_auxz00_1759); } } 
return BUNSPEC;}  else 
{ /* ./Llib/scheduler.scm 212 */
obj_t BgL_statez00_336;
{ /* ./Llib/scheduler.scm 212 */
BgL_schedulerz00_bglt BgL_auxz00_1783;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_331, BGl_schedulerz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 212 */
BgL_auxz00_1783 = 
(BgL_schedulerz00_bglt)(BgL_scdlz00_331)
; }  else 
{ /* ./Llib/scheduler.scm 212 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string2985z00zz__ft_schedulerz00, BgL_scdlz00_331); 
exit( -1 );} 
BgL_statez00_336 = 
BGl_schedulerzd2statezd2zz__ft_schedulerz00(BgL_auxz00_1783); } 
if(
BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(BgL_statez00_336, 
CNST_TABLE_REF(((long)13))))
{ /* ./Llib/scheduler.scm 215 */
return BTRUE;}  else 
{ /* ./Llib/scheduler.scm 215 */
if(
BGl_eqvzf3zf3zz__r4_equivalence_6_2z00(BgL_statez00_336, 
CNST_TABLE_REF(((long)15))))
{ /* ./Llib/scheduler.scm 215 */
{ /* ./Llib/scheduler.scm 219 */
obj_t BgL_arg1667z00_341;
{ /* ./Llib/scheduler.scm 219 */
BgL_threadz00_bglt BgL_obj1003z00_607;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_331, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 219 */
BgL_obj1003z00_607 = 
(BgL_threadz00_bglt)(BgL_scdlz00_331); }  else 
{ /* ./Llib/scheduler.scm 219 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string2992z00zz__ft_schedulerz00, BgL_scdlz00_331); 
exit( -1 );} 
BgL_arg1667z00_341 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_607))->BgL_z52builtinz52); } 
{ /* ./Llib/scheduler.scm 219 */
bglthread_t BgL_auxz00_1804;
{ /* ./Llib/scheduler.scm 219 */
obj_t BgL_auxz00_1805;
{ /* ./Llib/scheduler.scm 219 */
obj_t BgL_aux2541z00_890;
if(
FOREIGNP(BgL_arg1667z00_341))
{ /* ./Llib/scheduler.scm 219 */
BgL_aux2541z00_890 = BgL_arg1667z00_341; }  else 
{ /* ./Llib/scheduler.scm 219 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string2993z00zz__ft_schedulerz00, BgL_arg1667z00_341); 
exit( -1 );} 
{ /* ./Llib/scheduler.scm 219 */
bool_t BgL_testz00_1811;
if(
FOREIGNP(BgL_aux2541z00_890))
{ /* ./Llib/scheduler.scm 219 */
obj_t BgL_arg1478z00_1072;obj_t BgL_arg1479z00_1073;
{ /* ./Llib/scheduler.scm 219 */
obj_t BgL_auxz00_1814;
if(
FOREIGNP(BgL_aux2541z00_890))
{ /* ./Llib/scheduler.scm 219 */
BgL_auxz00_1814 = BgL_aux2541z00_890
; }  else 
{ /* ./Llib/scheduler.scm 219 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2980z00zz__ft_schedulerz00, BgL_aux2541z00_890); 
exit( -1 );} 
BgL_arg1478z00_1072 = 
FOREIGN_ID(BgL_auxz00_1814); } 
BgL_arg1479z00_1073 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_1811 = 
(BgL_arg1478z00_1072==BgL_arg1479z00_1073); }  else 
{ /* ./Llib/scheduler.scm 219 */
BgL_testz00_1811 = ((bool_t)0)
; } 
if(BgL_testz00_1811)
{ /* ./Llib/scheduler.scm 219 */
BgL_auxz00_1805 = BgL_aux2541z00_890
; }  else 
{ /* ./Llib/scheduler.scm 219 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string2993z00zz__ft_schedulerz00, BgL_aux2541z00_890); 
exit( -1 );} } } 
BgL_auxz00_1804 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_1805); } 
bglasync_synchronize(BgL_auxz00_1804); } } 
{ /* ./Llib/scheduler.scm 219 */
bool_t BgL_g1447z00_342;
{ /* ./Llib/scheduler.scm 227 */
bool_t BgL_testz00_1828;
{ /* ./Llib/scheduler.scm 227 */
bool_t BgL_testz00_1829;
{ /* ./Llib/scheduler.scm 227 */
obj_t BgL_auxz00_1830;
{ /* ./Llib/scheduler.scm 227 */
BgL_z52schedulerz52_bglt BgL_obj1205z00_608;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_331, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/scheduler.scm 227 */
BgL_obj1205z00_608 = 
(BgL_z52schedulerz52_bglt)(BgL_scdlz00_331); }  else 
{ /* ./Llib/scheduler.scm 227 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string2994z00zz__ft_schedulerz00, BgL_scdlz00_331); 
exit( -1 );} 
BgL_auxz00_1830 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_obj1205z00_608))->BgL_tobroadcastz00); } 
BgL_testz00_1829 = 
NULLP(BgL_auxz00_1830); } 
if(BgL_testz00_1829)
{ /* ./Llib/scheduler.scm 227 */
obj_t BgL_auxz00_1839;
{ /* ./Llib/scheduler.scm 227 */
BgL_z52schedulerz52_bglt BgL_obj1187z00_610;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_331, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/scheduler.scm 227 */
BgL_obj1187z00_610 = 
(BgL_z52schedulerz52_bglt)(BgL_scdlz00_331); }  else 
{ /* ./Llib/scheduler.scm 227 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string2994z00zz__ft_schedulerz00, BgL_scdlz00_331); 
exit( -1 );} 
BgL_auxz00_1839 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_obj1187z00_610))->BgL_asynczd2runnablezd2); } 
BgL_testz00_1828 = 
NULLP(BgL_auxz00_1839); }  else 
{ /* ./Llib/scheduler.scm 227 */
BgL_testz00_1828 = ((bool_t)0)
; } } 
if(BgL_testz00_1828)
{ /* ./Llib/scheduler.scm 227 */
{ /* ./Llib/scheduler.scm 229 */
obj_t BgL_arg1677z00_346;
{ /* ./Llib/scheduler.scm 229 */
BgL_threadz00_bglt BgL_obj1003z00_612;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_331, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 229 */
BgL_obj1003z00_612 = 
(BgL_threadz00_bglt)(BgL_scdlz00_331); }  else 
{ /* ./Llib/scheduler.scm 229 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string2992z00zz__ft_schedulerz00, BgL_scdlz00_331); 
exit( -1 );} 
BgL_arg1677z00_346 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_612))->BgL_z52builtinz52); } 
{ /* ./Llib/scheduler.scm 229 */
bglthread_t BgL_auxz00_1855;
{ /* ./Llib/scheduler.scm 229 */
obj_t BgL_auxz00_1856;
{ /* ./Llib/scheduler.scm 229 */
obj_t BgL_aux2580z00_900;
if(
FOREIGNP(BgL_arg1677z00_346))
{ /* ./Llib/scheduler.scm 229 */
BgL_aux2580z00_900 = BgL_arg1677z00_346; }  else 
{ /* ./Llib/scheduler.scm 229 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string2993z00zz__ft_schedulerz00, BgL_arg1677z00_346); 
exit( -1 );} 
{ /* ./Llib/scheduler.scm 229 */
bool_t BgL_testz00_1862;
if(
FOREIGNP(BgL_aux2580z00_900))
{ /* ./Llib/scheduler.scm 229 */
obj_t BgL_arg1478z00_1078;obj_t BgL_arg1479z00_1079;
{ /* ./Llib/scheduler.scm 229 */
obj_t BgL_auxz00_1865;
if(
FOREIGNP(BgL_aux2580z00_900))
{ /* ./Llib/scheduler.scm 229 */
BgL_auxz00_1865 = BgL_aux2580z00_900
; }  else 
{ /* ./Llib/scheduler.scm 229 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2980z00zz__ft_schedulerz00, BgL_aux2580z00_900); 
exit( -1 );} 
BgL_arg1478z00_1078 = 
FOREIGN_ID(BgL_auxz00_1865); } 
BgL_arg1479z00_1079 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_1862 = 
(BgL_arg1478z00_1078==BgL_arg1479z00_1079); }  else 
{ /* ./Llib/scheduler.scm 229 */
BgL_testz00_1862 = ((bool_t)0)
; } 
if(BgL_testz00_1862)
{ /* ./Llib/scheduler.scm 229 */
BgL_auxz00_1856 = BgL_aux2580z00_900
; }  else 
{ /* ./Llib/scheduler.scm 229 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string2993z00zz__ft_schedulerz00, BgL_aux2580z00_900); 
exit( -1 );} } } 
BgL_auxz00_1855 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_1856); } 
bglasync_scheduler_wait(BgL_auxz00_1855); } } BUNSPEC; }  else 
{ /* ./Llib/scheduler.scm 227 */BFALSE; } } 
BgL_g1447z00_342 = ((bool_t)1); 
{ /* ./Llib/scheduler.scm 219 */
obj_t BgL_arg1671z00_343;
{ /* ./Llib/scheduler.scm 219 */
BgL_threadz00_bglt BgL_obj1003z00_613;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_331, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 219 */
BgL_obj1003z00_613 = 
(BgL_threadz00_bglt)(BgL_scdlz00_331); }  else 
{ /* ./Llib/scheduler.scm 219 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string2992z00zz__ft_schedulerz00, BgL_scdlz00_331); 
exit( -1 );} 
BgL_arg1671z00_343 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_613))->BgL_z52builtinz52); } 
{ /* ./Llib/scheduler.scm 219 */
bglthread_t BgL_auxz00_1886;
{ /* ./Llib/scheduler.scm 219 */
obj_t BgL_auxz00_1887;
{ /* ./Llib/scheduler.scm 219 */
obj_t BgL_aux2604z00_906;
if(
FOREIGNP(BgL_arg1671z00_343))
{ /* ./Llib/scheduler.scm 219 */
BgL_aux2604z00_906 = BgL_arg1671z00_343; }  else 
{ /* ./Llib/scheduler.scm 219 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string2993z00zz__ft_schedulerz00, BgL_arg1671z00_343); 
exit( -1 );} 
{ /* ./Llib/scheduler.scm 219 */
bool_t BgL_testz00_1893;
if(
FOREIGNP(BgL_aux2604z00_906))
{ /* ./Llib/scheduler.scm 219 */
obj_t BgL_arg1478z00_1082;obj_t BgL_arg1479z00_1083;
{ /* ./Llib/scheduler.scm 219 */
obj_t BgL_auxz00_1896;
if(
FOREIGNP(BgL_aux2604z00_906))
{ /* ./Llib/scheduler.scm 219 */
BgL_auxz00_1896 = BgL_aux2604z00_906
; }  else 
{ /* ./Llib/scheduler.scm 219 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2980z00zz__ft_schedulerz00, BgL_aux2604z00_906); 
exit( -1 );} 
BgL_arg1478z00_1082 = 
FOREIGN_ID(BgL_auxz00_1896); } 
BgL_arg1479z00_1083 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_1893 = 
(BgL_arg1478z00_1082==BgL_arg1479z00_1083); }  else 
{ /* ./Llib/scheduler.scm 219 */
BgL_testz00_1893 = ((bool_t)0)
; } 
if(BgL_testz00_1893)
{ /* ./Llib/scheduler.scm 219 */
BgL_auxz00_1887 = BgL_aux2604z00_906
; }  else 
{ /* ./Llib/scheduler.scm 219 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string2993z00zz__ft_schedulerz00, BgL_aux2604z00_906); 
exit( -1 );} } } 
BgL_auxz00_1886 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_1887); } 
bglasync_asynchronize(BgL_auxz00_1886); } } 
return 
BBOOL(BgL_g1447z00_342);} }  else 
{ /* ./Llib/scheduler.scm 215 */
{ /* ./Llib/scheduler.scm 233 */
obj_t BgL_arg1691z00_350;
{ /* ./Llib/scheduler.scm 233 */
BgL_threadz00_bglt BgL_obj1003z00_614;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_331, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 233 */
BgL_obj1003z00_614 = 
(BgL_threadz00_bglt)(BgL_scdlz00_331); }  else 
{ /* ./Llib/scheduler.scm 233 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string2992z00zz__ft_schedulerz00, BgL_scdlz00_331); 
exit( -1 );} 
BgL_arg1691z00_350 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_614))->BgL_z52builtinz52); } 
{ /* ./Llib/scheduler.scm 233 */
bglthread_t BgL_auxz00_1918;
{ /* ./Llib/scheduler.scm 233 */
obj_t BgL_auxz00_1919;
{ /* ./Llib/scheduler.scm 233 */
obj_t BgL_aux2628z00_912;
if(
FOREIGNP(BgL_arg1691z00_350))
{ /* ./Llib/scheduler.scm 233 */
BgL_aux2628z00_912 = BgL_arg1691z00_350; }  else 
{ /* ./Llib/scheduler.scm 233 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string2993z00zz__ft_schedulerz00, BgL_arg1691z00_350); 
exit( -1 );} 
{ /* ./Llib/scheduler.scm 233 */
bool_t BgL_testz00_1925;
if(
FOREIGNP(BgL_aux2628z00_912))
{ /* ./Llib/scheduler.scm 233 */
obj_t BgL_arg1478z00_1086;obj_t BgL_arg1479z00_1087;
{ /* ./Llib/scheduler.scm 233 */
obj_t BgL_auxz00_1928;
if(
FOREIGNP(BgL_aux2628z00_912))
{ /* ./Llib/scheduler.scm 233 */
BgL_auxz00_1928 = BgL_aux2628z00_912
; }  else 
{ /* ./Llib/scheduler.scm 233 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2980z00zz__ft_schedulerz00, BgL_aux2628z00_912); 
exit( -1 );} 
BgL_arg1478z00_1086 = 
FOREIGN_ID(BgL_auxz00_1928); } 
BgL_arg1479z00_1087 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_1925 = 
(BgL_arg1478z00_1086==BgL_arg1479z00_1087); }  else 
{ /* ./Llib/scheduler.scm 233 */
BgL_testz00_1925 = ((bool_t)0)
; } 
if(BgL_testz00_1925)
{ /* ./Llib/scheduler.scm 233 */
BgL_auxz00_1919 = BgL_aux2628z00_912
; }  else 
{ /* ./Llib/scheduler.scm 233 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string2993z00zz__ft_schedulerz00, BgL_aux2628z00_912); 
exit( -1 );} } } 
BgL_auxz00_1918 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_1919); } 
bglthread_leave_scheduler(BgL_auxz00_1918); } } 
return BTRUE;} } } } } } } 
}



/* <anonymous:1717> */
obj_t BGl_zc3anonymousza31717ze3z83zz__ft_schedulerz00(obj_t BgL_envz00_733, obj_t BgL_iz00_734)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 177 */
return 
BBOOL(((bool_t)0));} 
}



/* <anonymous:1719> */
obj_t BGl_zc3anonymousza31719ze3z83zz__ft_schedulerz00(obj_t BgL_envz00_735, obj_t BgL_iz00_737)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 181 */
{ /* ./Llib/scheduler.scm 182 */
obj_t BgL_stz00_736;
BgL_stz00_736 = 
PROCEDURE_REF(BgL_envz00_735, 
(int)(((long)0))); 
{ 
obj_t BgL_iz00_368;
{ /* ./Llib/scheduler.scm 182 */
bool_t BgL_auxz00_1945;
BgL_iz00_368 = BgL_iz00_737; 
BgL_auxz00_1945 = 
BGl_2ze3zd3z30zz__r4_numbers_6_5z00(BgL_iz00_368, BgL_stz00_736); 
return 
BBOOL(BgL_auxz00_1945);} } } } 
}



/* <anonymous:1733> */
obj_t BGl_zc3anonymousza31733ze3z83zz__ft_schedulerz00(obj_t BgL_envz00_738, obj_t BgL_iz00_740)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 184 */
{ /* ./Llib/scheduler.scm 185 */
obj_t BgL_argsz00_739;
BgL_argsz00_739 = 
PROCEDURE_REF(BgL_envz00_738, 
(int)(((long)0))); 
{ 
obj_t BgL_iz00_375;
BgL_iz00_375 = BgL_iz00_740; 
{ /* ./Llib/scheduler.scm 185 */
obj_t BgL_fun1736z00_595;
{ /* ./Llib/scheduler.scm 185 */
obj_t BgL_pairz00_596;
if(
PAIRP(BgL_argsz00_739))
{ /* ./Llib/scheduler.scm 185 */
BgL_pairz00_596 = BgL_argsz00_739; }  else 
{ /* ./Llib/scheduler.scm 185 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)23)), BGl_string2981z00zz__ft_schedulerz00, BgL_argsz00_739); 
exit( -1 );} 
BgL_fun1736z00_595 = 
CAR(BgL_pairz00_596); } 
{ /* ./Llib/scheduler.scm 185 */
obj_t BgL_funz00_918;
if(
PROCEDUREP(BgL_fun1736z00_595))
{ /* ./Llib/scheduler.scm 185 */
BgL_funz00_918 = BgL_fun1736z00_595; }  else 
{ /* ./Llib/scheduler.scm 185 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)23)), BGl_string2986z00zz__ft_schedulerz00, BgL_fun1736z00_595); 
exit( -1 );} 
if(
PROCEDURE_CORRECT_ARITYP(BgL_funz00_918, ((long)1)))
{ /* ./Llib/scheduler.scm 185 */
return 
PROCEDURE_ENTRY(BgL_funz00_918)(BgL_fun1736z00_595, BgL_iz00_375, BEOA);}  else 
{ 
obj_t BgL_auxz00_1965;
BgL_auxz00_1965 = 
CNST_TABLE_REF(((long)24)); 
FAILURE(BGl_string3002z00zz__ft_schedulerz00,BgL_auxz00_1965,BgL_funz00_918);} } } } } } 
}



/* broadcast! */
BGL_EXPORTED_DEF obj_t BGl_broadcastz12z12zz__ft_schedulerz00(obj_t BgL_sigz00_14, obj_t BgL_valz00_15)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 250 */
{ /* ./Llib/scheduler.scm 251 */
obj_t BgL_tz00_386;obj_t BgL_vz00_387;
BgL_tz00_386 = 
BGl_currentzd2threadzd2zz__ft_threadz00(); 
if(
PAIRP(BgL_valz00_15))
{ /* ./Llib/scheduler.scm 252 */
obj_t BgL_pairz00_618;
if(
PAIRP(BgL_valz00_15))
{ /* ./Llib/scheduler.scm 252 */
BgL_pairz00_618 = BgL_valz00_15; }  else 
{ /* ./Llib/scheduler.scm 252 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)25)), BGl_string2981z00zz__ft_schedulerz00, BgL_valz00_15); 
exit( -1 );} 
BgL_vz00_387 = 
CAR(BgL_pairz00_618); }  else 
{ /* ./Llib/scheduler.scm 252 */
BgL_vz00_387 = BUNSPEC; } 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_tz00_386, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 254 */
bool_t BgL_testz00_1979;
{ /* ./Llib/scheduler.scm 254 */
BgL_threadz00_bglt BgL_auxz00_1980;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_tz00_386, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 254 */
BgL_auxz00_1980 = 
(BgL_threadz00_bglt)(BgL_tz00_386)
; }  else 
{ /* ./Llib/scheduler.scm 254 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)25)), BGl_string2992z00zz__ft_schedulerz00, BgL_tz00_386); 
exit( -1 );} 
BgL_testz00_1979 = 
BGl_z52threadzd2attachedzf3z73zz__ft_z52threadz52(BgL_auxz00_1980); } 
if(BgL_testz00_1979)
{ /* ./Llib/scheduler.scm 256 */
obj_t BgL_arg1765z00_391;
{ /* ./Llib/scheduler.scm 256 */
BgL_threadz00_bglt BgL_obj1047z00_620;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_tz00_386, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 256 */
BgL_obj1047z00_620 = 
(BgL_threadz00_bglt)(BgL_tz00_386); }  else 
{ /* ./Llib/scheduler.scm 256 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)25)), BGl_string2992z00zz__ft_schedulerz00, BgL_tz00_386); 
exit( -1 );} 
BgL_arg1765z00_391 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1047z00_620))->BgL_schedulerz00); } 
{ /* ./Llib/scheduler.scm 256 */
BgL_z52schedulerz52_bglt BgL_auxz00_1995;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_arg1765z00_391, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/scheduler.scm 256 */
BgL_auxz00_1995 = 
(BgL_z52schedulerz52_bglt)(BgL_arg1765z00_391)
; }  else 
{ /* ./Llib/scheduler.scm 256 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)25)), BGl_string2994z00zz__ft_schedulerz00, BgL_arg1765z00_391); 
exit( -1 );} 
return 
BGl_z52broadcastz12z40zz__ft_z52schedulerz52(BgL_auxz00_1995, BgL_sigz00_14, BgL_vz00_387);} }  else 
{ /* ./Llib/scheduler.scm 254 */
FAILURE(BGl_string3003z00zz__ft_schedulerz00,BGl_string3004z00zz__ft_schedulerz00,BgL_tz00_386);} }  else 
{ /* ./Llib/scheduler.scm 253 */
return BFALSE;} } } 
}



/* _broadcast! */
obj_t BGl__broadcastz12z12zz__ft_schedulerz00(obj_t BgL_envz00_741, obj_t BgL_sigz00_742, obj_t BgL_valz00_743)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 250 */
return 
BGl_broadcastz12z12zz__ft_schedulerz00(BgL_sigz00_742, BgL_valz00_743);} 
}



/* scheduler-broadcast! */
BGL_EXPORTED_DEF obj_t BGl_schedulerzd2broadcastz12zc0zz__ft_schedulerz00(BgL_schedulerz00_bglt BgL_sz00_16, obj_t BgL_sigz00_17, obj_t BgL_valz00_18)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 262 */
{ /* ./Llib/scheduler.scm 263 */
obj_t BgL_arg1777z00_624;
if(
PAIRP(BgL_valz00_18))
{ /* ./Llib/scheduler.scm 263 */
obj_t BgL_pairz00_627;
if(
PAIRP(BgL_valz00_18))
{ /* ./Llib/scheduler.scm 263 */
BgL_pairz00_627 = BgL_valz00_18; }  else 
{ /* ./Llib/scheduler.scm 263 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)26)), BGl_string2981z00zz__ft_schedulerz00, BgL_valz00_18); 
exit( -1 );} 
BgL_arg1777z00_624 = 
CAR(BgL_pairz00_627); }  else 
{ /* ./Llib/scheduler.scm 263 */
BgL_arg1777z00_624 = BUNSPEC; } 
{ /* ./Llib/scheduler.scm 263 */
BgL_z52schedulerz52_bglt BgL_auxz00_2013;
{ /* ./Llib/scheduler.scm 263 */
obj_t BgL_aux22698z00_932;
BgL_aux22698z00_932 = 
((obj_t)BgL_sz00_16); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22698z00_932, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/scheduler.scm 263 */
BgL_auxz00_2013 = 
(BgL_z52schedulerz52_bglt)(BgL_sz00_16)
; }  else 
{ /* ./Llib/scheduler.scm 263 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)26)), BGl_string2994z00zz__ft_schedulerz00, 
(obj_t)(BgL_sz00_16)); 
exit( -1 );} } 
return 
BGl_z52schedulerzd2addzd2broadcastz12z40zz__ft_z52schedulerz52(BgL_auxz00_2013, BgL_sigz00_17, BgL_arg1777z00_624);} } } 
}



/* _scheduler-broadcast! */
obj_t BGl__schedulerzd2broadcastz12zc0zz__ft_schedulerz00(obj_t BgL_envz00_744, obj_t BgL_sz00_745, obj_t BgL_sigz00_746, obj_t BgL_valz00_747)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 262 */
{ /* ./Llib/scheduler.scm 263 */
BgL_schedulerz00_bglt BgL_auxz00_2023;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_sz00_745, BGl_schedulerz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 263 */
BgL_auxz00_2023 = 
(BgL_schedulerz00_bglt)(BgL_sz00_745)
; }  else 
{ /* ./Llib/scheduler.scm 263 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)27)), BGl_string2985z00zz__ft_schedulerz00, BgL_sz00_745); 
exit( -1 );} 
return 
BGl_schedulerzd2broadcastz12zc0zz__ft_schedulerz00(BgL_auxz00_2023, BgL_sigz00_746, BgL_valz00_747);} } 
}



/* scheduler-terminate! */
BGL_EXPORTED_DEF obj_t BGl_schedulerzd2terminatez12zc0zz__ft_schedulerz00(obj_t BgL_sz00_19)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 268 */
{ /* ./Llib/scheduler.scm 269 */
obj_t BgL_sz00_395;
if(
NULLP(BgL_sz00_19))
{ /* ./Llib/scheduler.scm 270 */
BgL_sz00_395 = 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BNIL); }  else 
{ /* ./Llib/scheduler.scm 272 */
bool_t BgL_testz00_2034;
{ /* ./Llib/scheduler.scm 272 */
obj_t BgL_arg1892z00_440;
{ /* ./Llib/scheduler.scm 272 */
obj_t BgL_pairz00_629;
if(
PAIRP(BgL_sz00_19))
{ /* ./Llib/scheduler.scm 272 */
BgL_pairz00_629 = BgL_sz00_19; }  else 
{ /* ./Llib/scheduler.scm 272 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2981z00zz__ft_schedulerz00, BgL_sz00_19); 
exit( -1 );} 
BgL_arg1892z00_440 = 
CAR(BgL_pairz00_629); } 
BgL_testz00_2034 = 
BGl_iszd2azf3z21zz__objectz00(BgL_arg1892z00_440, BGl_schedulerz00zz__ft_typesz00); } 
if(BgL_testz00_2034)
{ /* ./Llib/scheduler.scm 273 */
obj_t BgL_pairz00_631;
if(
PAIRP(BgL_sz00_19))
{ /* ./Llib/scheduler.scm 273 */
BgL_pairz00_631 = BgL_sz00_19; }  else 
{ /* ./Llib/scheduler.scm 273 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2981z00zz__ft_schedulerz00, BgL_sz00_19); 
exit( -1 );} 
BgL_sz00_395 = 
CAR(BgL_pairz00_631); }  else 
{ /* ./Llib/scheduler.scm 275 */
obj_t BgL_arg1888z00_439;
{ /* ./Llib/scheduler.scm 277 */
obj_t BgL_pairz00_632;
if(
PAIRP(BgL_sz00_19))
{ /* ./Llib/scheduler.scm 277 */
BgL_pairz00_632 = BgL_sz00_19; }  else 
{ /* ./Llib/scheduler.scm 277 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2981z00zz__ft_schedulerz00, BgL_sz00_19); 
exit( -1 );} 
BgL_arg1888z00_439 = 
CAR(BgL_pairz00_632); } 
FAILURE(BGl_string3005z00zz__ft_schedulerz00,BGl_string2983z00zz__ft_schedulerz00,BgL_arg1888z00_439);} } 
{ /* ./Llib/scheduler.scm 294 */
obj_t BgL_arg1783z00_397;
{ /* ./Llib/scheduler.scm 294 */
BgL_z52schedulerz52_bglt BgL_obj1175z00_636;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_sz00_395, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/scheduler.scm 294 */
BgL_obj1175z00_636 = 
(BgL_z52schedulerz52_bglt)(BgL_sz00_395); }  else 
{ /* ./Llib/scheduler.scm 294 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2994z00zz__ft_schedulerz00, BgL_sz00_395); 
exit( -1 );} 
BgL_arg1783z00_397 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_obj1175z00_636))->BgL_currentzd2threadzd2); } 
{ /* ./Llib/scheduler.scm 294 */
BgL_threadz00_bglt BgL_auxz00_2062;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_arg1783z00_397, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 294 */
BgL_auxz00_2062 = 
(BgL_threadz00_bglt)(BgL_arg1783z00_397)
; }  else 
{ /* ./Llib/scheduler.scm 294 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2992z00zz__ft_schedulerz00, BgL_arg1783z00_397); 
exit( -1 );} 
BGl_threadzd2terminatez12zc0zz__ft_threadz00(BgL_auxz00_2062); } } 
{ 
obj_t BgL_l1458z00_398;
{ /* ./Llib/scheduler.scm 295 */
obj_t BgL_arg1787z00_400;
{ /* ./Llib/scheduler.scm 295 */
BgL_z52schedulerz52_bglt BgL_obj1202z00_637;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_sz00_395, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/scheduler.scm 295 */
BgL_obj1202z00_637 = 
(BgL_z52schedulerz52_bglt)(BgL_sz00_395); }  else 
{ /* ./Llib/scheduler.scm 295 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2994z00zz__ft_schedulerz00, BgL_sz00_395); 
exit( -1 );} 
BgL_arg1787z00_400 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_obj1202z00_637))->BgL_tosuspendzf2resumezf2); } 
BgL_l1458z00_398 = BgL_arg1787z00_400; 
BgL_forzd2each1459zd2_399:
if(
PAIRP(BgL_l1458z00_398))
{ /* ./Llib/scheduler.scm 295 */
{ /* ./Llib/scheduler.scm 295 */
obj_t BgL_arg1792z00_402;
{ /* ./Llib/scheduler.scm 295 */
obj_t BgL_pairz00_639;
if(
PAIRP(BgL_l1458z00_398))
{ /* ./Llib/scheduler.scm 295 */
BgL_pairz00_639 = BgL_l1458z00_398; }  else 
{ /* ./Llib/scheduler.scm 295 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2981z00zz__ft_schedulerz00, BgL_l1458z00_398); 
exit( -1 );} 
BgL_arg1792z00_402 = 
CAR(BgL_pairz00_639); } 
{ /* ./Llib/scheduler.scm 295 */
BgL_threadz00_bglt BgL_auxz00_2085;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_arg1792z00_402, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 295 */
BgL_auxz00_2085 = 
(BgL_threadz00_bglt)(BgL_arg1792z00_402)
; }  else 
{ /* ./Llib/scheduler.scm 295 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2992z00zz__ft_schedulerz00, BgL_arg1792z00_402); 
exit( -1 );} 
BGl_threadzd2terminatez12zc0zz__ft_threadz00(BgL_auxz00_2085); } } 
{ /* ./Llib/scheduler.scm 295 */
obj_t BgL_arg1796z00_403;
{ /* ./Llib/scheduler.scm 295 */
obj_t BgL_pairz00_640;
if(
PAIRP(BgL_l1458z00_398))
{ /* ./Llib/scheduler.scm 295 */
BgL_pairz00_640 = BgL_l1458z00_398; }  else 
{ /* ./Llib/scheduler.scm 295 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2981z00zz__ft_schedulerz00, BgL_l1458z00_398); 
exit( -1 );} 
BgL_arg1796z00_403 = 
CDR(BgL_pairz00_640); } 
{ 
obj_t BgL_l1458z00_2099;
BgL_l1458z00_2099 = BgL_arg1796z00_403; 
BgL_l1458z00_398 = BgL_l1458z00_2099; 
goto BgL_forzd2each1459zd2_399;} } }  else 
{ /* ./Llib/scheduler.scm 295 */
if(
NULLP(BgL_l1458z00_398))
{ /* ./Llib/scheduler.scm 295 */BTRUE; }  else 
{ /* ./Llib/scheduler.scm 295 */
FAILURE(BGl_string3006z00zz__ft_schedulerz00,BGl_string3007z00zz__ft_schedulerz00,BgL_l1458z00_398);} } } } 
{ 
obj_t BgL_l1460z00_405;
{ /* ./Llib/scheduler.scm 296 */
obj_t BgL_arg1804z00_407;
{ /* ./Llib/scheduler.scm 296 */
BgL_z52schedulerz52_bglt BgL_obj1184z00_645;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_sz00_395, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/scheduler.scm 296 */
BgL_obj1184z00_645 = 
(BgL_z52schedulerz52_bglt)(BgL_sz00_395); }  else 
{ /* ./Llib/scheduler.scm 296 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2994z00zz__ft_schedulerz00, BgL_sz00_395); 
exit( -1 );} 
BgL_arg1804z00_407 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_obj1184z00_645))->BgL_threadszd2runnablezd2); } 
BgL_l1460z00_405 = BgL_arg1804z00_407; 
BgL_forzd2each1461zd2_406:
if(
PAIRP(BgL_l1460z00_405))
{ /* ./Llib/scheduler.scm 296 */
{ /* ./Llib/scheduler.scm 296 */
obj_t BgL_arg1809z00_409;
{ /* ./Llib/scheduler.scm 296 */
obj_t BgL_pairz00_647;
if(
PAIRP(BgL_l1460z00_405))
{ /* ./Llib/scheduler.scm 296 */
BgL_pairz00_647 = BgL_l1460z00_405; }  else 
{ /* ./Llib/scheduler.scm 296 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2981z00zz__ft_schedulerz00, BgL_l1460z00_405); 
exit( -1 );} 
BgL_arg1809z00_409 = 
CAR(BgL_pairz00_647); } 
{ /* ./Llib/scheduler.scm 296 */
BgL_threadz00_bglt BgL_auxz00_2118;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_arg1809z00_409, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 296 */
BgL_auxz00_2118 = 
(BgL_threadz00_bglt)(BgL_arg1809z00_409)
; }  else 
{ /* ./Llib/scheduler.scm 296 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2992z00zz__ft_schedulerz00, BgL_arg1809z00_409); 
exit( -1 );} 
BGl_threadzd2terminatez12zc0zz__ft_threadz00(BgL_auxz00_2118); } } 
{ /* ./Llib/scheduler.scm 296 */
obj_t BgL_arg1815z00_410;
{ /* ./Llib/scheduler.scm 296 */
obj_t BgL_pairz00_648;
if(
PAIRP(BgL_l1460z00_405))
{ /* ./Llib/scheduler.scm 296 */
BgL_pairz00_648 = BgL_l1460z00_405; }  else 
{ /* ./Llib/scheduler.scm 296 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2981z00zz__ft_schedulerz00, BgL_l1460z00_405); 
exit( -1 );} 
BgL_arg1815z00_410 = 
CDR(BgL_pairz00_648); } 
{ 
obj_t BgL_l1460z00_2132;
BgL_l1460z00_2132 = BgL_arg1815z00_410; 
BgL_l1460z00_405 = BgL_l1460z00_2132; 
goto BgL_forzd2each1461zd2_406;} } }  else 
{ /* ./Llib/scheduler.scm 296 */
if(
NULLP(BgL_l1460z00_405))
{ /* ./Llib/scheduler.scm 296 */BTRUE; }  else 
{ /* ./Llib/scheduler.scm 296 */
FAILURE(BGl_string3006z00zz__ft_schedulerz00,BGl_string3007z00zz__ft_schedulerz00,BgL_l1460z00_405);} } } } 
{ 
obj_t BgL_l1462z00_412;
{ /* ./Llib/scheduler.scm 297 */
obj_t BgL_arg1823z00_414;
{ /* ./Llib/scheduler.scm 297 */
BgL_z52schedulerz52_bglt BgL_obj1193z00_653;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_sz00_395, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/scheduler.scm 297 */
BgL_obj1193z00_653 = 
(BgL_z52schedulerz52_bglt)(BgL_sz00_395); }  else 
{ /* ./Llib/scheduler.scm 297 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2994z00zz__ft_schedulerz00, BgL_sz00_395); 
exit( -1 );} 
BgL_arg1823z00_414 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_obj1193z00_653))->BgL_threadszd2yieldzd2); } 
BgL_l1462z00_412 = BgL_arg1823z00_414; 
BgL_forzd2each1463zd2_413:
if(
PAIRP(BgL_l1462z00_412))
{ /* ./Llib/scheduler.scm 297 */
{ /* ./Llib/scheduler.scm 297 */
obj_t BgL_arg1828z00_416;
{ /* ./Llib/scheduler.scm 297 */
obj_t BgL_pairz00_655;
if(
PAIRP(BgL_l1462z00_412))
{ /* ./Llib/scheduler.scm 297 */
BgL_pairz00_655 = BgL_l1462z00_412; }  else 
{ /* ./Llib/scheduler.scm 297 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2981z00zz__ft_schedulerz00, BgL_l1462z00_412); 
exit( -1 );} 
BgL_arg1828z00_416 = 
CAR(BgL_pairz00_655); } 
{ /* ./Llib/scheduler.scm 297 */
BgL_threadz00_bglt BgL_auxz00_2151;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_arg1828z00_416, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 297 */
BgL_auxz00_2151 = 
(BgL_threadz00_bglt)(BgL_arg1828z00_416)
; }  else 
{ /* ./Llib/scheduler.scm 297 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2992z00zz__ft_schedulerz00, BgL_arg1828z00_416); 
exit( -1 );} 
BGl_threadzd2terminatez12zc0zz__ft_threadz00(BgL_auxz00_2151); } } 
{ /* ./Llib/scheduler.scm 297 */
obj_t BgL_arg1833z00_417;
{ /* ./Llib/scheduler.scm 297 */
obj_t BgL_pairz00_656;
if(
PAIRP(BgL_l1462z00_412))
{ /* ./Llib/scheduler.scm 297 */
BgL_pairz00_656 = BgL_l1462z00_412; }  else 
{ /* ./Llib/scheduler.scm 297 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2981z00zz__ft_schedulerz00, BgL_l1462z00_412); 
exit( -1 );} 
BgL_arg1833z00_417 = 
CDR(BgL_pairz00_656); } 
{ 
obj_t BgL_l1462z00_2165;
BgL_l1462z00_2165 = BgL_arg1833z00_417; 
BgL_l1462z00_412 = BgL_l1462z00_2165; 
goto BgL_forzd2each1463zd2_413;} } }  else 
{ /* ./Llib/scheduler.scm 297 */
if(
NULLP(BgL_l1462z00_412))
{ /* ./Llib/scheduler.scm 297 */BTRUE; }  else 
{ /* ./Llib/scheduler.scm 297 */
FAILURE(BGl_string3006z00zz__ft_schedulerz00,BGl_string3007z00zz__ft_schedulerz00,BgL_l1462z00_412);} } } } 
{ 
obj_t BgL_l1464z00_419;
{ /* ./Llib/scheduler.scm 298 */
obj_t BgL_arg1841z00_421;
{ /* ./Llib/scheduler.scm 298 */
BgL_z52schedulerz52_bglt BgL_obj1190z00_661;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_sz00_395, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/scheduler.scm 298 */
BgL_obj1190z00_661 = 
(BgL_z52schedulerz52_bglt)(BgL_sz00_395); }  else 
{ /* ./Llib/scheduler.scm 298 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2994z00zz__ft_schedulerz00, BgL_sz00_395); 
exit( -1 );} 
BgL_arg1841z00_421 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_obj1190z00_661))->BgL_threadszd2timeoutzd2); } 
BgL_l1464z00_419 = BgL_arg1841z00_421; 
BgL_forzd2each1465zd2_420:
if(
PAIRP(BgL_l1464z00_419))
{ /* ./Llib/scheduler.scm 298 */
{ /* ./Llib/scheduler.scm 298 */
obj_t BgL_arg1846z00_423;
{ /* ./Llib/scheduler.scm 298 */
obj_t BgL_pairz00_663;
if(
PAIRP(BgL_l1464z00_419))
{ /* ./Llib/scheduler.scm 298 */
BgL_pairz00_663 = BgL_l1464z00_419; }  else 
{ /* ./Llib/scheduler.scm 298 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2981z00zz__ft_schedulerz00, BgL_l1464z00_419); 
exit( -1 );} 
BgL_arg1846z00_423 = 
CAR(BgL_pairz00_663); } 
{ /* ./Llib/scheduler.scm 298 */
BgL_threadz00_bglt BgL_auxz00_2184;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_arg1846z00_423, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 298 */
BgL_auxz00_2184 = 
(BgL_threadz00_bglt)(BgL_arg1846z00_423)
; }  else 
{ /* ./Llib/scheduler.scm 298 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2992z00zz__ft_schedulerz00, BgL_arg1846z00_423); 
exit( -1 );} 
BGl_threadzd2terminatez12zc0zz__ft_threadz00(BgL_auxz00_2184); } } 
{ /* ./Llib/scheduler.scm 298 */
obj_t BgL_arg1850z00_424;
{ /* ./Llib/scheduler.scm 298 */
obj_t BgL_pairz00_664;
if(
PAIRP(BgL_l1464z00_419))
{ /* ./Llib/scheduler.scm 298 */
BgL_pairz00_664 = BgL_l1464z00_419; }  else 
{ /* ./Llib/scheduler.scm 298 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2981z00zz__ft_schedulerz00, BgL_l1464z00_419); 
exit( -1 );} 
BgL_arg1850z00_424 = 
CDR(BgL_pairz00_664); } 
{ 
obj_t BgL_l1464z00_2198;
BgL_l1464z00_2198 = BgL_arg1850z00_424; 
BgL_l1464z00_419 = BgL_l1464z00_2198; 
goto BgL_forzd2each1465zd2_420;} } }  else 
{ /* ./Llib/scheduler.scm 298 */
if(
NULLP(BgL_l1464z00_419))
{ /* ./Llib/scheduler.scm 298 */BTRUE; }  else 
{ /* ./Llib/scheduler.scm 298 */
FAILURE(BGl_string3006z00zz__ft_schedulerz00,BGl_string3007z00zz__ft_schedulerz00,BgL_l1464z00_419);} } } } 
{ 
obj_t BgL_l1466z00_426;
{ /* ./Llib/scheduler.scm 300 */
obj_t BgL_arg1858z00_428;
{ /* ./Llib/scheduler.scm 300 */
BgL_z52schedulerz52_bglt BgL_auxz00_2202;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_sz00_395, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/scheduler.scm 300 */
BgL_auxz00_2202 = 
(BgL_z52schedulerz52_bglt)(BgL_sz00_395)
; }  else 
{ /* ./Llib/scheduler.scm 300 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2994z00zz__ft_schedulerz00, BgL_sz00_395); 
exit( -1 );} 
BgL_arg1858z00_428 = 
BGl_z52schedulerzd2waitingzd2threadsz52zz__ft_z52schedulerz52(BgL_auxz00_2202); } 
BgL_l1466z00_426 = BgL_arg1858z00_428; 
BgL_forzd2each1467zd2_427:
if(
PAIRP(BgL_l1466z00_426))
{ /* ./Llib/scheduler.scm 300 */
{ /* ./Llib/scheduler.scm 300 */
obj_t BgL_arg1863z00_430;
{ /* ./Llib/scheduler.scm 300 */
obj_t BgL_pairz00_670;
if(
PAIRP(BgL_l1466z00_426))
{ /* ./Llib/scheduler.scm 300 */
BgL_pairz00_670 = BgL_l1466z00_426; }  else 
{ /* ./Llib/scheduler.scm 300 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2981z00zz__ft_schedulerz00, BgL_l1466z00_426); 
exit( -1 );} 
BgL_arg1863z00_430 = 
CAR(BgL_pairz00_670); } 
{ /* ./Llib/scheduler.scm 300 */
BgL_threadz00_bglt BgL_auxz00_2218;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_arg1863z00_430, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 300 */
BgL_auxz00_2218 = 
(BgL_threadz00_bglt)(BgL_arg1863z00_430)
; }  else 
{ /* ./Llib/scheduler.scm 300 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2992z00zz__ft_schedulerz00, BgL_arg1863z00_430); 
exit( -1 );} 
BGl_threadzd2terminatez12zc0zz__ft_threadz00(BgL_auxz00_2218); } } 
{ /* ./Llib/scheduler.scm 300 */
obj_t BgL_arg1868z00_431;
{ /* ./Llib/scheduler.scm 300 */
obj_t BgL_pairz00_671;
if(
PAIRP(BgL_l1466z00_426))
{ /* ./Llib/scheduler.scm 300 */
BgL_pairz00_671 = BgL_l1466z00_426; }  else 
{ /* ./Llib/scheduler.scm 300 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2981z00zz__ft_schedulerz00, BgL_l1466z00_426); 
exit( -1 );} 
BgL_arg1868z00_431 = 
CDR(BgL_pairz00_671); } 
{ 
obj_t BgL_l1466z00_2232;
BgL_l1466z00_2232 = BgL_arg1868z00_431; 
BgL_l1466z00_426 = BgL_l1466z00_2232; 
goto BgL_forzd2each1467zd2_427;} } }  else 
{ /* ./Llib/scheduler.scm 300 */
if(
NULLP(BgL_l1466z00_426))
{ /* ./Llib/scheduler.scm 300 */BTRUE; }  else 
{ /* ./Llib/scheduler.scm 300 */
FAILURE(BGl_string3006z00zz__ft_schedulerz00,BGl_string3007z00zz__ft_schedulerz00,BgL_l1466z00_426);} } } } 
{ /* ./Llib/scheduler.scm 302 */
BgL_z52schedulerz52_bglt BgL_obj1204z00_676;obj_t BgL_val1203z00_677;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_sz00_395, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/scheduler.scm 302 */
BgL_obj1204z00_676 = 
(BgL_z52schedulerz52_bglt)(BgL_sz00_395); }  else 
{ /* ./Llib/scheduler.scm 302 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2994z00zz__ft_schedulerz00, BgL_sz00_395); 
exit( -1 );} 
BgL_val1203z00_677 = BNIL; 
((((BgL_z52schedulerz52_bglt)CREF(BgL_obj1204z00_676))->BgL_tosuspendzf2resumezf2) = ((obj_t)BgL_val1203z00_677), BUNSPEC); } 
{ /* ./Llib/scheduler.scm 303 */
BgL_z52schedulerz52_bglt BgL_obj1198z00_678;obj_t BgL_val1197z00_679;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_sz00_395, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/scheduler.scm 303 */
BgL_obj1198z00_678 = 
(BgL_z52schedulerz52_bglt)(BgL_sz00_395); }  else 
{ /* ./Llib/scheduler.scm 303 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2994z00zz__ft_schedulerz00, BgL_sz00_395); 
exit( -1 );} 
BgL_val1197z00_679 = BNIL; 
((((BgL_z52schedulerz52_bglt)CREF(BgL_obj1198z00_678))->BgL_tostartz00) = ((obj_t)BgL_val1197z00_679), BUNSPEC); } 
{ /* ./Llib/scheduler.scm 305 */
obj_t BgL_list1878z00_433;
BgL_list1878z00_433 = 
MAKE_PAIR(BTRUE, BNIL); 
{ /* ./Llib/scheduler.scm 305 */
bool_t BgL_auxz00_2251;
{ /* ./Llib/scheduler.scm 305 */
BgL_threadz00_bglt BgL_auxz00_2252;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_sz00_395, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 305 */
BgL_auxz00_2252 = 
(BgL_threadz00_bglt)(BgL_sz00_395)
; }  else 
{ /* ./Llib/scheduler.scm 305 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2992z00zz__ft_schedulerz00, BgL_sz00_395); 
exit( -1 );} 
BgL_auxz00_2251 = 
BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_auxz00_2252, BgL_list1878z00_433); } 
return 
BBOOL(BgL_auxz00_2251);} } } } 
}



/* _scheduler-terminate! */
obj_t BGl__schedulerzd2terminatez12zc0zz__ft_schedulerz00(obj_t BgL_envz00_748, obj_t BgL_sz00_749)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 268 */
return 
BGl_schedulerzd2terminatez12zc0zz__ft_schedulerz00(BgL_sz00_749);} 
}



/* scheduler-instant */
BGL_EXPORTED_DEF int BGl_schedulerzd2instantzd2zz__ft_schedulerz00(obj_t BgL_sz00_20)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 310 */
{ /* ./Llib/scheduler.scm 311 */
obj_t BgL_sz00_441;
if(
NULLP(BgL_sz00_20))
{ /* ./Llib/scheduler.scm 312 */
BgL_sz00_441 = 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BNIL); }  else 
{ /* ./Llib/scheduler.scm 314 */
bool_t BgL_testz00_2265;
{ /* ./Llib/scheduler.scm 314 */
obj_t BgL_arg1917z00_451;
{ /* ./Llib/scheduler.scm 314 */
obj_t BgL_pairz00_681;
if(
PAIRP(BgL_sz00_20))
{ /* ./Llib/scheduler.scm 314 */
BgL_pairz00_681 = BgL_sz00_20; }  else 
{ /* ./Llib/scheduler.scm 314 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)29)), BGl_string2981z00zz__ft_schedulerz00, BgL_sz00_20); 
exit( -1 );} 
BgL_arg1917z00_451 = 
CAR(BgL_pairz00_681); } 
BgL_testz00_2265 = 
BGl_iszd2azf3z21zz__objectz00(BgL_arg1917z00_451, BGl_schedulerz00zz__ft_typesz00); } 
if(BgL_testz00_2265)
{ /* ./Llib/scheduler.scm 315 */
obj_t BgL_pairz00_683;
if(
PAIRP(BgL_sz00_20))
{ /* ./Llib/scheduler.scm 315 */
BgL_pairz00_683 = BgL_sz00_20; }  else 
{ /* ./Llib/scheduler.scm 315 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)29)), BGl_string2981z00zz__ft_schedulerz00, BgL_sz00_20); 
exit( -1 );} 
BgL_sz00_441 = 
CAR(BgL_pairz00_683); }  else 
{ /* ./Llib/scheduler.scm 317 */
obj_t BgL_arg1913z00_450;
{ /* ./Llib/scheduler.scm 317 */
obj_t BgL_pairz00_684;
if(
PAIRP(BgL_sz00_20))
{ /* ./Llib/scheduler.scm 317 */
BgL_pairz00_684 = BgL_sz00_20; }  else 
{ /* ./Llib/scheduler.scm 317 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)29)), BGl_string2981z00zz__ft_schedulerz00, BgL_sz00_20); 
exit( -1 );} 
BgL_arg1913z00_450 = 
CAR(BgL_pairz00_684); } 
FAILURE(BGl_string3005z00zz__ft_schedulerz00,BGl_string2983z00zz__ft_schedulerz00,BgL_arg1913z00_450);} } 
{ /* ./Llib/scheduler.scm 319 */
BgL_ftenvz00_bglt BgL_obj1106z00_690;
{ /* ./Llib/scheduler.scm 319 */
obj_t BgL_aux2962z00_1000;
{ /* ./Llib/scheduler.scm 319 */
obj_t BgL_auxz00_2286;
{ /* ./Llib/scheduler.scm 319 */
BgL_schedulerz00_bglt BgL_obj1104z00_688;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_sz00_441, BGl_schedulerz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 319 */
BgL_obj1104z00_688 = 
(BgL_schedulerz00_bglt)(BgL_sz00_441); }  else 
{ /* ./Llib/scheduler.scm 319 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)29)), BGl_string2985z00zz__ft_schedulerz00, BgL_sz00_441); 
exit( -1 );} 
BgL_auxz00_2286 = 
(((BgL_schedulerz00_bglt)CREF(BgL_obj1104z00_688))->BgL_envzb2zb2); } 
BgL_aux2962z00_1000 = 
CAR(BgL_auxz00_2286); } 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux2962z00_1000, BGl_ftenvz00zz__ft_typesz00))
{ /* ./Llib/scheduler.scm 319 */
BgL_obj1106z00_690 = 
(BgL_ftenvz00_bglt)(BgL_aux2962z00_1000); }  else 
{ /* ./Llib/scheduler.scm 319 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)29)), BGl_string3008z00zz__ft_schedulerz00, BgL_aux2962z00_1000); 
exit( -1 );} } 
return 
(int)(
(((BgL_ftenvz00_bglt)CREF(BgL_obj1106z00_690))->BgL_instantz00));} } } 
}



/* _scheduler-instant */
obj_t BGl__schedulerzd2instantzd2zz__ft_schedulerz00(obj_t BgL_envz00_750, obj_t BgL_sz00_751)
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 310 */
return 
BINT(
BGl_schedulerzd2instantzd2zz__ft_schedulerz00(BgL_sz00_751));} 
}



/* method-init */
obj_t BGl_methodzd2initzd2zz__ft_schedulerz00()
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 15 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__ft_schedulerz00()
{ AN_OBJECT;
{ /* ./Llib/scheduler.scm 15 */
BGl_modulezd2initializa7ationz75zz__ft_debugz00(((long)45544), 
BSTRING_TO_STRING(BGl_string3009z00zz__ft_schedulerz00)); 
BGl_modulezd2initializa7ationz75zz__ft_typesz00(((long)55409), 
BSTRING_TO_STRING(BGl_string3009z00zz__ft_schedulerz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(((long)35069), 
BSTRING_TO_STRING(BGl_string3009z00zz__ft_schedulerz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(((long)7524), 
BSTRING_TO_STRING(BGl_string3009z00zz__ft_schedulerz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52envz52(((long)51670), 
BSTRING_TO_STRING(BGl_string3009z00zz__ft_schedulerz00)); 
BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(((long)38854), 
BSTRING_TO_STRING(BGl_string3009z00zz__ft_schedulerz00)); 
BGl_modulezd2initializa7ationz75zz__ft_threadz00(((long)18657), 
BSTRING_TO_STRING(BGl_string3009z00zz__ft_schedulerz00)); 
return 
BGl_modulezd2initializa7ationz75zz__ft_signalz00(((long)5725), 
BSTRING_TO_STRING(BGl_string3009z00zz__ft_schedulerz00));} 
}

