/*===========================================================================*/
/*   (Llib/_scheduler.scm)                                                   */
/*   Bigloo (2.6f)                                                           */
/*   Inria -- Sophia Antipolis (c)       Mon Dec 20 10:51:01 CET 2004        */
/*===========================================================================*/
/* COMPILATION: (/builddir/build/BUILD/bigloo2.6f/bin/bigloo -rm -O3 -I Llib -copt -fPIC -copt -I Posix Llib/_scheduler.scm -o objs/_scheduler.o -c)*/
/* GC selection */
#define THE_GC BOEHM_GC

#include <bigloo.h>
#include <bglthread.h>


/* Object type definitions */
typedef struct BgL_threadz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52mutexesz52;
   obj_t BgL_z52exczd2handlersz80;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_namez00;
   obj_t BgL_specificz00;
   obj_t BgL_schedulerz00;
   obj_t BgL_cleanupz00;
} *BgL_threadz00_bglt;

typedef struct BgL_schedulerz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52mutexesz52;
   obj_t BgL_z52exczd2handlersz80;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_namez00;
   obj_t BgL_specificz00;
   obj_t BgL_schedulerz00;
   obj_t BgL_cleanupz00;
   obj_t BgL_envzb2zb2;
} *BgL_schedulerz00_bglt;

typedef struct BgL_ftenvz00_bgl {
   header_t header;
   obj_t widening;
   long BgL_instantz00;
} *BgL_ftenvz00_bglt;

typedef struct BgL_mutexz00_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_specificz00;
   obj_t BgL_z52unlockzd2signalz80;
} *BgL_mutexz00_bglt;

typedef struct BgL_conditionzd2variablezd2_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_specificz00;
} *BgL_conditionzd2variablezd2_bglt;

typedef struct BgL_z52schedulerz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_z52builtinz52;
   int BgL_z52timeoutz52;
   obj_t BgL_z52statez52;
   bool_t BgL_z52iszd2suspendz80;
   obj_t BgL_z52terminatez52;
   obj_t BgL_z52resultz52;
   obj_t BgL_z52exczd2resultz80;
   bool_t BgL_z52exczd2raisedz80;
   int BgL_z52identz52;
   obj_t BgL_z52mutexesz52;
   obj_t BgL_z52exczd2handlersz80;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52awakezd2signalz80;
   obj_t BgL_z52awakezd2valuez80;
   obj_t BgL_namez00;
   obj_t BgL_specificz00;
   obj_t BgL_schedulerz00;
   obj_t BgL_cleanupz00;
   obj_t BgL_envzb2zb2;
   obj_t BgL_nextzd2instantzd2;
   obj_t BgL_currentzd2threadzd2;
   int BgL_z52livezd2threadzd2numberz52;
   bool_t BgL_z52threadszd2readyz80;
   obj_t BgL_threadszd2runnablezd2;
   obj_t BgL_asynczd2runnablezd2;
   obj_t BgL_threadszd2timeoutzd2;
   obj_t BgL_threadszd2yieldzd2;
   obj_t BgL_tostartz00;
   obj_t BgL_toterminatez00;
   obj_t BgL_tosuspendzf2resumezf2;
   obj_t BgL_tobroadcastz00;
   obj_t BgL_tospawnz00;
} *BgL_z52schedulerz52_bglt;

typedef struct BgL_z52sigasyncz52_bgl {
   header_t header;
   obj_t widening;
   bool_t BgL_spawnedz00;
   obj_t BgL_idz00;
   obj_t BgL_thunkz00;
} *BgL_z52sigasyncz52_bglt;

typedef struct BgL_z52conditionzd2variablez80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_specificz00;
} *BgL_z52conditionzd2variablez80_bglt;

typedef struct BgL_z52mutexz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_namez00;
   obj_t BgL_specificz00;
   obj_t BgL_z52unlockzd2signalz80;
   bool_t BgL_z52abandonedz52;
   obj_t BgL_z52ownedz52;
   bool_t BgL_z52lockedz52;
} *BgL_z52mutexz52_bglt;

typedef struct BgL_z52uncaughtzd2exceptionz80_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_reasonz00;
} *BgL_z52uncaughtzd2exceptionz80_bglt;

typedef struct BgL_z52envz52_bgl {
   header_t header;
   obj_t widening;
   long BgL_instantz00;
   obj_t BgL_z52signalsz52;
   obj_t BgL_z52lastzd2signalsz80;
} *BgL_z52envz52_bglt;

typedef struct BgL_z52signalz52_bgl {
   header_t header;
   obj_t widening;
   obj_t BgL_idz00;
   obj_t BgL_valsz00;
   int BgL_stampz00;
   obj_t BgL_threadsz00;
} *BgL_z52signalz52_bglt;


static obj_t BGl__z52broadcastz12z40zz__ft_z52schedulerz52(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_z52envzd2initzd2instantz52zz__ft_z52schedulerz52(BgL_schedulerz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_debugz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_typesz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_envz00(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_z52envz52(long, char *);
extern obj_t BGl_modulezd2initializa7ationz75zz__ft_signalz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__errorz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__objectz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__readerz00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(long, char *);
BGL_IMPORT obj_t BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(long, char *);
static obj_t BGl__z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(obj_t, obj_t, obj_t);
static obj_t BGl_methodzd2initzd2zz__ft_z52schedulerz52();
extern obj_t BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(obj_t);
static obj_t BGl_z52spawnzd2asyncz80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
BGL_IMPORT obj_t open_input_string(obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2timez80zz__ft_z52schedulerz52(BgL_schedulerz00_bglt);
static obj_t BGl_zc3anonymousza31783ze3z83zz__ft_z52schedulerz52(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2addzd2asynczd2runnablez12z92zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, BgL_threadz00_bglt);
static obj_t BGl_ntz00zz__ft_z52schedulerz52(obj_t);
extern obj_t BGl_z52sigasyncz52zz__ft_z52typesz52;
extern obj_t BGl_threadz00zz__ft_typesz00;
static obj_t BGl__z52schedulerzd2addzd2asynczd2runnablez12z92zz__ft_z52schedulerz52(obj_t, obj_t, obj_t);
BGL_IMPORT obj_t BGl_readz00zz__readerz00(obj_t);
BGL_IMPORT bool_t BGl_iszd2azf3z21zz__objectz00(obj_t, obj_t);
static obj_t BGl__z52schedulerzd2timez80zz__ft_z52schedulerz52(obj_t, obj_t);
static obj_t BGl__z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(obj_t, obj_t, obj_t);
static obj_t BGl_z52schedulerzd2getzd2asynczd2runnablez80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, obj_t);
extern obj_t BGl_signalzd2unbindzd2threadz12z12zz__ft_signalz00(obj_t, BgL_threadz00_bglt);
static obj_t BGl__z52schedulerzd2spawnzd2asyncz52zz__ft_z52schedulerz52(obj_t, obj_t, obj_t);
extern obj_t BGl_ftenvzd2threadszd2zz__ft_envz00(BgL_ftenvz00_bglt);
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2waitingzd2threadsz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
static obj_t BGl_z52startzd2newzd2threadsz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
BGL_EXPORTED_DECL obj_t BGl_z52broadcastz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, obj_t, obj_t);
BGL_IMPORT obj_t BGl_appendz12z12zz__r4_pairs_and_lists_6_3z00(obj_t, obj_t);
extern obj_t BGl_ftenvz00zz__ft_typesz00;
extern obj_t BGl_instantzd2envz12zc0zz__ft_envz00(BgL_ftenvz00_bglt);
extern obj_t BGl_schedulerz00zz__ft_typesz00;
BGL_IMPORT obj_t BGl_modulezd2initzd2errorz00zz__errorz00(char *, char *);
static obj_t BGl_zc3anonymousza31672ze3z83zz__ft_z52schedulerz52(obj_t, obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52schedulezd2instantz80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
static obj_t BGl__z52schedulerzd2waitingzd2threadsz52zz__ft_z52schedulerz52(obj_t, obj_t);
BGL_IMPORT obj_t BGl_sortz00zz__r4_vectors_6_8z00(obj_t, obj_t);
BGL_IMPORT obj_t BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_threadz00_bglt, BgL_schedulerz00_bglt);
static obj_t BGl_z52suspendzf2resumezd2threadsz72zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
extern bool_t BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(BgL_threadz00_bglt, obj_t);
static obj_t BGl_cnstzd2initzd2zz__ft_z52schedulerz52();
extern BgL_schedulerz00_bglt BGl_makezd2schedulerzd2zz__ft_schedulerz00(obj_t);
static obj_t BGl__z52schedulerzd2addzd2asyncz12z40zz__ft_z52schedulerz52(obj_t, obj_t, obj_t);
static obj_t BGl_zc3anonymousza31755ze3z83zz__ft_z52schedulerz52(obj_t, obj_t);
BGL_EXPORTED_DECL BgL_schedulerz00_bglt BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(obj_t, obj_t);
BGL_IMPORT bool_t BGl_zd3fxzd3zz__r4_numbers_6_5_fixnumz00(long, long);
extern obj_t BGl_signalzd2emitzd2zz__ft_signalz00(obj_t, obj_t, obj_t);
static obj_t BGl_z52schedulerzd2broadcastza2z12z30zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
BGL_IMPORT obj_t bgl_append2(obj_t, obj_t);
static obj_t BGl_z52selectzd2threadsz12z92zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
BGL_IMPORT obj_t BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(obj_t, obj_t);
static obj_t BGl_importedzd2moduleszd2initz00zz__ft_z52schedulerz52();
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2spawnzd2asyncz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, BgL_z52sigasyncz52_bglt);
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2addzd2asyncz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, BgL_z52sigasyncz52_bglt);
static obj_t BGl_requirezd2initializa7ationz75zz__ft_z52schedulerz52 = BUNSPEC;
static obj_t BGl_zc3anonymousza31764ze3z83zz__ft_z52schedulerz52(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_threadz00_bglt, BgL_schedulerz00_bglt);
static obj_t BGl_zc3anonymousza31628ze3z83zz__ft_z52schedulerz52(obj_t);
BGL_IMPORT long BGl_bitzd2andzd2zz__bitz00(long, long);
extern obj_t BGl_z52schedulerz52zz__ft_z52typesz52;
static obj_t BGl__z52schedulerzd2nextzd2threadz52zz__ft_z52schedulerz52(obj_t, obj_t, obj_t);
extern bool_t BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_threadz00_bglt, obj_t);
BGL_IMPORT obj_t BGl_filterz12z12zz__r4_control_features_6_9z00(obj_t, obj_t);
extern bool_t BGl_z52threadzd2iszd2terminatedz52zz__ft_z52threadz52(BgL_threadz00_bglt, obj_t);
static obj_t BGl_zc3anonymousza31694ze3z83zz__ft_z52schedulerz52(obj_t, obj_t);
BGL_EXPORTED_DECL obj_t BGl_z52schedulerzd2addzd2broadcastz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt, obj_t, obj_t);
BGL_IMPORT obj_t BGl_bigloozd2typezd2errorz00zz__errorz00(obj_t, obj_t, obj_t);
static obj_t BGl_libraryzd2moduleszd2initz00zz__ft_z52schedulerz52();
static obj_t BGl__z52schedulezd2instantz80zz__ft_z52schedulerz52(obj_t, obj_t);
extern obj_t BGl_za2threadzd2strictzd2orderza2z00zz__ft_typesz00;
static obj_t BGl__z52schedulerzd2addzd2broadcastz12z40zz__ft_z52schedulerz52(obj_t, obj_t, obj_t, obj_t);
static obj_t BGl_zc3anonymousza31774ze3z83zz__ft_z52schedulerz52(obj_t, obj_t);
static obj_t BGl_z52terminatezd2threadsz80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt);
static obj_t __cnst[ 35 ] ;


DEFINE_EXPORT_PROCEDURE( BGl_z52schedulerzd2switchzd2tozd2nextzd2threadzd2envz80zz__ft_z52schedulerz52, BgL_bgl__za752schedulerza7d2switchza7d2toza7d2nextza7d2threadza752za7za7__ft_za752schedulerza7523062z00, BGl__z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_z52broadcastz12zd2envz92zz__ft_z52schedulerz52, BgL_bgl__za752broadcastza712za740za7za7__ft_za752schedulerza7523063za7, BGl__z52broadcastz12z40zz__ft_z52schedulerz52, 0L, 3 );
DEFINE_STRING( BGl_string3016z00zz__ft_z52schedulerz52, BgL_bgl_string3016za700za7za7__ft_za752schedulerza7523064za7, "_%scheduler-waiting-threads %scheduler-waiting-threads _%scheduler-time %scheduler-time _%scheduler-add-broadcast! %scheduler-add-broadcast! %scheduler-broadcast*! _%broadcast! %spawn-async (funcall fun1838 fun1838) nt _%scheduler-spawn-async %scheduler-spawn-async %suspend/resume-threads <anonymous:1783> <anonymous:1755> <anonymous:1764> <anonymous:1774> <anonymous:1694> <anonymous:1672> %select-threads! %env-init-instant _%schedule-instant _%scheduler-switch-to-next-thread %scheduler-switch-to-next-thread _%scheduler-next-thread %scheduler-next-thread _%scheduler-add-async! _%scheduler-add-async-runnable! %scheduler-add-async-runnable! %scheduler-get-async-runnable _%get-optional-scheduler %get-optional-scheduler b$bglthread $bglthread? ", 749 );
DEFINE_STRING( BGl_string3015z00zz__ft_z52schedulerz52, BgL_bgl_string3015za700za7za7__ft_za752schedulerza7523065za7, "__ft_%scheduler", 15 );
DEFINE_STRING( BGl_string3014z00zz__ft_z52schedulerz52, BgL_bgl_string3014za700za7za7__ft_za752schedulerza7523066za7, "nt:Wrong number of arguments", 28 );
DEFINE_STRING( BGl_string3008z00zz__ft_z52schedulerz52, BgL_bgl_string3008za700za7za7__ft_za752schedulerza7523067za7, "argument not a list", 19 );
DEFINE_STRING( BGl_string3007z00zz__ft_z52schedulerz52, BgL_bgl_string3007za700za7za7__ft_za752schedulerza7523068za7, "for-each", 8 );
DEFINE_STRING( BGl_string3006z00zz__ft_z52schedulerz52, BgL_bgl_string3006za700za7za7__ft_za752schedulerza7523069za7, "ftenv", 5 );
DEFINE_STRING( BGl_string3004z00zz__ft_z52schedulerz52, BgL_bgl_string3004za700za7za7__ft_za752schedulerza7523070za7, "%sigasync", 9 );
DEFINE_STRING( BGl_string3003z00zz__ft_z52schedulerz52, BgL_bgl_string3003za700za7za7__ft_za752schedulerza7523071za7, "thread", 6 );
DEFINE_STRING( BGl_string3002z00zz__ft_z52schedulerz52, BgL_bgl_string3002za700za7za7__ft_za752schedulerza7523072za7, "%scheduler", 10 );
DEFINE_EXPORT_PROCEDURE( BGl_z52schedulerzd2addzd2asyncz12zd2envz92zz__ft_z52schedulerz52, BgL_bgl__za752schedulerza7d2addza7d2asyncza712za740za7za7__ft_za752schedulerza7523073za7, BGl__z52schedulerzd2addzd2asyncz12z40zz__ft_z52schedulerz52, 0L, 2 );
DEFINE_STRING( BGl_string3001z00zz__ft_z52schedulerz52, BgL_bgl_string3001za700za7za7__ft_za752schedulerza7523074za7, "$bglthread", 10 );
DEFINE_STRING( BGl_string3000z00zz__ft_z52schedulerz52, BgL_bgl_string3000za700za7za7__ft_za752schedulerza7523075za7, "pair-nil", 8 );
DEFINE_EXPORT_PROCEDURE( BGl_z52schedulerzd2waitingzd2threadszd2envz80zz__ft_z52schedulerz52, BgL_bgl__za752schedulerza7d2waitingza7d2threadsza752za7za7__ft_za752schedulerza7523076z00, BGl__z52schedulerzd2waitingzd2threadsz52zz__ft_z52schedulerz52, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl_z52schedulerzd2addzd2asynczd2runnablez12zd2envz40zz__ft_z52schedulerz52, BgL_bgl__za752schedulerza7d2addza7d2asyncza7d2runnableza712za792za7za7__ft_za752schedulerza7523077z00, BGl__z52schedulerzd2addzd2asynczd2runnablez12z92zz__ft_z52schedulerz52, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_z52schedulerzd2spawnzd2asynczd2envz80zz__ft_z52schedulerz52, BgL_bgl__za752schedulerza7d2spawnza7d2asyncza752za7za7__ft_za752schedulerza7523078z00, BGl__z52schedulerzd2spawnzd2asyncz52zz__ft_z52schedulerz52, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_z52schedulerzd2nextzd2threadzd2envz80zz__ft_z52schedulerz52, BgL_bgl__za752schedulerza7d2nextza7d2threadza752za7za7__ft_za752schedulerza7523079z00, BGl__z52schedulerzd2nextzd2threadz52zz__ft_z52schedulerz52, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3005z00zz__ft_z52schedulerz52, BgL_bgl_za7c3anonymousza7a31628za7e3za783za7za7__ft_za752schedulerza7523080z00, BGl_zc3anonymousza31628ze3z83zz__ft_z52schedulerz52, 0L, 0 );
DEFINE_STATIC_PROCEDURE( BGl_proc3010z00zz__ft_z52schedulerz52, BgL_bgl_za7c3anonymousza7a31783za7e3za783za7za7__ft_za752schedulerza7523081z00, BGl_zc3anonymousza31783ze3z83zz__ft_z52schedulerz52, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc3009z00zz__ft_z52schedulerz52, BgL_bgl_za7c3anonymousza7a31672za7e3za783za7za7__ft_za752schedulerza7523082z00, BGl_zc3anonymousza31672ze3z83zz__ft_z52schedulerz52, 0L, 2 );
DEFINE_STATIC_PROCEDURE( BGl_proc3011z00zz__ft_z52schedulerz52, BgL_bgl_za7c3anonymousza7a31755za7e3za783za7za7__ft_za752schedulerza7523083z00, BGl_zc3anonymousza31755ze3z83zz__ft_z52schedulerz52, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc3012z00zz__ft_z52schedulerz52, BgL_bgl_za7c3anonymousza7a31764za7e3za783za7za7__ft_za752schedulerza7523084z00, BGl_zc3anonymousza31764ze3z83zz__ft_z52schedulerz52, 0L, 1 );
DEFINE_STATIC_PROCEDURE( BGl_proc3013z00zz__ft_z52schedulerz52, BgL_bgl_za7c3anonymousza7a31774za7e3za783za7za7__ft_za752schedulerza7523085z00, BGl_zc3anonymousza31774ze3z83zz__ft_z52schedulerz52, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl_z52getzd2optionalzd2schedulerzd2envz80zz__ft_z52schedulerz52, BgL_bgl__za752getza7d2optionalza7d2schedulerza752za7za7__ft_za752schedulerza7523086z00, BGl__z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52, 0L, 2 );
DEFINE_EXPORT_PROCEDURE( BGl_z52schedulerzd2addzd2broadcastz12zd2envz92zz__ft_z52schedulerz52, BgL_bgl__za752schedulerza7d2addza7d2broadcastza712za740za7za7__ft_za752schedulerza7523087za7, BGl__z52schedulerzd2addzd2broadcastz12z40zz__ft_z52schedulerz52, 0L, 3 );
DEFINE_EXPORT_PROCEDURE( BGl_z52schedulezd2instantzd2envz52zz__ft_z52schedulerz52, BgL_bgl__za752scheduleza7d2instantza780za7za7__ft_za752schedulerza7523088za7, BGl__z52schedulezd2instantz80zz__ft_z52schedulerz52, 0L, 1 );
DEFINE_EXPORT_PROCEDURE( BGl_z52schedulerzd2timezd2envz52zz__ft_z52schedulerz52, BgL_bgl__za752schedulerza7d2timeza780za7za7__ft_za752schedulerza7523089za7, BGl__z52schedulerzd2timez80zz__ft_z52schedulerz52, 0L, 1 );
DEFINE_STRING( BGl_string2999z00zz__ft_z52schedulerz52, BgL_bgl_string2999za700za7za7__ft_za752schedulerza7523090za7, "symbol", 6 );
DEFINE_STRING( BGl_string2998z00zz__ft_z52schedulerz52, BgL_bgl_string2998za700za7za7__ft_za752schedulerza7523091za7, "Illegal scheduler", 17 );
DEFINE_STRING( BGl_string2997z00zz__ft_z52schedulerz52, BgL_bgl_string2997za700za7za7__ft_za752schedulerza7523092za7, "pair", 4 );
DEFINE_STRING( BGl_string2996z00zz__ft_z52schedulerz52, BgL_bgl_string2996za700za7za7__ft_za752schedulerza7523093za7, "scheduler", 9 );
DEFINE_STRING( BGl_string2995z00zz__ft_z52schedulerz52, BgL_bgl_string2995za700za7za7__ft_za752schedulerza7523094za7, "foreign", 7 );



/* module-initialization */
BGL_EXPORTED_DEF obj_t BGl_modulezd2initializa7ationz75zz__ft_z52schedulerz52(long BgL_checksumz00_1225, char * BgL_fromz00_1226)
{ AN_OBJECT;
{ 
if(
BGl_zd3fxzd3zz__r4_numbers_6_5_fixnumz00(
(long)CINT(
BINT(
BGl_bitzd2andzd2zz__bitz00(BgL_checksumz00_1225, ((long)7524)))), BgL_checksumz00_1225))
{ 
if(
CBOOL(BGl_requirezd2initializa7ationz75zz__ft_z52schedulerz52))
{ 
BGl_requirezd2initializa7ationz75zz__ft_z52schedulerz52 = 
BBOOL(((bool_t)0)); 
BGl_libraryzd2moduleszd2initz00zz__ft_z52schedulerz52(); 
BGl_cnstzd2initzd2zz__ft_z52schedulerz52(); 
BGl_importedzd2moduleszd2initz00zz__ft_z52schedulerz52(); 
return BUNSPEC;}  else 
{ 
return BUNSPEC;} }  else 
{ 
return 
BGl_modulezd2initzd2errorz00zz__errorz00(
BSTRING_TO_STRING("__ft_%scheduler"), BgL_fromz00_1226);} } 
}



/* library-modules-init */
obj_t BGl_libraryzd2moduleszd2initz00zz__ft_z52schedulerz52()
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 15 */
BGl_modulezd2initializa7ationz75zz__readerz00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__objectz00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_pairs_and_lists_6_3z00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_vectors_6_8z00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_ports_6_10_1z00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__r4_control_features_6_9z00(((long)0), "__ft_%scheduler"); 
BGl_modulezd2initializa7ationz75zz__errorz00(((long)0), "__ft_%scheduler"); 
return BUNSPEC;} 
}



/* cnst-init */
obj_t BGl_cnstzd2initzd2zz__ft_z52schedulerz52()
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 15 */
{ /* ./Llib/_scheduler.scm 15 */
obj_t BgL_cportz00_1086;
BgL_cportz00_1086 = 
open_input_string(BGl_string3016z00zz__ft_z52schedulerz52); 
{ 
long BgL_iz00_1087;
BgL_iz00_1087 = ((long)34); 
BgL_loopz00_1088:
if(
(BgL_iz00_1087==((long)-1)))
{ /* ./Llib/_scheduler.scm 15 */
return BUNSPEC;}  else 
{ /* ./Llib/_scheduler.scm 15 */
{ /* ./Llib/_scheduler.scm 15 */
obj_t BgL_arg3020z00_1090;
{ /* ./Llib/_scheduler.scm 15 */
obj_t BgL_list3023z00_1091;
BgL_list3023z00_1091 = 
MAKE_PAIR(BgL_cportz00_1086, BNIL); 
BgL_arg3020z00_1090 = 
BGl_readz00zz__readerz00(BgL_list3023z00_1091); } 
{ /* ./Llib/_scheduler.scm 15 */
int BgL_auxz00_1254;
BgL_auxz00_1254 = 
(int)(BgL_iz00_1087); 
CNST_TABLE_SET(BgL_auxz00_1254, BgL_arg3020z00_1090); } } 
{ /* ./Llib/_scheduler.scm 15 */
int BgL_auxz00_1092;
BgL_auxz00_1092 = 
(int)(
(BgL_iz00_1087-((long)1))); 
{ 
long BgL_iz00_1259;
BgL_iz00_1259 = 
(long)(BgL_auxz00_1092); 
BgL_iz00_1087 = BgL_iz00_1259; 
goto BgL_loopz00_1088;} } } } } } 
}



/* %get-optional-scheduler */
BGL_EXPORTED_DEF BgL_schedulerz00_bglt BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(obj_t BgL_whoz00_4, obj_t BgL_oz00_5)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 43 */
if(
NULLP(BgL_oz00_5))
{ /* ./Llib/_scheduler.scm 46 */
obj_t BgL_sz00_248;
BgL_sz00_248 = 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BNIL); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_sz00_248, BGl_schedulerz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 47 */
if(
BGl_iszd2azf3z21zz__objectz00(BgL_sz00_248, BGl_schedulerz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 48 */
return 
(BgL_schedulerz00_bglt)(BgL_sz00_248);}  else 
{ /* ./Llib/_scheduler.scm 48 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)2)), BGl_string2996z00zz__ft_z52schedulerz52, BgL_sz00_248); 
exit( -1 );} }  else 
{ /* ./Llib/_scheduler.scm 49 */
BgL_schedulerz00_bglt BgL_arg1511z00_250;
BgL_arg1511z00_250 = 
BGl_makezd2schedulerzd2zz__ft_schedulerz00(BNIL); 
{ /* ./Llib/_scheduler.scm 49 */
obj_t BgL_list1513z00_251;
BgL_list1513z00_251 = 
MAKE_PAIR(
(obj_t)(BgL_arg1511z00_250), BNIL); 
{ /* ./Llib/_scheduler.scm 49 */
obj_t BgL_aux2067z00_859;
BgL_aux2067z00_859 = 
BGl_defaultzd2schedulerzd2zz__ft_schedulerz00(BgL_list1513z00_251); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux2067z00_859, BGl_schedulerz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 49 */
return 
(BgL_schedulerz00_bglt)(BgL_aux2067z00_859);}  else 
{ /* ./Llib/_scheduler.scm 49 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)2)), BGl_string2996z00zz__ft_z52schedulerz52, BgL_aux2067z00_859); 
exit( -1 );} } } } }  else 
{ /* ./Llib/_scheduler.scm 50 */
bool_t BgL_testz00_1282;
{ /* ./Llib/_scheduler.scm 50 */
obj_t BgL_arg1529z00_257;
{ /* ./Llib/_scheduler.scm 50 */
obj_t BgL_pairz00_540;
if(
PAIRP(BgL_oz00_5))
{ /* ./Llib/_scheduler.scm 50 */
BgL_pairz00_540 = BgL_oz00_5; }  else 
{ /* ./Llib/_scheduler.scm 50 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)2)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_oz00_5); 
exit( -1 );} 
BgL_arg1529z00_257 = 
CAR(BgL_pairz00_540); } 
BgL_testz00_1282 = 
BGl_iszd2azf3z21zz__objectz00(BgL_arg1529z00_257, BGl_schedulerz00zz__ft_typesz00); } 
if(BgL_testz00_1282)
{ /* ./Llib/_scheduler.scm 51 */
obj_t BgL_pairz00_542;
if(
PAIRP(BgL_oz00_5))
{ /* ./Llib/_scheduler.scm 51 */
BgL_pairz00_542 = BgL_oz00_5; }  else 
{ /* ./Llib/_scheduler.scm 51 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)2)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_oz00_5); 
exit( -1 );} 
{ /* ./Llib/_scheduler.scm 51 */
obj_t BgL_aux2089z00_865;
BgL_aux2089z00_865 = 
CAR(BgL_pairz00_542); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux2089z00_865, BGl_schedulerz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 51 */
return 
(BgL_schedulerz00_bglt)(BgL_aux2089z00_865);}  else 
{ /* ./Llib/_scheduler.scm 51 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)2)), BGl_string2996z00zz__ft_z52schedulerz52, BgL_aux2089z00_865); 
exit( -1 );} } }  else 
{ /* ./Llib/_scheduler.scm 53 */
obj_t BgL_arg1524z00_256;
{ /* ./Llib/_scheduler.scm 53 */
obj_t BgL_pairz00_543;
if(
PAIRP(BgL_oz00_5))
{ /* ./Llib/_scheduler.scm 53 */
BgL_pairz00_543 = BgL_oz00_5; }  else 
{ /* ./Llib/_scheduler.scm 53 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)2)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_oz00_5); 
exit( -1 );} 
BgL_arg1524z00_256 = 
CAR(BgL_pairz00_543); } 
FAILURE(BgL_whoz00_4,BGl_string2998z00zz__ft_z52schedulerz52,BgL_arg1524z00_256);} } } 
}



/* _%get-optional-scheduler */
obj_t BGl__z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(obj_t BgL_envz00_794, obj_t BgL_whoz00_795, obj_t BgL_oz00_796)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 43 */
{ /* ./Llib/_scheduler.scm 45 */
BgL_schedulerz00_bglt BgL_auxz00_1309;
{ /* ./Llib/_scheduler.scm 45 */
obj_t BgL_auxz00_1316;obj_t BgL_auxz00_1310;
{ /* ./Llib/_scheduler.scm 45 */
bool_t BgL_testz00_1317;
if(
PAIRP(BgL_oz00_796))
{ /* ./Llib/_scheduler.scm 45 */
BgL_testz00_1317 = ((bool_t)1)
; }  else 
{ /* ./Llib/_scheduler.scm 45 */
BgL_testz00_1317 = 
NULLP(BgL_oz00_796)
; } 
if(BgL_testz00_1317)
{ /* ./Llib/_scheduler.scm 45 */
BgL_auxz00_1316 = BgL_oz00_796
; }  else 
{ /* ./Llib/_scheduler.scm 45 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)3)), BGl_string3000z00zz__ft_z52schedulerz52, BgL_oz00_796); 
exit( -1 );} } 
if(
SYMBOLP(BgL_whoz00_795))
{ /* ./Llib/_scheduler.scm 45 */
BgL_auxz00_1310 = BgL_whoz00_795
; }  else 
{ /* ./Llib/_scheduler.scm 45 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)3)), BGl_string2999z00zz__ft_z52schedulerz52, BgL_whoz00_795); 
exit( -1 );} 
BgL_auxz00_1309 = 
BGl_z52getzd2optionalzd2schedulerz52zz__ft_z52schedulerz52(BgL_auxz00_1310, BgL_auxz00_1316); } 
return 
(obj_t)(BgL_auxz00_1309);} } 
}



/* %scheduler-get-async-runnable */
obj_t BGl_z52schedulerzd2getzd2asynczd2runnablez80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_6, obj_t BgL_nvz00_7)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 62 */
{ /* ./Llib/_scheduler.scm 63 */
obj_t BgL_arg1534z00_259;
{ /* ./Llib/_scheduler.scm 63 */
BgL_threadz00_bglt BgL_obj1003z00_547;
BgL_obj1003z00_547 = 
(BgL_threadz00_bglt)(BgL_scdlz00_6); 
BgL_arg1534z00_259 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_547))->BgL_z52builtinz52); } 
{ /* ./Llib/_scheduler.scm 63 */
bglthread_t BgL_auxz00_1328;
{ /* ./Llib/_scheduler.scm 63 */
obj_t BgL_auxz00_1329;
{ /* ./Llib/_scheduler.scm 63 */
obj_t BgL_aux2128z00_875;
if(
FOREIGNP(BgL_arg1534z00_259))
{ /* ./Llib/_scheduler.scm 63 */
BgL_aux2128z00_875 = BgL_arg1534z00_259; }  else 
{ /* ./Llib/_scheduler.scm 63 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)4)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_arg1534z00_259); 
exit( -1 );} 
{ /* ./Llib/_scheduler.scm 63 */
bool_t BgL_testz00_1335;
if(
FOREIGNP(BgL_aux2128z00_875))
{ /* ./Llib/_scheduler.scm 63 */
obj_t BgL_arg1502z00_1107;obj_t BgL_arg1503z00_1108;
{ /* ./Llib/_scheduler.scm 63 */
obj_t BgL_auxz00_1338;
if(
FOREIGNP(BgL_aux2128z00_875))
{ /* ./Llib/_scheduler.scm 63 */
BgL_auxz00_1338 = BgL_aux2128z00_875
; }  else 
{ /* ./Llib/_scheduler.scm 63 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2995z00zz__ft_z52schedulerz52, BgL_aux2128z00_875); 
exit( -1 );} 
BgL_arg1502z00_1107 = 
FOREIGN_ID(BgL_auxz00_1338); } 
BgL_arg1503z00_1108 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_1335 = 
(BgL_arg1502z00_1107==BgL_arg1503z00_1108); }  else 
{ /* ./Llib/_scheduler.scm 63 */
BgL_testz00_1335 = ((bool_t)0)
; } 
if(BgL_testz00_1335)
{ /* ./Llib/_scheduler.scm 63 */
BgL_auxz00_1329 = BgL_aux2128z00_875
; }  else 
{ /* ./Llib/_scheduler.scm 63 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)4)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_aux2128z00_875); 
exit( -1 );} } } 
BgL_auxz00_1328 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_1329); } 
bglasync_synchronize(BgL_auxz00_1328); } } 
{ /* ./Llib/_scheduler.scm 63 */
obj_t BgL_g1435z00_260;
{ /* ./Llib/_scheduler.scm 65 */
obj_t BgL_vz00_262;
BgL_vz00_262 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_6))->BgL_asynczd2runnablezd2); 
if(
PAIRP(BgL_nvz00_7))
{ /* ./Llib/_scheduler.scm 67 */
obj_t BgL_arg1544z00_264;
{ /* ./Llib/_scheduler.scm 67 */
obj_t BgL_pairz00_550;
if(
PAIRP(BgL_nvz00_7))
{ /* ./Llib/_scheduler.scm 67 */
BgL_pairz00_550 = BgL_nvz00_7; }  else 
{ /* ./Llib/_scheduler.scm 67 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)4)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_nvz00_7); 
exit( -1 );} 
BgL_arg1544z00_264 = 
CAR(BgL_pairz00_550); } 
{ /* ./Llib/_scheduler.scm 67 */
BgL_z52schedulerz52_bglt BgL_obj1189z00_551;obj_t BgL_val1188z00_552;
BgL_obj1189z00_551 = BgL_scdlz00_6; 
{ /* ./Llib/_scheduler.scm 67 */
bool_t BgL_testz00_1361;
if(
PAIRP(BgL_arg1544z00_264))
{ /* ./Llib/_scheduler.scm 67 */
BgL_testz00_1361 = ((bool_t)1)
; }  else 
{ /* ./Llib/_scheduler.scm 67 */
BgL_testz00_1361 = 
NULLP(BgL_arg1544z00_264)
; } 
if(BgL_testz00_1361)
{ /* ./Llib/_scheduler.scm 67 */
BgL_val1188z00_552 = BgL_arg1544z00_264; }  else 
{ /* ./Llib/_scheduler.scm 67 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)4)), BGl_string3000z00zz__ft_z52schedulerz52, BgL_arg1544z00_264); 
exit( -1 );} } 
((((BgL_z52schedulerz52_bglt)CREF(BgL_obj1189z00_551))->BgL_asynczd2runnablezd2) = ((obj_t)BgL_val1188z00_552), BUNSPEC); } }  else 
{ /* ./Llib/_scheduler.scm 66 */BFALSE; } 
BgL_g1435z00_260 = BgL_vz00_262; } 
{ /* ./Llib/_scheduler.scm 63 */
obj_t BgL_arg1539z00_261;
{ /* ./Llib/_scheduler.scm 63 */
BgL_threadz00_bglt BgL_obj1003z00_553;
BgL_obj1003z00_553 = 
(BgL_threadz00_bglt)(BgL_scdlz00_6); 
BgL_arg1539z00_261 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_553))->BgL_z52builtinz52); } 
{ /* ./Llib/_scheduler.scm 63 */
bglthread_t BgL_auxz00_1371;
{ /* ./Llib/_scheduler.scm 63 */
obj_t BgL_auxz00_1372;
{ /* ./Llib/_scheduler.scm 63 */
obj_t BgL_aux2159z00_883;
if(
FOREIGNP(BgL_arg1539z00_261))
{ /* ./Llib/_scheduler.scm 63 */
BgL_aux2159z00_883 = BgL_arg1539z00_261; }  else 
{ /* ./Llib/_scheduler.scm 63 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)4)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_arg1539z00_261); 
exit( -1 );} 
{ /* ./Llib/_scheduler.scm 63 */
bool_t BgL_testz00_1378;
if(
FOREIGNP(BgL_aux2159z00_883))
{ /* ./Llib/_scheduler.scm 63 */
obj_t BgL_arg1502z00_1115;obj_t BgL_arg1503z00_1116;
{ /* ./Llib/_scheduler.scm 63 */
obj_t BgL_auxz00_1381;
if(
FOREIGNP(BgL_aux2159z00_883))
{ /* ./Llib/_scheduler.scm 63 */
BgL_auxz00_1381 = BgL_aux2159z00_883
; }  else 
{ /* ./Llib/_scheduler.scm 63 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2995z00zz__ft_z52schedulerz52, BgL_aux2159z00_883); 
exit( -1 );} 
BgL_arg1502z00_1115 = 
FOREIGN_ID(BgL_auxz00_1381); } 
BgL_arg1503z00_1116 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_1378 = 
(BgL_arg1502z00_1115==BgL_arg1503z00_1116); }  else 
{ /* ./Llib/_scheduler.scm 63 */
BgL_testz00_1378 = ((bool_t)0)
; } 
if(BgL_testz00_1378)
{ /* ./Llib/_scheduler.scm 63 */
BgL_auxz00_1372 = BgL_aux2159z00_883
; }  else 
{ /* ./Llib/_scheduler.scm 63 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)4)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_aux2159z00_883); 
exit( -1 );} } } 
BgL_auxz00_1371 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_1372); } 
bglasync_asynchronize(BgL_auxz00_1371); } } 
return BgL_g1435z00_260;} } 
}



/* %scheduler-add-async-runnable! */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2addzd2asynczd2runnablez12z92zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_8, BgL_threadz00_bglt BgL_tz00_9)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 76 */
{ /* ./Llib/_scheduler.scm 79 */
obj_t BgL_arg1550z00_266;
{ /* ./Llib/_scheduler.scm 79 */
BgL_threadz00_bglt BgL_obj1003z00_554;
BgL_obj1003z00_554 = 
(BgL_threadz00_bglt)(BgL_scdlz00_8); 
BgL_arg1550z00_266 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_554))->BgL_z52builtinz52); } 
{ /* ./Llib/_scheduler.scm 79 */
bglthread_t BgL_auxz00_1397;
{ /* ./Llib/_scheduler.scm 79 */
obj_t BgL_auxz00_1398;
{ /* ./Llib/_scheduler.scm 79 */
obj_t BgL_aux2175z00_887;
if(
FOREIGNP(BgL_arg1550z00_266))
{ /* ./Llib/_scheduler.scm 79 */
BgL_aux2175z00_887 = BgL_arg1550z00_266; }  else 
{ /* ./Llib/_scheduler.scm 79 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)5)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_arg1550z00_266); 
exit( -1 );} 
{ /* ./Llib/_scheduler.scm 79 */
bool_t BgL_testz00_1404;
if(
FOREIGNP(BgL_aux2175z00_887))
{ /* ./Llib/_scheduler.scm 79 */
obj_t BgL_arg1502z00_1118;obj_t BgL_arg1503z00_1119;
{ /* ./Llib/_scheduler.scm 79 */
obj_t BgL_auxz00_1407;
if(
FOREIGNP(BgL_aux2175z00_887))
{ /* ./Llib/_scheduler.scm 79 */
BgL_auxz00_1407 = BgL_aux2175z00_887
; }  else 
{ /* ./Llib/_scheduler.scm 79 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2995z00zz__ft_z52schedulerz52, BgL_aux2175z00_887); 
exit( -1 );} 
BgL_arg1502z00_1118 = 
FOREIGN_ID(BgL_auxz00_1407); } 
BgL_arg1503z00_1119 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_1404 = 
(BgL_arg1502z00_1118==BgL_arg1503z00_1119); }  else 
{ /* ./Llib/_scheduler.scm 79 */
BgL_testz00_1404 = ((bool_t)0)
; } 
if(BgL_testz00_1404)
{ /* ./Llib/_scheduler.scm 79 */
BgL_auxz00_1398 = BgL_aux2175z00_887
; }  else 
{ /* ./Llib/_scheduler.scm 79 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)5)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_aux2175z00_887); 
exit( -1 );} } } 
BgL_auxz00_1397 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_1398); } 
bglasync_synchronize(BgL_auxz00_1397); } } 
{ /* ./Llib/_scheduler.scm 79 */
obj_t BgL_g1438z00_267;
{ /* ./Llib/_scheduler.scm 82 */
obj_t BgL_arg1559z00_270;
{ /* ./Llib/_scheduler.scm 82 */
obj_t BgL_arg1562z00_271;
BgL_arg1562z00_271 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_8))->BgL_asynczd2runnablezd2); 
BgL_arg1559z00_270 = 
MAKE_PAIR(
(obj_t)(BgL_tz00_9), BgL_arg1562z00_271); } 
((((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_8))->BgL_asynczd2runnablezd2) = ((obj_t)BgL_arg1559z00_270), BUNSPEC); } 
{ /* ./Llib/_scheduler.scm 83 */
obj_t BgL_arg1566z00_272;
{ /* ./Llib/_scheduler.scm 83 */
BgL_threadz00_bglt BgL_obj1003z00_558;
BgL_obj1003z00_558 = 
(BgL_threadz00_bglt)(BgL_scdlz00_8); 
BgL_arg1566z00_272 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_558))->BgL_z52builtinz52); } 
{ /* ./Llib/_scheduler.scm 83 */
bglthread_t BgL_auxz00_1427;
{ /* ./Llib/_scheduler.scm 83 */
obj_t BgL_auxz00_1428;
{ /* ./Llib/_scheduler.scm 83 */
obj_t BgL_aux2192z00_891;
if(
FOREIGNP(BgL_arg1566z00_272))
{ /* ./Llib/_scheduler.scm 83 */
BgL_aux2192z00_891 = BgL_arg1566z00_272; }  else 
{ /* ./Llib/_scheduler.scm 83 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)5)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_arg1566z00_272); 
exit( -1 );} 
{ /* ./Llib/_scheduler.scm 83 */
bool_t BgL_testz00_1434;
if(
FOREIGNP(BgL_aux2192z00_891))
{ /* ./Llib/_scheduler.scm 83 */
obj_t BgL_arg1502z00_1121;obj_t BgL_arg1503z00_1122;
{ /* ./Llib/_scheduler.scm 83 */
obj_t BgL_auxz00_1437;
if(
FOREIGNP(BgL_aux2192z00_891))
{ /* ./Llib/_scheduler.scm 83 */
BgL_auxz00_1437 = BgL_aux2192z00_891
; }  else 
{ /* ./Llib/_scheduler.scm 83 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2995z00zz__ft_z52schedulerz52, BgL_aux2192z00_891); 
exit( -1 );} 
BgL_arg1502z00_1121 = 
FOREIGN_ID(BgL_auxz00_1437); } 
BgL_arg1503z00_1122 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_1434 = 
(BgL_arg1502z00_1121==BgL_arg1503z00_1122); }  else 
{ /* ./Llib/_scheduler.scm 83 */
BgL_testz00_1434 = ((bool_t)0)
; } 
if(BgL_testz00_1434)
{ /* ./Llib/_scheduler.scm 83 */
BgL_auxz00_1428 = BgL_aux2192z00_891
; }  else 
{ /* ./Llib/_scheduler.scm 83 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)5)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_aux2192z00_891); 
exit( -1 );} } } 
BgL_auxz00_1427 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_1428); } 
bglasync_scheduler_notify(BgL_auxz00_1427); } } 
BgL_g1438z00_267 = BUNSPEC; 
{ /* ./Llib/_scheduler.scm 79 */
obj_t BgL_arg1554z00_268;
{ /* ./Llib/_scheduler.scm 79 */
BgL_threadz00_bglt BgL_obj1003z00_559;
BgL_obj1003z00_559 = 
(BgL_threadz00_bglt)(BgL_scdlz00_8); 
BgL_arg1554z00_268 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_559))->BgL_z52builtinz52); } 
{ /* ./Llib/_scheduler.scm 79 */
bglthread_t BgL_auxz00_1453;
{ /* ./Llib/_scheduler.scm 79 */
obj_t BgL_auxz00_1454;
{ /* ./Llib/_scheduler.scm 79 */
obj_t BgL_aux2208z00_895;
if(
FOREIGNP(BgL_arg1554z00_268))
{ /* ./Llib/_scheduler.scm 79 */
BgL_aux2208z00_895 = BgL_arg1554z00_268; }  else 
{ /* ./Llib/_scheduler.scm 79 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)5)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_arg1554z00_268); 
exit( -1 );} 
{ /* ./Llib/_scheduler.scm 79 */
bool_t BgL_testz00_1460;
if(
FOREIGNP(BgL_aux2208z00_895))
{ /* ./Llib/_scheduler.scm 79 */
obj_t BgL_arg1502z00_1124;obj_t BgL_arg1503z00_1125;
{ /* ./Llib/_scheduler.scm 79 */
obj_t BgL_auxz00_1463;
if(
FOREIGNP(BgL_aux2208z00_895))
{ /* ./Llib/_scheduler.scm 79 */
BgL_auxz00_1463 = BgL_aux2208z00_895
; }  else 
{ /* ./Llib/_scheduler.scm 79 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2995z00zz__ft_z52schedulerz52, BgL_aux2208z00_895); 
exit( -1 );} 
BgL_arg1502z00_1124 = 
FOREIGN_ID(BgL_auxz00_1463); } 
BgL_arg1503z00_1125 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_1460 = 
(BgL_arg1502z00_1124==BgL_arg1503z00_1125); }  else 
{ /* ./Llib/_scheduler.scm 79 */
BgL_testz00_1460 = ((bool_t)0)
; } 
if(BgL_testz00_1460)
{ /* ./Llib/_scheduler.scm 79 */
BgL_auxz00_1454 = BgL_aux2208z00_895
; }  else 
{ /* ./Llib/_scheduler.scm 79 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)5)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_aux2208z00_895); 
exit( -1 );} } } 
BgL_auxz00_1453 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_1454); } 
bglasync_asynchronize(BgL_auxz00_1453); } } 
return BgL_g1438z00_267;} } 
}



/* _%scheduler-add-async-runnable! */
obj_t BGl__z52schedulerzd2addzd2asynczd2runnablez12z92zz__ft_z52schedulerz52(obj_t BgL_envz00_797, obj_t BgL_scdlz00_798, obj_t BgL_tz00_799)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 76 */
{ /* ./Llib/_scheduler.scm 78 */
BgL_threadz00_bglt BgL_auxz00_1484;BgL_z52schedulerz52_bglt BgL_auxz00_1477;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_tz00_799, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 78 */
BgL_auxz00_1484 = 
(BgL_threadz00_bglt)(BgL_tz00_799)
; }  else 
{ /* ./Llib/_scheduler.scm 78 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)6)), BGl_string3003z00zz__ft_z52schedulerz52, BgL_tz00_799); 
exit( -1 );} 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_798, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/_scheduler.scm 78 */
BgL_auxz00_1477 = 
(BgL_z52schedulerz52_bglt)(BgL_scdlz00_798)
; }  else 
{ /* ./Llib/_scheduler.scm 78 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)6)), BGl_string3002z00zz__ft_z52schedulerz52, BgL_scdlz00_798); 
exit( -1 );} 
return 
BGl_z52schedulerzd2addzd2asynczd2runnablez12z92zz__ft_z52schedulerz52(BgL_auxz00_1477, BgL_auxz00_1484);} } 
}



/* %scheduler-add-async! */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2addzd2asyncz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_10, BgL_z52sigasyncz52_bglt BgL_sigz00_11)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 89 */
{ /* ./Llib/_scheduler.scm 90 */
obj_t BgL_arg1570z00_561;
{ /* ./Llib/_scheduler.scm 90 */
obj_t BgL_arg1573z00_562;
BgL_arg1573z00_562 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_10))->BgL_tospawnz00); 
BgL_arg1570z00_561 = 
MAKE_PAIR(
(obj_t)(BgL_sigz00_11), BgL_arg1573z00_562); } 
return 
((((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_10))->BgL_tospawnz00) = ((obj_t)BgL_arg1570z00_561), BUNSPEC);} } 
}



/* _%scheduler-add-async! */
obj_t BGl__z52schedulerzd2addzd2asyncz12z40zz__ft_z52schedulerz52(obj_t BgL_envz00_800, obj_t BgL_scdlz00_801, obj_t BgL_sigz00_802)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 89 */
{ /* ./Llib/_scheduler.scm 90 */
BgL_z52sigasyncz52_bglt BgL_auxz00_1503;BgL_z52schedulerz52_bglt BgL_auxz00_1496;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_sigz00_802, BGl_z52sigasyncz52zz__ft_z52typesz52))
{ /* ./Llib/_scheduler.scm 90 */
BgL_auxz00_1503 = 
(BgL_z52sigasyncz52_bglt)(BgL_sigz00_802)
; }  else 
{ /* ./Llib/_scheduler.scm 90 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)7)), BGl_string3004z00zz__ft_z52schedulerz52, BgL_sigz00_802); 
exit( -1 );} 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_801, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/_scheduler.scm 90 */
BgL_auxz00_1496 = 
(BgL_z52schedulerz52_bglt)(BgL_scdlz00_801)
; }  else 
{ /* ./Llib/_scheduler.scm 90 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)7)), BGl_string3002z00zz__ft_z52schedulerz52, BgL_scdlz00_801); 
exit( -1 );} 
return 
BGl_z52schedulerzd2addzd2asyncz12z40zz__ft_z52schedulerz52(BgL_auxz00_1496, BgL_auxz00_1503);} } 
}



/* %scheduler-next-thread */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_threadz00_bglt BgL_tz00_12, BgL_schedulerz00_bglt BgL_scdlz00_13)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 96 */
{ /* ./Llib/_scheduler.scm 99 */
obj_t BgL_arg1624z00_568;
BgL_arg1624z00_568 = 
BGL_CURRENT_ERROR_PORT(); 
BGl_withzd2outputzd2tozd2portzd2zz__r4_ports_6_10_1z00(BgL_arg1624z00_568, BGl_proc3005z00zz__ft_z52schedulerz52); } 
{ 
obj_t BgL_runnablez00_277;
{ /* ./Llib/_scheduler.scm 100 */
obj_t BgL_arg1579z00_279;
{ /* ./Llib/_scheduler.scm 100 */
BgL_z52schedulerz52_bglt BgL_obj1184z00_570;
{ /* ./Llib/_scheduler.scm 100 */
obj_t BgL_aux22395z00_947;
BgL_aux22395z00_947 = 
((obj_t)BgL_scdlz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22395z00_947, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/_scheduler.scm 100 */
BgL_obj1184z00_570 = 
(BgL_z52schedulerz52_bglt)(BgL_scdlz00_13); }  else 
{ /* ./Llib/_scheduler.scm 100 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string3002z00zz__ft_z52schedulerz52, 
(obj_t)(BgL_scdlz00_13)); 
exit( -1 );} } 
BgL_arg1579z00_279 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_obj1184z00_570))->BgL_threadszd2runnablezd2); } 
BgL_runnablez00_277 = BgL_arg1579z00_279; 
BgL_loopz00_278:
if(
PAIRP(BgL_runnablez00_277))
{ /* ./Llib/_scheduler.scm 103 */
obj_t BgL_ntz00_281;
{ /* ./Llib/_scheduler.scm 103 */
obj_t BgL_pairz00_572;
if(
PAIRP(BgL_runnablez00_277))
{ /* ./Llib/_scheduler.scm 103 */
BgL_pairz00_572 = BgL_runnablez00_277; }  else 
{ /* ./Llib/_scheduler.scm 103 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_runnablez00_277); 
exit( -1 );} 
BgL_ntz00_281 = 
CAR(BgL_pairz00_572); } 
{ /* ./Llib/_scheduler.scm 105 */
bool_t BgL_testz00_1530;
{ /* ./Llib/_scheduler.scm 105 */
BgL_threadz00_bglt BgL_obj1010z00_573;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_ntz00_281, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 105 */
BgL_obj1010z00_573 = 
(BgL_threadz00_bglt)(BgL_ntz00_281); }  else 
{ /* ./Llib/_scheduler.scm 105 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string3003z00zz__ft_z52schedulerz52, BgL_ntz00_281); 
exit( -1 );} 
BgL_testz00_1530 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1010z00_573))->BgL_z52iszd2suspendz80); } 
if(BgL_testz00_1530)
{ /* ./Llib/_scheduler.scm 105 */
{ /* ./Llib/_scheduler.scm 107 */
obj_t BgL_arg1585z00_283;
{ /* ./Llib/_scheduler.scm 107 */
obj_t BgL_arg1588z00_284;
{ /* ./Llib/_scheduler.scm 107 */
BgL_z52schedulerz52_bglt BgL_obj1193z00_574;
{ /* ./Llib/_scheduler.scm 107 */
obj_t BgL_aux22267z00_910;
BgL_aux22267z00_910 = 
((obj_t)BgL_scdlz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22267z00_910, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/_scheduler.scm 107 */
BgL_obj1193z00_574 = 
(BgL_z52schedulerz52_bglt)(BgL_scdlz00_13); }  else 
{ /* ./Llib/_scheduler.scm 107 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string3002z00zz__ft_z52schedulerz52, 
(obj_t)(BgL_scdlz00_13)); 
exit( -1 );} } 
BgL_arg1588z00_284 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_obj1193z00_574))->BgL_threadszd2yieldzd2); } 
BgL_arg1585z00_283 = 
MAKE_PAIR(BgL_ntz00_281, BgL_arg1588z00_284); } 
{ /* ./Llib/_scheduler.scm 107 */
BgL_z52schedulerz52_bglt BgL_obj1195z00_575;obj_t BgL_val1194z00_576;
{ /* ./Llib/_scheduler.scm 107 */
obj_t BgL_aux22277z00_913;
BgL_aux22277z00_913 = 
((obj_t)BgL_scdlz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22277z00_913, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/_scheduler.scm 107 */
BgL_obj1195z00_575 = 
(BgL_z52schedulerz52_bglt)(BgL_scdlz00_13); }  else 
{ /* ./Llib/_scheduler.scm 107 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string3002z00zz__ft_z52schedulerz52, 
(obj_t)(BgL_scdlz00_13)); 
exit( -1 );} } 
BgL_val1194z00_576 = BgL_arg1585z00_283; 
((((BgL_z52schedulerz52_bglt)CREF(BgL_obj1195z00_575))->BgL_threadszd2yieldzd2) = ((obj_t)BgL_val1194z00_576), BUNSPEC); } } 
{ /* ./Llib/_scheduler.scm 108 */
obj_t BgL_arg1593z00_285;
{ /* ./Llib/_scheduler.scm 108 */
obj_t BgL_pairz00_577;
if(
PAIRP(BgL_runnablez00_277))
{ /* ./Llib/_scheduler.scm 108 */
BgL_pairz00_577 = BgL_runnablez00_277; }  else 
{ /* ./Llib/_scheduler.scm 108 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_runnablez00_277); 
exit( -1 );} 
BgL_arg1593z00_285 = 
CDR(BgL_pairz00_577); } 
{ 
obj_t BgL_runnablez00_1563;
BgL_runnablez00_1563 = BgL_arg1593z00_285; 
BgL_runnablez00_277 = BgL_runnablez00_1563; 
goto BgL_loopz00_278;} } }  else 
{ /* ./Llib/_scheduler.scm 109 */
bool_t BgL_testz00_1564;
{ /* ./Llib/_scheduler.scm 109 */
BgL_threadz00_bglt BgL_auxz00_1565;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_ntz00_281, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 109 */
BgL_auxz00_1565 = 
(BgL_threadz00_bglt)(BgL_ntz00_281)
; }  else 
{ /* ./Llib/_scheduler.scm 109 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string3003z00zz__ft_z52schedulerz52, BgL_ntz00_281); 
exit( -1 );} 
BgL_testz00_1564 = 
BGl_z52threadzd2iszd2deadz52zz__ft_z52threadz52(BgL_auxz00_1565, BNIL); } 
if(BgL_testz00_1564)
{ /* ./Llib/_scheduler.scm 110 */
obj_t BgL_arg1598z00_287;
{ /* ./Llib/_scheduler.scm 110 */
obj_t BgL_pairz00_578;
if(
PAIRP(BgL_runnablez00_277))
{ /* ./Llib/_scheduler.scm 110 */
BgL_pairz00_578 = BgL_runnablez00_277; }  else 
{ /* ./Llib/_scheduler.scm 110 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_runnablez00_277); 
exit( -1 );} 
BgL_arg1598z00_287 = 
CDR(BgL_pairz00_578); } 
{ 
obj_t BgL_runnablez00_1579;
BgL_runnablez00_1579 = BgL_arg1598z00_287; 
BgL_runnablez00_277 = BgL_runnablez00_1579; 
goto BgL_loopz00_278;} }  else 
{ /* ./Llib/_scheduler.scm 109 */
{ /* ./Llib/_scheduler.scm 112 */
obj_t BgL_arg1603z00_288;
{ /* ./Llib/_scheduler.scm 112 */
obj_t BgL_pairz00_579;
if(
PAIRP(BgL_runnablez00_277))
{ /* ./Llib/_scheduler.scm 112 */
BgL_pairz00_579 = BgL_runnablez00_277; }  else 
{ /* ./Llib/_scheduler.scm 112 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_runnablez00_277); 
exit( -1 );} 
BgL_arg1603z00_288 = 
CDR(BgL_pairz00_579); } 
{ /* ./Llib/_scheduler.scm 112 */
BgL_z52schedulerz52_bglt BgL_obj1186z00_580;obj_t BgL_val1185z00_581;
{ /* ./Llib/_scheduler.scm 112 */
obj_t BgL_aux22316z00_924;
BgL_aux22316z00_924 = 
((obj_t)BgL_scdlz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22316z00_924, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/_scheduler.scm 112 */
BgL_obj1186z00_580 = 
(BgL_z52schedulerz52_bglt)(BgL_scdlz00_13); }  else 
{ /* ./Llib/_scheduler.scm 112 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string3002z00zz__ft_z52schedulerz52, 
(obj_t)(BgL_scdlz00_13)); 
exit( -1 );} } 
{ /* ./Llib/_scheduler.scm 112 */
bool_t BgL_testz00_1594;
if(
PAIRP(BgL_arg1603z00_288))
{ /* ./Llib/_scheduler.scm 112 */
BgL_testz00_1594 = ((bool_t)1)
; }  else 
{ /* ./Llib/_scheduler.scm 112 */
BgL_testz00_1594 = 
NULLP(BgL_arg1603z00_288)
; } 
if(BgL_testz00_1594)
{ /* ./Llib/_scheduler.scm 112 */
BgL_val1185z00_581 = BgL_arg1603z00_288; }  else 
{ /* ./Llib/_scheduler.scm 112 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string3000z00zz__ft_z52schedulerz52, BgL_arg1603z00_288); 
exit( -1 );} } 
((((BgL_z52schedulerz52_bglt)CREF(BgL_obj1186z00_580))->BgL_threadszd2runnablezd2) = ((obj_t)BgL_val1185z00_581), BUNSPEC); } } 
{ /* ./Llib/_scheduler.scm 113 */
BgL_z52schedulerz52_bglt BgL_obj1177z00_582;obj_t BgL_val1176z00_583;
{ /* ./Llib/_scheduler.scm 113 */
obj_t BgL_aux22333z00_929;
BgL_aux22333z00_929 = 
((obj_t)BgL_scdlz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22333z00_929, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/_scheduler.scm 113 */
BgL_obj1177z00_582 = 
(BgL_z52schedulerz52_bglt)(BgL_scdlz00_13); }  else 
{ /* ./Llib/_scheduler.scm 113 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string3002z00zz__ft_z52schedulerz52, 
(obj_t)(BgL_scdlz00_13)); 
exit( -1 );} } 
BgL_val1176z00_583 = BgL_ntz00_281; 
((((BgL_z52schedulerz52_bglt)CREF(BgL_obj1177z00_582))->BgL_currentzd2threadzd2) = ((obj_t)BgL_val1176z00_583), BUNSPEC); } 
return BgL_ntz00_281;} } } }  else 
{ /* ./Llib/_scheduler.scm 115 */
obj_t BgL_asyncz00_290;
{ /* ./Llib/_scheduler.scm 115 */
obj_t BgL_list1620z00_294;
BgL_list1620z00_294 = 
MAKE_PAIR(BNIL, BNIL); 
{ /* ./Llib/_scheduler.scm 115 */
BgL_z52schedulerz52_bglt BgL_auxz00_1612;
{ /* ./Llib/_scheduler.scm 115 */
obj_t BgL_aux22343z00_932;
BgL_aux22343z00_932 = 
((obj_t)BgL_scdlz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22343z00_932, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/_scheduler.scm 115 */
BgL_auxz00_1612 = 
(BgL_z52schedulerz52_bglt)(BgL_scdlz00_13)
; }  else 
{ /* ./Llib/_scheduler.scm 115 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string3002z00zz__ft_z52schedulerz52, 
(obj_t)(BgL_scdlz00_13)); 
exit( -1 );} } 
BgL_asyncz00_290 = 
BGl_z52schedulerzd2getzd2asynczd2runnablez80zz__ft_z52schedulerz52(BgL_auxz00_1612, BgL_list1620z00_294); } } 
if(
PAIRP(BgL_asyncz00_290))
{ /* ./Llib/_scheduler.scm 117 */
obj_t BgL_ntz00_292;
{ /* ./Llib/_scheduler.scm 117 */
obj_t BgL_pairz00_585;
if(
PAIRP(BgL_asyncz00_290))
{ /* ./Llib/_scheduler.scm 117 */
BgL_pairz00_585 = BgL_asyncz00_290; }  else 
{ /* ./Llib/_scheduler.scm 117 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_asyncz00_290); 
exit( -1 );} 
BgL_ntz00_292 = 
CAR(BgL_pairz00_585); } 
{ /* ./Llib/_scheduler.scm 118 */
obj_t BgL_arg1613z00_293;
{ /* ./Llib/_scheduler.scm 118 */
obj_t BgL_pairz00_586;
if(
PAIRP(BgL_asyncz00_290))
{ /* ./Llib/_scheduler.scm 118 */
BgL_pairz00_586 = BgL_asyncz00_290; }  else 
{ /* ./Llib/_scheduler.scm 118 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_asyncz00_290); 
exit( -1 );} 
BgL_arg1613z00_293 = 
CDR(BgL_pairz00_586); } 
{ /* ./Llib/_scheduler.scm 118 */
BgL_z52schedulerz52_bglt BgL_obj1186z00_587;obj_t BgL_val1185z00_588;
{ /* ./Llib/_scheduler.scm 118 */
obj_t BgL_aux22367z00_939;
BgL_aux22367z00_939 = 
((obj_t)BgL_scdlz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22367z00_939, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/_scheduler.scm 118 */
BgL_obj1186z00_587 = 
(BgL_z52schedulerz52_bglt)(BgL_scdlz00_13); }  else 
{ /* ./Llib/_scheduler.scm 118 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string3002z00zz__ft_z52schedulerz52, 
(obj_t)(BgL_scdlz00_13)); 
exit( -1 );} } 
{ /* ./Llib/_scheduler.scm 118 */
bool_t BgL_testz00_1644;
if(
PAIRP(BgL_arg1613z00_293))
{ /* ./Llib/_scheduler.scm 118 */
BgL_testz00_1644 = ((bool_t)1)
; }  else 
{ /* ./Llib/_scheduler.scm 118 */
BgL_testz00_1644 = 
NULLP(BgL_arg1613z00_293)
; } 
if(BgL_testz00_1644)
{ /* ./Llib/_scheduler.scm 118 */
BgL_val1185z00_588 = BgL_arg1613z00_293; }  else 
{ /* ./Llib/_scheduler.scm 118 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string3000z00zz__ft_z52schedulerz52, BgL_arg1613z00_293); 
exit( -1 );} } 
((((BgL_z52schedulerz52_bglt)CREF(BgL_obj1186z00_587))->BgL_threadszd2runnablezd2) = ((obj_t)BgL_val1185z00_588), BUNSPEC); } } 
{ /* ./Llib/_scheduler.scm 119 */
BgL_z52schedulerz52_bglt BgL_obj1177z00_589;obj_t BgL_val1176z00_590;
{ /* ./Llib/_scheduler.scm 119 */
obj_t BgL_aux22384z00_944;
BgL_aux22384z00_944 = 
((obj_t)BgL_scdlz00_13); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux22384z00_944, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/_scheduler.scm 119 */
BgL_obj1177z00_589 = 
(BgL_z52schedulerz52_bglt)(BgL_scdlz00_13); }  else 
{ /* ./Llib/_scheduler.scm 119 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)8)), BGl_string3002z00zz__ft_z52schedulerz52, 
(obj_t)(BgL_scdlz00_13)); 
exit( -1 );} } 
BgL_val1176z00_590 = BgL_ntz00_292; 
((((BgL_z52schedulerz52_bglt)CREF(BgL_obj1177z00_589))->BgL_currentzd2threadzd2) = ((obj_t)BgL_val1176z00_590), BUNSPEC); } 
return BgL_ntz00_292;}  else 
{ /* ./Llib/_scheduler.scm 116 */
return 
(obj_t)(BgL_scdlz00_13);} } } } } 
}



/* _%scheduler-next-thread */
obj_t BGl__z52schedulerzd2nextzd2threadz52zz__ft_z52schedulerz52(obj_t BgL_envz00_804, obj_t BgL_tz00_805, obj_t BgL_scdlz00_806)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 96 */
{ /* ./Llib/_scheduler.scm 97 */
BgL_schedulerz00_bglt BgL_auxz00_1669;BgL_threadz00_bglt BgL_auxz00_1662;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_806, BGl_schedulerz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 97 */
BgL_auxz00_1669 = 
(BgL_schedulerz00_bglt)(BgL_scdlz00_806)
; }  else 
{ /* ./Llib/_scheduler.scm 97 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string2996z00zz__ft_z52schedulerz52, BgL_scdlz00_806); 
exit( -1 );} 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_tz00_805, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 97 */
BgL_auxz00_1662 = 
(BgL_threadz00_bglt)(BgL_tz00_805)
; }  else 
{ /* ./Llib/_scheduler.scm 97 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)9)), BGl_string3003z00zz__ft_z52schedulerz52, BgL_tz00_805); 
exit( -1 );} 
return 
BGl_z52schedulerzd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_auxz00_1662, BgL_auxz00_1669);} } 
}



/* <anonymous:1628> */
obj_t BGl_zc3anonymousza31628ze3z83zz__ft_z52schedulerz52(obj_t BgL_envz00_807)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 130 */
{ 

return BUNSPEC;} } 
}



/* %scheduler-switch-to-next-thread */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_threadz00_bglt BgL_tz00_16, BgL_schedulerz00_bglt BgL_scdlz00_17)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 148 */
{ /* ./Llib/_scheduler.scm 151 */
obj_t BgL_ntz00_301;
BgL_ntz00_301 = 
BGl_z52schedulerzd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_tz00_16, BgL_scdlz00_17); 
{ /* ./Llib/_scheduler.scm 153 */
obj_t BgL_arg1631z00_302;obj_t BgL_arg1633z00_303;
BgL_arg1631z00_302 = 
(((BgL_threadz00_bglt)CREF(BgL_tz00_16))->BgL_z52builtinz52); 
{ /* ./Llib/_scheduler.scm 153 */
BgL_threadz00_bglt BgL_obj1003z00_597;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_ntz00_301, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 153 */
BgL_obj1003z00_597 = 
(BgL_threadz00_bglt)(BgL_ntz00_301); }  else 
{ /* ./Llib/_scheduler.scm 153 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)10)), BGl_string3003z00zz__ft_z52schedulerz52, BgL_ntz00_301); 
exit( -1 );} 
BgL_arg1633z00_303 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_597))->BgL_z52builtinz52); } 
{ /* ./Llib/_scheduler.scm 153 */
bglthread_t BgL_auxz00_1709;bglthread_t BgL_auxz00_1686;
{ /* ./Llib/_scheduler.scm 153 */
obj_t BgL_auxz00_1710;
{ /* ./Llib/_scheduler.scm 153 */
obj_t BgL_aux2450z00_961;
if(
FOREIGNP(BgL_arg1633z00_303))
{ /* ./Llib/_scheduler.scm 153 */
BgL_aux2450z00_961 = BgL_arg1633z00_303; }  else 
{ /* ./Llib/_scheduler.scm 153 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)10)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_arg1633z00_303); 
exit( -1 );} 
{ /* ./Llib/_scheduler.scm 153 */
bool_t BgL_testz00_1716;
if(
FOREIGNP(BgL_aux2450z00_961))
{ /* ./Llib/_scheduler.scm 153 */
obj_t BgL_arg1502z00_1159;obj_t BgL_arg1503z00_1160;
{ /* ./Llib/_scheduler.scm 153 */
obj_t BgL_auxz00_1719;
if(
FOREIGNP(BgL_aux2450z00_961))
{ /* ./Llib/_scheduler.scm 153 */
BgL_auxz00_1719 = BgL_aux2450z00_961
; }  else 
{ /* ./Llib/_scheduler.scm 153 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2995z00zz__ft_z52schedulerz52, BgL_aux2450z00_961); 
exit( -1 );} 
BgL_arg1502z00_1159 = 
FOREIGN_ID(BgL_auxz00_1719); } 
BgL_arg1503z00_1160 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_1716 = 
(BgL_arg1502z00_1159==BgL_arg1503z00_1160); }  else 
{ /* ./Llib/_scheduler.scm 153 */
BgL_testz00_1716 = ((bool_t)0)
; } 
if(BgL_testz00_1716)
{ /* ./Llib/_scheduler.scm 153 */
BgL_auxz00_1710 = BgL_aux2450z00_961
; }  else 
{ /* ./Llib/_scheduler.scm 153 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)10)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_aux2450z00_961); 
exit( -1 );} } } 
BgL_auxz00_1709 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_1710); } 
{ /* ./Llib/_scheduler.scm 153 */
obj_t BgL_auxz00_1687;
{ /* ./Llib/_scheduler.scm 153 */
obj_t BgL_aux2435z00_957;
if(
FOREIGNP(BgL_arg1631z00_302))
{ /* ./Llib/_scheduler.scm 153 */
BgL_aux2435z00_957 = BgL_arg1631z00_302; }  else 
{ /* ./Llib/_scheduler.scm 153 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)10)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_arg1631z00_302); 
exit( -1 );} 
{ /* ./Llib/_scheduler.scm 153 */
bool_t BgL_testz00_1693;
if(
FOREIGNP(BgL_aux2435z00_957))
{ /* ./Llib/_scheduler.scm 153 */
obj_t BgL_arg1502z00_1156;obj_t BgL_arg1503z00_1157;
{ /* ./Llib/_scheduler.scm 153 */
obj_t BgL_auxz00_1696;
if(
FOREIGNP(BgL_aux2435z00_957))
{ /* ./Llib/_scheduler.scm 153 */
BgL_auxz00_1696 = BgL_aux2435z00_957
; }  else 
{ /* ./Llib/_scheduler.scm 153 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2995z00zz__ft_z52schedulerz52, BgL_aux2435z00_957); 
exit( -1 );} 
BgL_arg1502z00_1156 = 
FOREIGN_ID(BgL_auxz00_1696); } 
BgL_arg1503z00_1157 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_1693 = 
(BgL_arg1502z00_1156==BgL_arg1503z00_1157); }  else 
{ /* ./Llib/_scheduler.scm 153 */
BgL_testz00_1693 = ((bool_t)0)
; } 
if(BgL_testz00_1693)
{ /* ./Llib/_scheduler.scm 153 */
BgL_auxz00_1687 = BgL_aux2435z00_957
; }  else 
{ /* ./Llib/_scheduler.scm 153 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)10)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_aux2435z00_957); 
exit( -1 );} } } 
BgL_auxz00_1686 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_1687); } 
bglthread_switch(BgL_auxz00_1686, BgL_auxz00_1709); } } 
{ /* ./Llib/_scheduler.scm 154 */
obj_t BgL_arg1638z00_304;
BgL_arg1638z00_304 = 
(((BgL_threadz00_bglt)CREF(BgL_tz00_16))->BgL_z52builtinz52); 
{ /* ./Llib/_scheduler.scm 154 */
bglthread_t BgL_auxz00_1734;
{ /* ./Llib/_scheduler.scm 154 */
obj_t BgL_auxz00_1735;
{ /* ./Llib/_scheduler.scm 154 */
obj_t BgL_aux2465z00_965;
if(
FOREIGNP(BgL_arg1638z00_304))
{ /* ./Llib/_scheduler.scm 154 */
BgL_aux2465z00_965 = BgL_arg1638z00_304; }  else 
{ /* ./Llib/_scheduler.scm 154 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)10)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_arg1638z00_304); 
exit( -1 );} 
{ /* ./Llib/_scheduler.scm 154 */
bool_t BgL_testz00_1741;
if(
FOREIGNP(BgL_aux2465z00_965))
{ /* ./Llib/_scheduler.scm 154 */
obj_t BgL_arg1502z00_1162;obj_t BgL_arg1503z00_1163;
{ /* ./Llib/_scheduler.scm 154 */
obj_t BgL_auxz00_1744;
if(
FOREIGNP(BgL_aux2465z00_965))
{ /* ./Llib/_scheduler.scm 154 */
BgL_auxz00_1744 = BgL_aux2465z00_965
; }  else 
{ /* ./Llib/_scheduler.scm 154 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2995z00zz__ft_z52schedulerz52, BgL_aux2465z00_965); 
exit( -1 );} 
BgL_arg1502z00_1162 = 
FOREIGN_ID(BgL_auxz00_1744); } 
BgL_arg1503z00_1163 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_1741 = 
(BgL_arg1502z00_1162==BgL_arg1503z00_1163); }  else 
{ /* ./Llib/_scheduler.scm 154 */
BgL_testz00_1741 = ((bool_t)0)
; } 
if(BgL_testz00_1741)
{ /* ./Llib/_scheduler.scm 154 */
BgL_auxz00_1735 = BgL_aux2465z00_965
; }  else 
{ /* ./Llib/_scheduler.scm 154 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)10)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_aux2465z00_965); 
exit( -1 );} } } 
BgL_auxz00_1734 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_1735); } 
bglthread_wait(BgL_auxz00_1734); } } 
return BUNSPEC;} } 
}



/* _%scheduler-switch-to-next-thread */
obj_t BGl__z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(obj_t BgL_envz00_808, obj_t BgL_tz00_809, obj_t BgL_scdlz00_810)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 148 */
{ /* ./Llib/_scheduler.scm 149 */
BgL_schedulerz00_bglt BgL_auxz00_1765;BgL_threadz00_bglt BgL_auxz00_1758;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_810, BGl_schedulerz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 149 */
BgL_auxz00_1765 = 
(BgL_schedulerz00_bglt)(BgL_scdlz00_810)
; }  else 
{ /* ./Llib/_scheduler.scm 149 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)11)), BGl_string2996z00zz__ft_z52schedulerz52, BgL_scdlz00_810); 
exit( -1 );} 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_tz00_809, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 149 */
BgL_auxz00_1758 = 
(BgL_threadz00_bglt)(BgL_tz00_809)
; }  else 
{ /* ./Llib/_scheduler.scm 149 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)11)), BGl_string3003z00zz__ft_z52schedulerz52, BgL_tz00_809); 
exit( -1 );} 
return 
BGl_z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(BgL_auxz00_1758, BgL_auxz00_1765);} } 
}



/* %schedule-instant */
BGL_EXPORTED_DEF obj_t BGl_z52schedulezd2instantz80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_21)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 170 */
BGl_z52envzd2initzd2instantz52zz__ft_z52schedulerz52(
(BgL_schedulerz00_bglt)(BgL_scdlz00_21)); 
BGl_z52terminatezd2threadsz80zz__ft_z52schedulerz52(BgL_scdlz00_21); 
BGl_z52suspendzf2resumezd2threadsz72zz__ft_z52schedulerz52(BgL_scdlz00_21); 
BGl_z52selectzd2threadsz12z92zz__ft_z52schedulerz52(BgL_scdlz00_21); 
BGl_z52startzd2newzd2threadsz52zz__ft_z52schedulerz52(BgL_scdlz00_21); 
BGl_z52schedulerzd2broadcastza2z12z30zz__ft_z52schedulerz52(BgL_scdlz00_21); 
BGl_z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(
(BgL_threadz00_bglt)(BgL_scdlz00_21), 
(BgL_schedulerz00_bglt)(BgL_scdlz00_21)); 
return 
BGl_z52spawnzd2asyncz80zz__ft_z52schedulerz52(BgL_scdlz00_21);} 
}



/* _%schedule-instant */
obj_t BGl__z52schedulezd2instantz80zz__ft_z52schedulerz52(obj_t BgL_envz00_811, obj_t BgL_scdlz00_812)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 170 */
{ /* ./Llib/_scheduler.scm 172 */
BgL_z52schedulerz52_bglt BgL_auxz00_1784;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_812, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/_scheduler.scm 172 */
BgL_auxz00_1784 = 
(BgL_z52schedulerz52_bglt)(BgL_scdlz00_812)
; }  else 
{ /* ./Llib/_scheduler.scm 172 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)12)), BGl_string3002z00zz__ft_z52schedulerz52, BgL_scdlz00_812); 
exit( -1 );} 
return 
BGl_z52schedulezd2instantz80zz__ft_z52schedulerz52(BgL_auxz00_1784);} } 
}



/* %env-init-instant */
obj_t BGl_z52envzd2initzd2instantz52zz__ft_z52schedulerz52(BgL_schedulerz00_bglt BgL_scdlz00_22)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 196 */
{ 
obj_t BgL_l1453z00_306;
{ /* ./Llib/_scheduler.scm 198 */
obj_t BgL_arg1651z00_308;
BgL_arg1651z00_308 = 
(((BgL_schedulerz00_bglt)CREF(BgL_scdlz00_22))->BgL_envzb2zb2); 
BgL_l1453z00_306 = BgL_arg1651z00_308; 
BgL_forzd2each1454zd2_307:
if(
PAIRP(BgL_l1453z00_306))
{ /* ./Llib/_scheduler.scm 198 */
{ /* ./Llib/_scheduler.scm 198 */
obj_t BgL_arg1657z00_310;
{ /* ./Llib/_scheduler.scm 198 */
obj_t BgL_pairz00_601;
if(
PAIRP(BgL_l1453z00_306))
{ /* ./Llib/_scheduler.scm 198 */
BgL_pairz00_601 = BgL_l1453z00_306; }  else 
{ /* ./Llib/_scheduler.scm 198 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)13)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_l1453z00_306); 
exit( -1 );} 
BgL_arg1657z00_310 = 
CAR(BgL_pairz00_601); } 
{ /* ./Llib/_scheduler.scm 198 */
BgL_ftenvz00_bglt BgL_auxz00_1801;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_arg1657z00_310, BGl_ftenvz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 198 */
BgL_auxz00_1801 = 
(BgL_ftenvz00_bglt)(BgL_arg1657z00_310)
; }  else 
{ /* ./Llib/_scheduler.scm 198 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)13)), BGl_string3006z00zz__ft_z52schedulerz52, BgL_arg1657z00_310); 
exit( -1 );} 
BGl_instantzd2envz12zc0zz__ft_envz00(BgL_auxz00_1801); } } 
{ /* ./Llib/_scheduler.scm 198 */
obj_t BgL_arg1661z00_311;
{ /* ./Llib/_scheduler.scm 198 */
obj_t BgL_pairz00_602;
if(
PAIRP(BgL_l1453z00_306))
{ /* ./Llib/_scheduler.scm 198 */
BgL_pairz00_602 = BgL_l1453z00_306; }  else 
{ /* ./Llib/_scheduler.scm 198 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)13)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_l1453z00_306); 
exit( -1 );} 
BgL_arg1661z00_311 = 
CDR(BgL_pairz00_602); } 
{ 
obj_t BgL_l1453z00_1815;
BgL_l1453z00_1815 = BgL_arg1661z00_311; 
BgL_l1453z00_306 = BgL_l1453z00_1815; 
goto BgL_forzd2each1454zd2_307;} } }  else 
{ /* ./Llib/_scheduler.scm 198 */
if(
NULLP(BgL_l1453z00_306))
{ /* ./Llib/_scheduler.scm 198 */
return BTRUE;}  else 
{ /* ./Llib/_scheduler.scm 198 */
FAILURE(BGl_string3007z00zz__ft_z52schedulerz52,BGl_string3008z00zz__ft_z52schedulerz52,BgL_l1453z00_306);} } } } } 
}



/* %select-threads! */
obj_t BGl_z52selectzd2threadsz12z92zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_24)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 215 */
((((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_24))->BgL_z52threadszd2readyz80) = ((bool_t)((bool_t)0)), BUNSPEC); 
{ /* ./Llib/_scheduler.scm 237 */
obj_t BgL_runnablez00_326;
{ /* ./Llib/_scheduler.scm 237 */
obj_t BgL_cellvalz00_1820;
BgL_cellvalz00_1820 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_24))->BgL_threadszd2yieldzd2); 
BgL_runnablez00_326 = 
MAKE_CELL(BgL_cellvalz00_1820); } 
((((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_24))->BgL_threadszd2yieldzd2) = ((obj_t)BNIL), BUNSPEC); 
{ /* ./Llib/_scheduler.scm 240 */
obj_t BgL_arg1688z00_327;
{ /* ./Llib/_scheduler.scm 240 */
obj_t BgL_arg1692z00_329;
BgL_arg1692z00_329 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_24))->BgL_threadszd2timeoutzd2); 
{ /* ./Llib/_scheduler.scm 241 */
obj_t BgL_zc3anonymousza31694ze3z83_814;
BgL_zc3anonymousza31694ze3z83_814 = 
make_fx_procedure(BGl_zc3anonymousza31694ze3z83zz__ft_z52schedulerz52, 
(int)(((long)1)), 
(int)(((long)2))); 
PROCEDURE_SET(BgL_zc3anonymousza31694ze3z83_814, 
(int)(((long)0)), 
(obj_t)(BgL_scdlz00_24)); 
PROCEDURE_SET(BgL_zc3anonymousza31694ze3z83_814, 
(int)(((long)1)), BgL_runnablez00_326); 
BgL_arg1688z00_327 = 
BGl_filterz12z12zz__r4_control_features_6_9z00(BgL_zc3anonymousza31694ze3z83_814, BgL_arg1692z00_329); } } 
((((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_24))->BgL_threadszd2timeoutzd2) = ((obj_t)BgL_arg1688z00_327), BUNSPEC); } 
if(
CBOOL(BGl_za2threadzd2strictzd2orderza2z00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 259 */
obj_t BgL_arg1719z00_343;
{ /* ./Llib/_scheduler.scm 259 */
obj_t BgL_threadsz00_656;
BgL_threadsz00_656 = 
CELL_REF(BgL_runnablez00_326); 
BgL_arg1719z00_343 = 
BGl_sortz00zz__r4_vectors_6_8z00(BgL_threadsz00_656, BGl_proc3009z00zz__ft_z52schedulerz52); } 
{ /* ./Llib/_scheduler.scm 259 */
BgL_z52schedulerz52_bglt BgL_obj1186z00_668;obj_t BgL_val1185z00_669;
BgL_obj1186z00_668 = BgL_scdlz00_24; 
{ /* ./Llib/_scheduler.scm 259 */
bool_t BgL_testz00_1837;
if(
PAIRP(BgL_arg1719z00_343))
{ /* ./Llib/_scheduler.scm 259 */
BgL_testz00_1837 = ((bool_t)1)
; }  else 
{ /* ./Llib/_scheduler.scm 259 */
BgL_testz00_1837 = 
NULLP(BgL_arg1719z00_343)
; } 
if(BgL_testz00_1837)
{ /* ./Llib/_scheduler.scm 259 */
BgL_val1185z00_669 = BgL_arg1719z00_343; }  else 
{ /* ./Llib/_scheduler.scm 259 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)14)), BGl_string3000z00zz__ft_z52schedulerz52, BgL_arg1719z00_343); 
exit( -1 );} } 
return 
((((BgL_z52schedulerz52_bglt)CREF(BgL_obj1186z00_668))->BgL_threadszd2runnablezd2) = ((obj_t)BgL_val1185z00_669), BUNSPEC);} }  else 
{ /* ./Llib/_scheduler.scm 260 */
BgL_z52schedulerz52_bglt BgL_obj1186z00_670;obj_t BgL_val1185z00_671;
BgL_obj1186z00_670 = BgL_scdlz00_24; 
{ /* ./Llib/_scheduler.scm 260 */
obj_t BgL_aux2538z00_981;
BgL_aux2538z00_981 = 
CELL_REF(BgL_runnablez00_326); 
{ /* ./Llib/_scheduler.scm 260 */
bool_t BgL_testz00_1845;
if(
PAIRP(BgL_aux2538z00_981))
{ /* ./Llib/_scheduler.scm 260 */
BgL_testz00_1845 = ((bool_t)1)
; }  else 
{ /* ./Llib/_scheduler.scm 260 */
BgL_testz00_1845 = 
NULLP(BgL_aux2538z00_981)
; } 
if(BgL_testz00_1845)
{ /* ./Llib/_scheduler.scm 260 */
BgL_val1185z00_671 = BgL_aux2538z00_981; }  else 
{ /* ./Llib/_scheduler.scm 260 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)14)), BGl_string3000z00zz__ft_z52schedulerz52, BgL_aux2538z00_981); 
exit( -1 );} } } 
return 
((((BgL_z52schedulerz52_bglt)CREF(BgL_obj1186z00_670))->BgL_threadszd2runnablezd2) = ((obj_t)BgL_val1185z00_671), BUNSPEC);} } } 
}



/* <anonymous:1672> */
obj_t BGl_zc3anonymousza31672ze3z83zz__ft_z52schedulerz52(obj_t BgL_envz00_815, obj_t BgL_t1z00_816, obj_t BgL_t2z00_817)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 205 */
{ 
obj_t BgL_t1z00_658;obj_t BgL_t2z00_659;
{ /* ./Llib/_scheduler.scm 259 */
bool_t BgL_auxz00_1853;
BgL_t1z00_658 = BgL_t1z00_816; 
BgL_t2z00_659 = BgL_t2z00_817; 
{ /* ./Llib/_scheduler.scm 259 */
long BgL_n1z00_666;long BgL_n2z00_667;
{ /* ./Llib/_scheduler.scm 259 */
BgL_threadz00_bglt BgL_obj1025z00_664;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_t1z00_658, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 259 */
BgL_obj1025z00_664 = 
(BgL_threadz00_bglt)(BgL_t1z00_658); }  else 
{ /* ./Llib/_scheduler.scm 259 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)15)), BGl_string3003z00zz__ft_z52schedulerz52, BgL_t1z00_658); 
exit( -1 );} 
BgL_n1z00_666 = 
(long)(
(((BgL_threadz00_bglt)CREF(BgL_obj1025z00_664))->BgL_z52identz52)); } 
{ /* ./Llib/_scheduler.scm 259 */
BgL_threadz00_bglt BgL_obj1025z00_665;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_t2z00_659, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 259 */
BgL_obj1025z00_665 = 
(BgL_threadz00_bglt)(BgL_t2z00_659); }  else 
{ /* ./Llib/_scheduler.scm 259 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)15)), BGl_string3003z00zz__ft_z52schedulerz52, BgL_t2z00_659); 
exit( -1 );} 
BgL_n2z00_667 = 
(long)(
(((BgL_threadz00_bglt)CREF(BgL_obj1025z00_665))->BgL_z52identz52)); } 
BgL_auxz00_1853 = 
(BgL_n1z00_666<BgL_n2z00_667); } 
return 
BBOOL(BgL_auxz00_1853);} } } 
}



/* <anonymous:1694> */
obj_t BGl_zc3anonymousza31694ze3z83zz__ft_z52schedulerz52(obj_t BgL_envz00_818, obj_t BgL_tz00_821)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 240 */
{ /* ./Llib/_scheduler.scm 241 */
obj_t BgL_instance1455z00_819;obj_t BgL_runnablez00_820;
BgL_instance1455z00_819 = 
PROCEDURE_REF(BgL_envz00_818, 
(int)(((long)0))); 
BgL_runnablez00_820 = 
PROCEDURE_REF(BgL_envz00_818, 
(int)(((long)1))); 
{ 
obj_t BgL_tz00_330;
{ /* ./Llib/_scheduler.scm 241 */
bool_t BgL_auxz00_1876;
BgL_tz00_330 = BgL_tz00_821; 
{ 

{ /* ./Llib/_scheduler.scm 242 */
int BgL_aux1460z00_334;
{ /* ./Llib/_scheduler.scm 242 */
BgL_threadz00_bglt BgL_obj1004z00_629;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_tz00_330, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 242 */
BgL_obj1004z00_629 = 
(BgL_threadz00_bglt)(BgL_tz00_330); }  else 
{ /* ./Llib/_scheduler.scm 242 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)16)), BGl_string3003z00zz__ft_z52schedulerz52, BgL_tz00_330); 
exit( -1 );} 
BgL_aux1460z00_334 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1004z00_629))->BgL_z52timeoutz52); } 
switch( 
(long)(BgL_aux1460z00_334)) { case ((long)0) : 

BgL_auxz00_1876 = ((bool_t)0); break;case ((long)1) : 

{ /* ./Llib/_scheduler.scm 249 */
BgL_threadz00_bglt BgL_tz00_630;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_tz00_330, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 249 */
BgL_tz00_630 = 
(BgL_threadz00_bglt)(BgL_tz00_330); }  else 
{ /* ./Llib/_scheduler.scm 249 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)16)), BGl_string3003z00zz__ft_z52schedulerz52, BgL_tz00_330); 
exit( -1 );} 
{ 
obj_t BgL_l1498z00_633;
{ /* ./Llib/_scheduler.scm 249 */
obj_t BgL_arg2021z00_638;
BgL_arg2021z00_638 = 
(((BgL_threadz00_bglt)CREF(BgL_tz00_630))->BgL_z52signalsz52); 
BgL_l1498z00_633 = BgL_arg2021z00_638; 
BgL_forzd2each1499zd2_632:
if(
PAIRP(BgL_l1498z00_633))
{ /* ./Llib/_scheduler.scm 249 */
{ /* ./Llib/_scheduler.scm 249 */
obj_t BgL_sz00_635;
{ /* ./Llib/_scheduler.scm 249 */
obj_t BgL_pairz00_641;
if(
PAIRP(BgL_l1498z00_633))
{ /* ./Llib/_scheduler.scm 249 */
BgL_pairz00_641 = BgL_l1498z00_633; }  else 
{ /* ./Llib/_scheduler.scm 249 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)16)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_l1498z00_633); 
exit( -1 );} 
BgL_sz00_635 = 
CAR(BgL_pairz00_641); } 
BGl_signalzd2unbindzd2threadz12z12zz__ft_signalz00(BgL_sz00_635, BgL_tz00_630); } 
{ /* ./Llib/_scheduler.scm 249 */
obj_t BgL_arg2028z00_636;
{ /* ./Llib/_scheduler.scm 249 */
obj_t BgL_pairz00_642;
if(
PAIRP(BgL_l1498z00_633))
{ /* ./Llib/_scheduler.scm 249 */
BgL_pairz00_642 = BgL_l1498z00_633; }  else 
{ /* ./Llib/_scheduler.scm 249 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)16)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_l1498z00_633); 
exit( -1 );} 
BgL_arg2028z00_636 = 
CDR(BgL_pairz00_642); } 
{ 
obj_t BgL_l1498z00_1906;
BgL_l1498z00_1906 = BgL_arg2028z00_636; 
BgL_l1498z00_633 = BgL_l1498z00_1906; 
goto BgL_forzd2each1499zd2_632;} } }  else 
{ /* ./Llib/_scheduler.scm 249 */
if(
NULLP(BgL_l1498z00_633))
{ /* ./Llib/_scheduler.scm 249 */BTRUE; }  else 
{ /* ./Llib/_scheduler.scm 249 */
FAILURE(BGl_string3007z00zz__ft_z52schedulerz52,BGl_string3008z00zz__ft_z52schedulerz52,BgL_l1498z00_633);} } } } } 
{ /* ./Llib/_scheduler.scm 250 */
obj_t BgL_auxz00_822;
BgL_auxz00_822 = 
MAKE_PAIR(BgL_tz00_330, 
CELL_REF(BgL_runnablez00_820)); 
CELL_SET(BgL_runnablez00_820, BgL_auxz00_822); } 
BgL_auxz00_1876 = ((bool_t)0); break;
default: 
{ /* ./Llib/_scheduler.scm 254 */
long BgL_arg1707z00_339;
{ /* ./Llib/_scheduler.scm 254 */
long BgL_za71za7_648;
{ /* ./Llib/_scheduler.scm 254 */
BgL_threadz00_bglt BgL_obj1004z00_647;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_tz00_330, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 254 */
BgL_obj1004z00_647 = 
(BgL_threadz00_bglt)(BgL_tz00_330); }  else 
{ /* ./Llib/_scheduler.scm 254 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)16)), BGl_string3003z00zz__ft_z52schedulerz52, BgL_tz00_330); 
exit( -1 );} 
BgL_za71za7_648 = 
(long)(
(((BgL_threadz00_bglt)CREF(BgL_obj1004z00_647))->BgL_z52timeoutz52)); } 
BgL_arg1707z00_339 = 
(BgL_za71za7_648-((long)1)); } 
{ /* ./Llib/_scheduler.scm 254 */
BgL_threadz00_bglt BgL_obj1006z00_650;int BgL_val1005z00_651;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_tz00_330, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 254 */
BgL_obj1006z00_650 = 
(BgL_threadz00_bglt)(BgL_tz00_330); }  else 
{ /* ./Llib/_scheduler.scm 254 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)16)), BGl_string3003z00zz__ft_z52schedulerz52, BgL_tz00_330); 
exit( -1 );} 
BgL_val1005z00_651 = 
(int)(BgL_arg1707z00_339); 
((((BgL_threadz00_bglt)CREF(BgL_obj1006z00_650))->BgL_z52timeoutz52) = ((int)BgL_val1005z00_651), BUNSPEC); } } 
{ /* ./Llib/_scheduler.scm 255 */
BgL_z52schedulerz52_bglt BgL_obj1183z00_652;bool_t BgL_val1182z00_653;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_instance1455z00_819, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/_scheduler.scm 255 */
BgL_obj1183z00_652 = 
(BgL_z52schedulerz52_bglt)(BgL_instance1455z00_819); }  else 
{ /* ./Llib/_scheduler.scm 255 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)16)), BGl_string3002z00zz__ft_z52schedulerz52, BgL_instance1455z00_819); 
exit( -1 );} 
BgL_val1182z00_653 = ((bool_t)1); 
((((BgL_z52schedulerz52_bglt)CREF(BgL_obj1183z00_652))->BgL_z52threadszd2readyz80) = ((bool_t)BgL_val1182z00_653), BUNSPEC); } 
BgL_auxz00_1876 = ((bool_t)1); } } } 
return 
BBOOL(BgL_auxz00_1876);} } } } 
}



/* %start-new-threads */
obj_t BGl_z52startzd2newzd2threadsz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_sz00_25)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 267 */
{ /* ./Llib/_scheduler.scm 269 */
bool_t BgL_testz00_1938;
{ /* ./Llib/_scheduler.scm 269 */
obj_t BgL_auxz00_1939;
BgL_auxz00_1939 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_sz00_25))->BgL_tostartz00); 
BgL_testz00_1938 = 
PAIRP(BgL_auxz00_1939); } 
if(BgL_testz00_1938)
{ /* ./Llib/_scheduler.scm 269 */
{ /* ./Llib/_scheduler.scm 273 */
obj_t BgL_arg1727z00_346;
{ /* ./Llib/_scheduler.scm 273 */
obj_t BgL_arg1731z00_347;obj_t BgL_arg1732z00_348;
BgL_arg1731z00_347 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_sz00_25))->BgL_threadszd2runnablezd2); 
{ /* ./Llib/_scheduler.scm 273 */
obj_t BgL_arg1736z00_349;
BgL_arg1736z00_349 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_sz00_25))->BgL_tostartz00); 
BgL_arg1732z00_348 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_arg1736z00_349); } 
BgL_arg1727z00_346 = 
BGl_appendz12z12zz__r4_pairs_and_lists_6_3z00(BgL_arg1731z00_347, BgL_arg1732z00_348); } 
((((BgL_z52schedulerz52_bglt)CREF(BgL_sz00_25))->BgL_threadszd2runnablezd2) = ((obj_t)BgL_arg1727z00_346), BUNSPEC); } 
return 
((((BgL_z52schedulerz52_bglt)CREF(BgL_sz00_25))->BgL_tostartz00) = ((obj_t)BNIL), BUNSPEC);}  else 
{ /* ./Llib/_scheduler.scm 269 */
return BFALSE;} } } 
}



/* %terminate-threads */
obj_t BGl_z52terminatezd2threadsz80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_26)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 281 */
{ /* ./Llib/_scheduler.scm 286 */
bool_t BgL_testz00_1948;
{ /* ./Llib/_scheduler.scm 286 */
obj_t BgL_auxz00_1949;
BgL_auxz00_1949 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_26))->BgL_toterminatez00); 
BgL_testz00_1948 = 
PAIRP(BgL_auxz00_1949); } 
if(BgL_testz00_1948)
{ /* ./Llib/_scheduler.scm 286 */
{ /* ./Llib/_scheduler.scm 291 */
obj_t BgL_thdsz00_353;
{ /* ./Llib/_scheduler.scm 291 */
obj_t BgL_arg1781z00_379;
BgL_arg1781z00_379 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_26))->BgL_toterminatez00); 
BgL_thdsz00_353 = 
BGl_filterz12z12zz__r4_control_features_6_9z00(BGl_proc3010z00zz__ft_z52schedulerz52, BgL_arg1781z00_379); } 
((((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_26))->BgL_toterminatez00) = ((obj_t)BNIL), BUNSPEC); 
{ /* ./Llib/_scheduler.scm 302 */
obj_t BgL_runnablez00_354;obj_t BgL_yieldz00_355;obj_t BgL_timeoutz00_356;
{ /* ./Llib/_scheduler.scm 302 */
obj_t BgL_arg1753z00_358;
BgL_arg1753z00_358 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_26))->BgL_threadszd2runnablezd2); 
BgL_runnablez00_354 = 
BGl_filterz12z12zz__r4_control_features_6_9z00(BGl_proc3011z00zz__ft_z52schedulerz52, BgL_arg1753z00_358); } 
{ /* ./Llib/_scheduler.scm 305 */
obj_t BgL_arg1762z00_365;
BgL_arg1762z00_365 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_26))->BgL_threadszd2yieldzd2); 
BgL_yieldz00_355 = 
BGl_filterz12z12zz__r4_control_features_6_9z00(BGl_proc3012z00zz__ft_z52schedulerz52, BgL_arg1762z00_365); } 
{ /* ./Llib/_scheduler.scm 308 */
obj_t BgL_arg1772z00_372;
BgL_arg1772z00_372 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_26))->BgL_threadszd2timeoutzd2); 
BgL_timeoutz00_356 = 
BGl_filterz12z12zz__r4_control_features_6_9z00(BGl_proc3013z00zz__ft_z52schedulerz52, BgL_arg1772z00_372); } 
((((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_26))->BgL_threadszd2runnablezd2) = ((obj_t)BgL_thdsz00_353), BUNSPEC); 
BGl_z52schedulerzd2switchzd2tozd2nextzd2threadz52zz__ft_z52schedulerz52(
(BgL_threadz00_bglt)(BgL_scdlz00_26), 
(BgL_schedulerz00_bglt)(BgL_scdlz00_26)); 
((((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_26))->BgL_threadszd2runnablezd2) = ((obj_t)BgL_runnablez00_354), BUNSPEC); 
((((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_26))->BgL_threadszd2yieldzd2) = ((obj_t)BgL_yieldz00_355), BUNSPEC); 
return 
((((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_26))->BgL_threadszd2timeoutzd2) = ((obj_t)BgL_timeoutz00_356), BUNSPEC);} } }  else 
{ /* ./Llib/_scheduler.scm 286 */
return BFALSE;} } } 
}



/* <anonymous:1774> */
obj_t BGl_zc3anonymousza31774ze3z83zz__ft_z52schedulerz52(obj_t BgL_envz00_827, obj_t BgL_tz00_828)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 308 */
{ 
obj_t BgL_tz00_373;
{ /* ./Llib/_scheduler.scm 309 */
bool_t BgL_auxz00_1968;
BgL_tz00_373 = BgL_tz00_828; 
{ /* ./Llib/_scheduler.scm 309 */
bool_t BgL_testz00_1969;
{ /* ./Llib/_scheduler.scm 309 */
BgL_threadz00_bglt BgL_auxz00_1970;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_tz00_373, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 309 */
BgL_auxz00_1970 = 
(BgL_threadz00_bglt)(BgL_tz00_373)
; }  else 
{ /* ./Llib/_scheduler.scm 309 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)17)), BGl_string3003z00zz__ft_z52schedulerz52, BgL_tz00_373); 
exit( -1 );} 
BgL_testz00_1969 = 
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(BgL_auxz00_1970, BNIL); } 
if(BgL_testz00_1969)
{ /* ./Llib/_scheduler.scm 309 */
BgL_auxz00_1968 = ((bool_t)0)
; }  else 
{ /* ./Llib/_scheduler.scm 309 */
BgL_auxz00_1968 = ((bool_t)1)
; } } 
return 
BBOOL(BgL_auxz00_1968);} } } 
}



/* <anonymous:1764> */
obj_t BGl_zc3anonymousza31764ze3z83zz__ft_z52schedulerz52(obj_t BgL_envz00_829, obj_t BgL_tz00_830)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 305 */
{ 
obj_t BgL_tz00_366;
{ /* ./Llib/_scheduler.scm 306 */
bool_t BgL_auxz00_1979;
BgL_tz00_366 = BgL_tz00_830; 
{ /* ./Llib/_scheduler.scm 306 */
bool_t BgL_testz00_1980;
{ /* ./Llib/_scheduler.scm 306 */
BgL_threadz00_bglt BgL_auxz00_1981;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_tz00_366, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 306 */
BgL_auxz00_1981 = 
(BgL_threadz00_bglt)(BgL_tz00_366)
; }  else 
{ /* ./Llib/_scheduler.scm 306 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)18)), BGl_string3003z00zz__ft_z52schedulerz52, BgL_tz00_366); 
exit( -1 );} 
BgL_testz00_1980 = 
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(BgL_auxz00_1981, BNIL); } 
if(BgL_testz00_1980)
{ /* ./Llib/_scheduler.scm 306 */
BgL_auxz00_1979 = ((bool_t)0)
; }  else 
{ /* ./Llib/_scheduler.scm 306 */
BgL_auxz00_1979 = ((bool_t)1)
; } } 
return 
BBOOL(BgL_auxz00_1979);} } } 
}



/* <anonymous:1755> */
obj_t BGl_zc3anonymousza31755ze3z83zz__ft_z52schedulerz52(obj_t BgL_envz00_831, obj_t BgL_tz00_832)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 302 */
{ 
obj_t BgL_tz00_359;
{ /* ./Llib/_scheduler.scm 303 */
bool_t BgL_auxz00_1990;
BgL_tz00_359 = BgL_tz00_832; 
{ /* ./Llib/_scheduler.scm 303 */
bool_t BgL_testz00_1991;
{ /* ./Llib/_scheduler.scm 303 */
BgL_threadz00_bglt BgL_auxz00_1992;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_tz00_359, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 303 */
BgL_auxz00_1992 = 
(BgL_threadz00_bglt)(BgL_tz00_359)
; }  else 
{ /* ./Llib/_scheduler.scm 303 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)19)), BGl_string3003z00zz__ft_z52schedulerz52, BgL_tz00_359); 
exit( -1 );} 
BgL_testz00_1991 = 
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(BgL_auxz00_1992, BNIL); } 
if(BgL_testz00_1991)
{ /* ./Llib/_scheduler.scm 303 */
BgL_auxz00_1990 = ((bool_t)0)
; }  else 
{ /* ./Llib/_scheduler.scm 303 */
BgL_auxz00_1990 = ((bool_t)1)
; } } 
return 
BBOOL(BgL_auxz00_1990);} } } 
}



/* <anonymous:1783> */
obj_t BGl_zc3anonymousza31783ze3z83zz__ft_z52schedulerz52(obj_t BgL_envz00_833, obj_t BgL_tz00_834)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 291 */
{ 
obj_t BgL_tz00_380;
{ /* ./Llib/_scheduler.scm 292 */
bool_t BgL_auxz00_2001;
BgL_tz00_380 = BgL_tz00_834; 
{ /* ./Llib/_scheduler.scm 292 */
bool_t BgL_testz00_2002;
{ /* ./Llib/_scheduler.scm 292 */
BgL_threadz00_bglt BgL_auxz00_2003;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_tz00_380, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 292 */
BgL_auxz00_2003 = 
(BgL_threadz00_bglt)(BgL_tz00_380)
; }  else 
{ /* ./Llib/_scheduler.scm 292 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)20)), BGl_string3003z00zz__ft_z52schedulerz52, BgL_tz00_380); 
exit( -1 );} 
BgL_testz00_2002 = 
BGl_z52threadzd2iszd2toterminatez52zz__ft_z52threadz52(BgL_auxz00_2003, BNIL); } 
if(BgL_testz00_2002)
{ /* ./Llib/_scheduler.scm 292 */
{ /* ./Llib/_scheduler.scm 294 */
obj_t BgL_list1785z00_383;
BgL_list1785z00_383 = 
MAKE_PAIR(BTRUE, BNIL); 
{ /* ./Llib/_scheduler.scm 294 */
BgL_threadz00_bglt BgL_auxz00_2012;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_tz00_380, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 294 */
BgL_auxz00_2012 = 
(BgL_threadz00_bglt)(BgL_tz00_380)
; }  else 
{ /* ./Llib/_scheduler.scm 294 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)20)), BGl_string3003z00zz__ft_z52schedulerz52, BgL_tz00_380); 
exit( -1 );} 
BGl_z52threadzd2iszd2terminatedz52zz__ft_z52threadz52(BgL_auxz00_2012, BgL_list1785z00_383); } } 
BgL_auxz00_2001 = ((bool_t)1); }  else 
{ /* ./Llib/_scheduler.scm 292 */
BgL_auxz00_2001 = ((bool_t)0)
; } } 
return 
BBOOL(BgL_auxz00_2001);} } } 
}



/* %suspend/resume-threads */
obj_t BGl_z52suspendzf2resumezd2threadsz72zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_27)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 326 */
{ /* ./Llib/_scheduler.scm 328 */
bool_t BgL_testz00_2021;
{ /* ./Llib/_scheduler.scm 328 */
obj_t BgL_auxz00_2022;
BgL_auxz00_2022 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_27))->BgL_tosuspendzf2resumezf2); 
BgL_testz00_2021 = 
PAIRP(BgL_auxz00_2022); } 
if(BgL_testz00_2021)
{ /* ./Llib/_scheduler.scm 328 */
{ 
obj_t BgL_l1470z00_389;
{ /* ./Llib/_scheduler.scm 332 */
obj_t BgL_arg1796z00_391;
{ /* ./Llib/_scheduler.scm 332 */
obj_t BgL_arg1799z00_392;
BgL_arg1799z00_392 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_27))->BgL_tosuspendzf2resumezf2); 
BgL_arg1796z00_391 = 
BGl_reversez12z12zz__r4_pairs_and_lists_6_3z00(BgL_arg1799z00_392); } 
BgL_l1470z00_389 = BgL_arg1796z00_391; 
BgL_forzd2each1471zd2_390:
if(
PAIRP(BgL_l1470z00_389))
{ /* ./Llib/_scheduler.scm 330 */
{ /* ./Llib/_scheduler.scm 331 */
obj_t BgL_vz00_394;
{ /* ./Llib/_scheduler.scm 331 */
obj_t BgL_pairz00_706;
if(
PAIRP(BgL_l1470z00_389))
{ /* ./Llib/_scheduler.scm 331 */
BgL_pairz00_706 = BgL_l1470z00_389; }  else 
{ /* ./Llib/_scheduler.scm 331 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)21)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_l1470z00_389); 
exit( -1 );} 
BgL_vz00_394 = 
CAR(BgL_pairz00_706); } 
{ /* ./Llib/_scheduler.scm 331 */
obj_t BgL_arg1804z00_395;obj_t BgL_arg1805z00_396;
{ /* ./Llib/_scheduler.scm 331 */
obj_t BgL_pairz00_707;
if(
PAIRP(BgL_vz00_394))
{ /* ./Llib/_scheduler.scm 331 */
BgL_pairz00_707 = BgL_vz00_394; }  else 
{ /* ./Llib/_scheduler.scm 331 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)21)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_vz00_394); 
exit( -1 );} 
BgL_arg1804z00_395 = 
CAR(BgL_pairz00_707); } 
{ /* ./Llib/_scheduler.scm 331 */
obj_t BgL_pairz00_708;
if(
PAIRP(BgL_vz00_394))
{ /* ./Llib/_scheduler.scm 331 */
BgL_pairz00_708 = BgL_vz00_394; }  else 
{ /* ./Llib/_scheduler.scm 331 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)21)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_vz00_394); 
exit( -1 );} 
BgL_arg1805z00_396 = 
CDR(BgL_pairz00_708); } 
{ /* ./Llib/_scheduler.scm 331 */
BgL_threadz00_bglt BgL_obj1012z00_709;bool_t BgL_val1011z00_710;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_arg1804z00_395, BGl_threadz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 331 */
BgL_obj1012z00_709 = 
(BgL_threadz00_bglt)(BgL_arg1804z00_395); }  else 
{ /* ./Llib/_scheduler.scm 331 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)21)), BGl_string3003z00zz__ft_z52schedulerz52, BgL_arg1804z00_395); 
exit( -1 );} 
BgL_val1011z00_710 = 
CBOOL(BgL_arg1805z00_396); 
((((BgL_threadz00_bglt)CREF(BgL_obj1012z00_709))->BgL_z52iszd2suspendz80) = ((bool_t)BgL_val1011z00_710), BUNSPEC); } } } 
{ /* ./Llib/_scheduler.scm 330 */
obj_t BgL_arg1811z00_397;
{ /* ./Llib/_scheduler.scm 330 */
obj_t BgL_pairz00_711;
if(
PAIRP(BgL_l1470z00_389))
{ /* ./Llib/_scheduler.scm 330 */
BgL_pairz00_711 = BgL_l1470z00_389; }  else 
{ /* ./Llib/_scheduler.scm 330 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)21)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_l1470z00_389); 
exit( -1 );} 
BgL_arg1811z00_397 = 
CDR(BgL_pairz00_711); } 
{ 
obj_t BgL_l1470z00_2061;
BgL_l1470z00_2061 = BgL_arg1811z00_397; 
BgL_l1470z00_389 = BgL_l1470z00_2061; 
goto BgL_forzd2each1471zd2_390;} } }  else 
{ /* ./Llib/_scheduler.scm 330 */
if(
NULLP(BgL_l1470z00_389))
{ /* ./Llib/_scheduler.scm 330 */BTRUE; }  else 
{ /* ./Llib/_scheduler.scm 330 */
FAILURE(BGl_string3007z00zz__ft_z52schedulerz52,BGl_string3008z00zz__ft_z52schedulerz52,BgL_l1470z00_389);} } } } 
return 
((((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_27))->BgL_tosuspendzf2resumezf2) = ((obj_t)BNIL), BUNSPEC);}  else 
{ /* ./Llib/_scheduler.scm 328 */
return BFALSE;} } } 
}



/* %scheduler-spawn-async */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2spawnzd2asyncz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_28, BgL_z52sigasyncz52_bglt BgL_sigz00_29)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 338 */
if(
(((BgL_z52sigasyncz52_bglt)CREF(BgL_sigz00_29))->BgL_spawnedz00))
{ /* ./Llib/_scheduler.scm 340 */
return BFALSE;}  else 
{ /* ./Llib/_scheduler.scm 342 */
obj_t BgL_ntz00_835;
BgL_ntz00_835 = 
make_fx_procedure(BGl_ntz00zz__ft_z52schedulerz52, 
(int)(((long)0)), 
(int)(((long)3))); 
PROCEDURE_SET(BgL_ntz00_835, 
(int)(((long)0)), 
(obj_t)(BgL_sigz00_29)); 
PROCEDURE_SET(BgL_ntz00_835, 
(int)(((long)1)), 
(obj_t)(BgL_scdlz00_28)); 
PROCEDURE_SET(BgL_ntz00_835, 
(int)(((long)2)), 
(obj_t)(BgL_sigz00_29)); 
((((BgL_z52sigasyncz52_bglt)CREF(BgL_sigz00_29))->BgL_spawnedz00) = ((bool_t)((bool_t)1)), BUNSPEC); 
{ /* ./Llib/_scheduler.scm 345 */
obj_t BgL_arg1827z00_403;obj_t BgL_arg1828z00_404;
{ /* ./Llib/_scheduler.scm 345 */
BgL_threadz00_bglt BgL_obj1003z00_721;
BgL_obj1003z00_721 = 
(BgL_threadz00_bglt)(BgL_scdlz00_28); 
BgL_arg1827z00_403 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_721))->BgL_z52builtinz52); } 
BgL_arg1828z00_404 = 
(((BgL_z52sigasyncz52_bglt)CREF(BgL_sigz00_29))->BgL_idz00); 
{ /* ./Llib/_scheduler.scm 345 */
bglthread_t BgL_auxz00_2084;
{ /* ./Llib/_scheduler.scm 345 */
obj_t BgL_auxz00_2085;
{ /* ./Llib/_scheduler.scm 345 */
obj_t BgL_aux2740z00_1023;
if(
FOREIGNP(BgL_arg1827z00_403))
{ /* ./Llib/_scheduler.scm 345 */
BgL_aux2740z00_1023 = BgL_arg1827z00_403; }  else 
{ /* ./Llib/_scheduler.scm 345 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_arg1827z00_403); 
exit( -1 );} 
{ /* ./Llib/_scheduler.scm 345 */
bool_t BgL_testz00_2091;
if(
FOREIGNP(BgL_aux2740z00_1023))
{ /* ./Llib/_scheduler.scm 345 */
obj_t BgL_arg1502z00_1192;obj_t BgL_arg1503z00_1193;
{ /* ./Llib/_scheduler.scm 345 */
obj_t BgL_auxz00_2094;
if(
FOREIGNP(BgL_aux2740z00_1023))
{ /* ./Llib/_scheduler.scm 345 */
BgL_auxz00_2094 = BgL_aux2740z00_1023
; }  else 
{ /* ./Llib/_scheduler.scm 345 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2995z00zz__ft_z52schedulerz52, BgL_aux2740z00_1023); 
exit( -1 );} 
BgL_arg1502z00_1192 = 
FOREIGN_ID(BgL_auxz00_2094); } 
BgL_arg1503z00_1193 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_2091 = 
(BgL_arg1502z00_1192==BgL_arg1503z00_1193); }  else 
{ /* ./Llib/_scheduler.scm 345 */
BgL_testz00_2091 = ((bool_t)0)
; } 
if(BgL_testz00_2091)
{ /* ./Llib/_scheduler.scm 345 */
BgL_auxz00_2085 = BgL_aux2740z00_1023
; }  else 
{ /* ./Llib/_scheduler.scm 345 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)22)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_aux2740z00_1023); 
exit( -1 );} } } 
BgL_auxz00_2084 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_2085); } 
bglasync_spawn(BgL_auxz00_2084, BgL_ntz00_835, BgL_arg1828z00_404); } } 
return BUNSPEC;} } 
}



/* _%scheduler-spawn-async */
obj_t BGl__z52schedulerzd2spawnzd2asyncz52zz__ft_z52schedulerz52(obj_t BgL_envz00_836, obj_t BgL_scdlz00_837, obj_t BgL_sigz00_838)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 338 */
{ /* ./Llib/_scheduler.scm 339 */
BgL_z52sigasyncz52_bglt BgL_auxz00_2115;BgL_z52schedulerz52_bglt BgL_auxz00_2108;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_sigz00_838, BGl_z52sigasyncz52zz__ft_z52typesz52))
{ /* ./Llib/_scheduler.scm 339 */
BgL_auxz00_2115 = 
(BgL_z52sigasyncz52_bglt)(BgL_sigz00_838)
; }  else 
{ /* ./Llib/_scheduler.scm 339 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)23)), BGl_string3004z00zz__ft_z52schedulerz52, BgL_sigz00_838); 
exit( -1 );} 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_837, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/_scheduler.scm 339 */
BgL_auxz00_2108 = 
(BgL_z52schedulerz52_bglt)(BgL_scdlz00_837)
; }  else 
{ /* ./Llib/_scheduler.scm 339 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)23)), BGl_string3002z00zz__ft_z52schedulerz52, BgL_scdlz00_837); 
exit( -1 );} 
return 
BGl_z52schedulerzd2spawnzd2asyncz52zz__ft_z52schedulerz52(BgL_auxz00_2108, BgL_auxz00_2115);} } 
}



/* nt */
obj_t BGl_ntz00zz__ft_z52schedulerz52(obj_t BgL_envz00_839)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 341 */
{ /* ./Llib/_scheduler.scm 342 */
obj_t BgL_instance1472z00_840;obj_t BgL_scdlz00_841;obj_t BgL_sigz00_842;
BgL_instance1472z00_840 = 
PROCEDURE_REF(BgL_envz00_839, 
(int)(((long)0))); 
BgL_scdlz00_841 = 
PROCEDURE_REF(BgL_envz00_839, 
(int)(((long)1))); 
BgL_sigz00_842 = 
PROCEDURE_REF(BgL_envz00_839, 
(int)(((long)2))); 
{ 

{ /* ./Llib/_scheduler.scm 342 */
obj_t BgL_arg1834z00_406;
{ /* ./Llib/_scheduler.scm 342 */
obj_t BgL_fun1838z00_407;
{ /* ./Llib/_scheduler.scm 342 */
BgL_z52sigasyncz52_bglt BgL_obj1315z00_723;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_instance1472z00_840, BGl_z52sigasyncz52zz__ft_z52typesz52))
{ /* ./Llib/_scheduler.scm 342 */
BgL_obj1315z00_723 = 
(BgL_z52sigasyncz52_bglt)(BgL_instance1472z00_840); }  else 
{ /* ./Llib/_scheduler.scm 342 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)24)), BGl_string3004z00zz__ft_z52schedulerz52, BgL_instance1472z00_840); 
exit( -1 );} 
BgL_fun1838z00_407 = 
(((BgL_z52sigasyncz52_bglt)CREF(BgL_obj1315z00_723))->BgL_thunkz00); } 
if(
PROCEDURE_CORRECT_ARITYP(BgL_fun1838z00_407, ((long)0)))
{ /* ./Llib/_scheduler.scm 342 */
BgL_arg1834z00_406 = 
PROCEDURE_ENTRY(BgL_fun1838z00_407)(BgL_fun1838z00_407, BEOA); }  else 
{ 
obj_t BgL_auxz00_2140;
BgL_auxz00_2140 = 
CNST_TABLE_REF(((long)25)); 
FAILURE(BGl_string3014z00zz__ft_z52schedulerz52,BgL_auxz00_2140,BgL_fun1838z00_407);} } 
{ /* ./Llib/_scheduler.scm 342 */
BgL_z52schedulerz52_bglt BgL_auxz00_2143;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_841, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/_scheduler.scm 342 */
BgL_auxz00_2143 = 
(BgL_z52schedulerz52_bglt)(BgL_scdlz00_841)
; }  else 
{ /* ./Llib/_scheduler.scm 342 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)24)), BGl_string3002z00zz__ft_z52schedulerz52, BgL_scdlz00_841); 
exit( -1 );} 
BGl_z52schedulerzd2addzd2broadcastz12z40zz__ft_z52schedulerz52(BgL_auxz00_2143, BgL_sigz00_842, BgL_arg1834z00_406); } } 
return BUNSPEC;} } } 
}



/* %spawn-async */
obj_t BGl_z52spawnzd2asyncz80zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_30)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 355 */
{ /* ./Llib/_scheduler.scm 357 */
bool_t BgL_testz00_2151;
{ /* ./Llib/_scheduler.scm 357 */
obj_t BgL_auxz00_2152;
BgL_auxz00_2152 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_30))->BgL_tospawnz00); 
BgL_testz00_2151 = 
PAIRP(BgL_auxz00_2152); } 
if(BgL_testz00_2151)
{ /* ./Llib/_scheduler.scm 357 */
{ 
obj_t BgL_l1476z00_411;
{ /* ./Llib/_scheduler.scm 359 */
obj_t BgL_arg1843z00_413;
BgL_arg1843z00_413 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_30))->BgL_tospawnz00); 
BgL_l1476z00_411 = BgL_arg1843z00_413; 
BgL_forzd2each1477zd2_412:
if(
PAIRP(BgL_l1476z00_411))
{ /* ./Llib/_scheduler.scm 359 */
{ /* ./Llib/_scheduler.scm 359 */
obj_t BgL_sz00_415;
{ /* ./Llib/_scheduler.scm 359 */
obj_t BgL_pairz00_728;
if(
PAIRP(BgL_l1476z00_411))
{ /* ./Llib/_scheduler.scm 359 */
BgL_pairz00_728 = BgL_l1476z00_411; }  else 
{ /* ./Llib/_scheduler.scm 359 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)26)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_l1476z00_411); 
exit( -1 );} 
BgL_sz00_415 = 
CAR(BgL_pairz00_728); } 
{ /* ./Llib/_scheduler.scm 359 */
BgL_z52sigasyncz52_bglt BgL_auxz00_2164;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_sz00_415, BGl_z52sigasyncz52zz__ft_z52typesz52))
{ /* ./Llib/_scheduler.scm 359 */
BgL_auxz00_2164 = 
(BgL_z52sigasyncz52_bglt)(BgL_sz00_415)
; }  else 
{ /* ./Llib/_scheduler.scm 359 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)26)), BGl_string3004z00zz__ft_z52schedulerz52, BgL_sz00_415); 
exit( -1 );} 
BGl_z52schedulerzd2spawnzd2asyncz52zz__ft_z52schedulerz52(BgL_scdlz00_30, BgL_auxz00_2164); } } 
{ /* ./Llib/_scheduler.scm 359 */
obj_t BgL_arg1850z00_416;
{ /* ./Llib/_scheduler.scm 359 */
obj_t BgL_pairz00_729;
if(
PAIRP(BgL_l1476z00_411))
{ /* ./Llib/_scheduler.scm 359 */
BgL_pairz00_729 = BgL_l1476z00_411; }  else 
{ /* ./Llib/_scheduler.scm 359 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)26)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_l1476z00_411); 
exit( -1 );} 
BgL_arg1850z00_416 = 
CDR(BgL_pairz00_729); } 
{ 
obj_t BgL_l1476z00_2178;
BgL_l1476z00_2178 = BgL_arg1850z00_416; 
BgL_l1476z00_411 = BgL_l1476z00_2178; 
goto BgL_forzd2each1477zd2_412;} } }  else 
{ /* ./Llib/_scheduler.scm 359 */
if(
NULLP(BgL_l1476z00_411))
{ /* ./Llib/_scheduler.scm 359 */BTRUE; }  else 
{ /* ./Llib/_scheduler.scm 359 */
FAILURE(BGl_string3007z00zz__ft_z52schedulerz52,BGl_string3008z00zz__ft_z52schedulerz52,BgL_l1476z00_411);} } } } 
return 
((((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_30))->BgL_tospawnz00) = ((obj_t)BNIL), BUNSPEC);}  else 
{ /* ./Llib/_scheduler.scm 357 */
return BFALSE;} } } 
}



/* %broadcast! */
BGL_EXPORTED_DEF obj_t BGl_z52broadcastz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_31, obj_t BgL_sigz00_32, obj_t BgL_valz00_33)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 365 */
{ /* ./Llib/_scheduler.scm 366 */
obj_t BgL_arg1865z00_737;
{ /* ./Llib/_scheduler.scm 366 */
BgL_schedulerz00_bglt BgL_obj1104z00_738;
BgL_obj1104z00_738 = 
(BgL_schedulerz00_bglt)(BgL_scdlz00_31); 
BgL_arg1865z00_737 = 
(((BgL_schedulerz00_bglt)CREF(BgL_obj1104z00_738))->BgL_envzb2zb2); } 
return 
BGl_signalzd2emitzd2zz__ft_signalz00(BgL_sigz00_32, BgL_valz00_33, BgL_arg1865z00_737);} } 
}



/* _%broadcast! */
obj_t BGl__z52broadcastz12z40zz__ft_z52schedulerz52(obj_t BgL_envz00_843, obj_t BgL_scdlz00_844, obj_t BgL_sigz00_845, obj_t BgL_valz00_846)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 365 */
{ /* ./Llib/_scheduler.scm 366 */
BgL_z52schedulerz52_bglt BgL_auxz00_2186;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_844, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/_scheduler.scm 366 */
BgL_auxz00_2186 = 
(BgL_z52schedulerz52_bglt)(BgL_scdlz00_844)
; }  else 
{ /* ./Llib/_scheduler.scm 366 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)27)), BGl_string3002z00zz__ft_z52schedulerz52, BgL_scdlz00_844); 
exit( -1 );} 
return 
BGl_z52broadcastz12z40zz__ft_z52schedulerz52(BgL_auxz00_2186, BgL_sigz00_845, BgL_valz00_846);} } 
}



/* %scheduler-broadcast*! */
obj_t BGl_z52schedulerzd2broadcastza2z12z30zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_34)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 372 */
{ /* ./Llib/_scheduler.scm 373 */
obj_t BgL_arg1869z00_422;
{ /* ./Llib/_scheduler.scm 373 */
BgL_threadz00_bglt BgL_obj1003z00_739;
BgL_obj1003z00_739 = 
(BgL_threadz00_bglt)(BgL_scdlz00_34); 
BgL_arg1869z00_422 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_739))->BgL_z52builtinz52); } 
{ /* ./Llib/_scheduler.scm 373 */
bglthread_t BgL_auxz00_2196;
{ /* ./Llib/_scheduler.scm 373 */
obj_t BgL_auxz00_2197;
{ /* ./Llib/_scheduler.scm 373 */
obj_t BgL_aux2827z00_1046;
if(
FOREIGNP(BgL_arg1869z00_422))
{ /* ./Llib/_scheduler.scm 373 */
BgL_aux2827z00_1046 = BgL_arg1869z00_422; }  else 
{ /* ./Llib/_scheduler.scm 373 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_arg1869z00_422); 
exit( -1 );} 
{ /* ./Llib/_scheduler.scm 373 */
bool_t BgL_testz00_2203;
if(
FOREIGNP(BgL_aux2827z00_1046))
{ /* ./Llib/_scheduler.scm 373 */
obj_t BgL_arg1502z00_1201;obj_t BgL_arg1503z00_1202;
{ /* ./Llib/_scheduler.scm 373 */
obj_t BgL_auxz00_2206;
if(
FOREIGNP(BgL_aux2827z00_1046))
{ /* ./Llib/_scheduler.scm 373 */
BgL_auxz00_2206 = BgL_aux2827z00_1046
; }  else 
{ /* ./Llib/_scheduler.scm 373 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2995z00zz__ft_z52schedulerz52, BgL_aux2827z00_1046); 
exit( -1 );} 
BgL_arg1502z00_1201 = 
FOREIGN_ID(BgL_auxz00_2206); } 
BgL_arg1503z00_1202 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_2203 = 
(BgL_arg1502z00_1201==BgL_arg1503z00_1202); }  else 
{ /* ./Llib/_scheduler.scm 373 */
BgL_testz00_2203 = ((bool_t)0)
; } 
if(BgL_testz00_2203)
{ /* ./Llib/_scheduler.scm 373 */
BgL_auxz00_2197 = BgL_aux2827z00_1046
; }  else 
{ /* ./Llib/_scheduler.scm 373 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_aux2827z00_1046); 
exit( -1 );} } } 
BgL_auxz00_2196 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_2197); } 
bglasync_synchronize(BgL_auxz00_2196); } } 
{ /* ./Llib/_scheduler.scm 373 */
obj_t BgL_g1480z00_423;
{ /* ./Llib/_scheduler.scm 376 */
bool_t BgL_testz00_2220;
{ /* ./Llib/_scheduler.scm 376 */
obj_t BgL_auxz00_2221;
BgL_auxz00_2221 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_34))->BgL_tobroadcastz00); 
BgL_testz00_2220 = 
PAIRP(BgL_auxz00_2221); } 
if(BgL_testz00_2220)
{ /* ./Llib/_scheduler.scm 376 */
{ 
obj_t BgL_l1485z00_427;
{ /* ./Llib/_scheduler.scm 378 */
obj_t BgL_arg1879z00_429;
BgL_arg1879z00_429 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_34))->BgL_tobroadcastz00); 
BgL_l1485z00_427 = BgL_arg1879z00_429; 
BgL_forzd2each1486zd2_428:
if(
PAIRP(BgL_l1485z00_427))
{ /* ./Llib/_scheduler.scm 378 */
{ /* ./Llib/_scheduler.scm 379 */
obj_t BgL_sigz00_431;
{ /* ./Llib/_scheduler.scm 379 */
obj_t BgL_pairz00_744;
if(
PAIRP(BgL_l1485z00_427))
{ /* ./Llib/_scheduler.scm 379 */
BgL_pairz00_744 = BgL_l1485z00_427; }  else 
{ /* ./Llib/_scheduler.scm 379 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_l1485z00_427); 
exit( -1 );} 
BgL_sigz00_431 = 
CAR(BgL_pairz00_744); } 
{ /* ./Llib/_scheduler.scm 379 */
obj_t BgL_arg1884z00_432;obj_t BgL_arg1885z00_433;
{ /* ./Llib/_scheduler.scm 379 */
obj_t BgL_pairz00_745;
if(
PAIRP(BgL_sigz00_431))
{ /* ./Llib/_scheduler.scm 379 */
BgL_pairz00_745 = BgL_sigz00_431; }  else 
{ /* ./Llib/_scheduler.scm 379 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_sigz00_431); 
exit( -1 );} 
BgL_arg1884z00_432 = 
CAR(BgL_pairz00_745); } 
{ /* ./Llib/_scheduler.scm 379 */
obj_t BgL_pairz00_746;
if(
PAIRP(BgL_sigz00_431))
{ /* ./Llib/_scheduler.scm 379 */
BgL_pairz00_746 = BgL_sigz00_431; }  else 
{ /* ./Llib/_scheduler.scm 379 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_sigz00_431); 
exit( -1 );} 
BgL_arg1885z00_433 = 
CDR(BgL_pairz00_746); } 
{ /* ./Llib/_scheduler.scm 379 */
obj_t BgL_arg1865z00_751;
{ /* ./Llib/_scheduler.scm 379 */
BgL_schedulerz00_bglt BgL_obj1104z00_752;
BgL_obj1104z00_752 = 
(BgL_schedulerz00_bglt)(BgL_scdlz00_34); 
BgL_arg1865z00_751 = 
(((BgL_schedulerz00_bglt)CREF(BgL_obj1104z00_752))->BgL_envzb2zb2); } 
BGl_signalzd2emitzd2zz__ft_signalz00(BgL_arg1884z00_432, BgL_arg1885z00_433, BgL_arg1865z00_751); } } } 
{ /* ./Llib/_scheduler.scm 378 */
obj_t BgL_arg1891z00_434;
{ /* ./Llib/_scheduler.scm 378 */
obj_t BgL_pairz00_753;
if(
PAIRP(BgL_l1485z00_427))
{ /* ./Llib/_scheduler.scm 378 */
BgL_pairz00_753 = BgL_l1485z00_427; }  else 
{ /* ./Llib/_scheduler.scm 378 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_l1485z00_427); 
exit( -1 );} 
BgL_arg1891z00_434 = 
CDR(BgL_pairz00_753); } 
{ 
obj_t BgL_l1485z00_2254;
BgL_l1485z00_2254 = BgL_arg1891z00_434; 
BgL_l1485z00_427 = BgL_l1485z00_2254; 
goto BgL_forzd2each1486zd2_428;} } }  else 
{ /* ./Llib/_scheduler.scm 378 */
if(
NULLP(BgL_l1485z00_427))
{ /* ./Llib/_scheduler.scm 378 */BTRUE; }  else 
{ /* ./Llib/_scheduler.scm 378 */
FAILURE(BGl_string3007z00zz__ft_z52schedulerz52,BGl_string3008z00zz__ft_z52schedulerz52,BgL_l1485z00_427);} } } } 
BgL_g1480z00_423 = 
((((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_34))->BgL_tobroadcastz00) = ((obj_t)BNIL), BUNSPEC); }  else 
{ /* ./Llib/_scheduler.scm 376 */
BgL_g1480z00_423 = BFALSE; } } 
{ /* ./Llib/_scheduler.scm 373 */
obj_t BgL_arg1873z00_424;
{ /* ./Llib/_scheduler.scm 373 */
BgL_threadz00_bglt BgL_obj1003z00_760;
BgL_obj1003z00_760 = 
(BgL_threadz00_bglt)(BgL_scdlz00_34); 
BgL_arg1873z00_424 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_760))->BgL_z52builtinz52); } 
{ /* ./Llib/_scheduler.scm 373 */
bglthread_t BgL_auxz00_2261;
{ /* ./Llib/_scheduler.scm 373 */
obj_t BgL_auxz00_2262;
{ /* ./Llib/_scheduler.scm 373 */
obj_t BgL_aux2874z00_1058;
if(
FOREIGNP(BgL_arg1873z00_424))
{ /* ./Llib/_scheduler.scm 373 */
BgL_aux2874z00_1058 = BgL_arg1873z00_424; }  else 
{ /* ./Llib/_scheduler.scm 373 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_arg1873z00_424); 
exit( -1 );} 
{ /* ./Llib/_scheduler.scm 373 */
bool_t BgL_testz00_2268;
if(
FOREIGNP(BgL_aux2874z00_1058))
{ /* ./Llib/_scheduler.scm 373 */
obj_t BgL_arg1502z00_1204;obj_t BgL_arg1503z00_1205;
{ /* ./Llib/_scheduler.scm 373 */
obj_t BgL_auxz00_2271;
if(
FOREIGNP(BgL_aux2874z00_1058))
{ /* ./Llib/_scheduler.scm 373 */
BgL_auxz00_2271 = BgL_aux2874z00_1058
; }  else 
{ /* ./Llib/_scheduler.scm 373 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2995z00zz__ft_z52schedulerz52, BgL_aux2874z00_1058); 
exit( -1 );} 
BgL_arg1502z00_1204 = 
FOREIGN_ID(BgL_auxz00_2271); } 
BgL_arg1503z00_1205 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_2268 = 
(BgL_arg1502z00_1204==BgL_arg1503z00_1205); }  else 
{ /* ./Llib/_scheduler.scm 373 */
BgL_testz00_2268 = ((bool_t)0)
; } 
if(BgL_testz00_2268)
{ /* ./Llib/_scheduler.scm 373 */
BgL_auxz00_2262 = BgL_aux2874z00_1058
; }  else 
{ /* ./Llib/_scheduler.scm 373 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)28)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_aux2874z00_1058); 
exit( -1 );} } } 
BgL_auxz00_2261 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_2262); } 
bglasync_asynchronize(BgL_auxz00_2261); } } 
return BgL_g1480z00_423;} } 
}



/* %scheduler-add-broadcast! */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2addzd2broadcastz12z40zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_35, obj_t BgL_sigz00_36, obj_t BgL_valz00_37)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 386 */
{ /* ./Llib/_scheduler.scm 387 */
obj_t BgL_arg1905z00_438;
{ /* ./Llib/_scheduler.scm 387 */
BgL_threadz00_bglt BgL_obj1003z00_761;
BgL_obj1003z00_761 = 
(BgL_threadz00_bglt)(BgL_scdlz00_35); 
BgL_arg1905z00_438 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_761))->BgL_z52builtinz52); } 
{ /* ./Llib/_scheduler.scm 387 */
bglthread_t BgL_auxz00_2287;
{ /* ./Llib/_scheduler.scm 387 */
obj_t BgL_auxz00_2288;
{ /* ./Llib/_scheduler.scm 387 */
obj_t BgL_aux2890z00_1062;
if(
FOREIGNP(BgL_arg1905z00_438))
{ /* ./Llib/_scheduler.scm 387 */
BgL_aux2890z00_1062 = BgL_arg1905z00_438; }  else 
{ /* ./Llib/_scheduler.scm 387 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)29)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_arg1905z00_438); 
exit( -1 );} 
{ /* ./Llib/_scheduler.scm 387 */
bool_t BgL_testz00_2294;
if(
FOREIGNP(BgL_aux2890z00_1062))
{ /* ./Llib/_scheduler.scm 387 */
obj_t BgL_arg1502z00_1207;obj_t BgL_arg1503z00_1208;
{ /* ./Llib/_scheduler.scm 387 */
obj_t BgL_auxz00_2297;
if(
FOREIGNP(BgL_aux2890z00_1062))
{ /* ./Llib/_scheduler.scm 387 */
BgL_auxz00_2297 = BgL_aux2890z00_1062
; }  else 
{ /* ./Llib/_scheduler.scm 387 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2995z00zz__ft_z52schedulerz52, BgL_aux2890z00_1062); 
exit( -1 );} 
BgL_arg1502z00_1207 = 
FOREIGN_ID(BgL_auxz00_2297); } 
BgL_arg1503z00_1208 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_2294 = 
(BgL_arg1502z00_1207==BgL_arg1503z00_1208); }  else 
{ /* ./Llib/_scheduler.scm 387 */
BgL_testz00_2294 = ((bool_t)0)
; } 
if(BgL_testz00_2294)
{ /* ./Llib/_scheduler.scm 387 */
BgL_auxz00_2288 = BgL_aux2890z00_1062
; }  else 
{ /* ./Llib/_scheduler.scm 387 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)29)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_aux2890z00_1062); 
exit( -1 );} } } 
BgL_auxz00_2287 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_2288); } 
bglasync_synchronize(BgL_auxz00_2287); } } 
{ /* ./Llib/_scheduler.scm 387 */
obj_t BgL_g1487z00_439;
{ /* ./Llib/_scheduler.scm 390 */
obj_t BgL_svz00_442;
BgL_svz00_442 = 
MAKE_PAIR(BgL_sigz00_36, BgL_valz00_37); 
{ /* ./Llib/_scheduler.scm 391 */
obj_t BgL_arg1913z00_443;
{ /* ./Llib/_scheduler.scm 391 */
obj_t BgL_arg1916z00_444;
BgL_arg1916z00_444 = 
(((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_35))->BgL_tobroadcastz00); 
BgL_arg1913z00_443 = 
MAKE_PAIR(BgL_svz00_442, BgL_arg1916z00_444); } 
((((BgL_z52schedulerz52_bglt)CREF(BgL_scdlz00_35))->BgL_tobroadcastz00) = ((obj_t)BgL_arg1913z00_443), BUNSPEC); } } 
{ /* ./Llib/_scheduler.scm 392 */
obj_t BgL_arg1921z00_445;
{ /* ./Llib/_scheduler.scm 392 */
BgL_threadz00_bglt BgL_obj1003z00_765;
BgL_obj1003z00_765 = 
(BgL_threadz00_bglt)(BgL_scdlz00_35); 
BgL_arg1921z00_445 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_765))->BgL_z52builtinz52); } 
{ /* ./Llib/_scheduler.scm 392 */
bglthread_t BgL_auxz00_2317;
{ /* ./Llib/_scheduler.scm 392 */
obj_t BgL_auxz00_2318;
{ /* ./Llib/_scheduler.scm 392 */
obj_t BgL_aux2906z00_1066;
if(
FOREIGNP(BgL_arg1921z00_445))
{ /* ./Llib/_scheduler.scm 392 */
BgL_aux2906z00_1066 = BgL_arg1921z00_445; }  else 
{ /* ./Llib/_scheduler.scm 392 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)29)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_arg1921z00_445); 
exit( -1 );} 
{ /* ./Llib/_scheduler.scm 392 */
bool_t BgL_testz00_2324;
if(
FOREIGNP(BgL_aux2906z00_1066))
{ /* ./Llib/_scheduler.scm 392 */
obj_t BgL_arg1502z00_1210;obj_t BgL_arg1503z00_1211;
{ /* ./Llib/_scheduler.scm 392 */
obj_t BgL_auxz00_2327;
if(
FOREIGNP(BgL_aux2906z00_1066))
{ /* ./Llib/_scheduler.scm 392 */
BgL_auxz00_2327 = BgL_aux2906z00_1066
; }  else 
{ /* ./Llib/_scheduler.scm 392 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2995z00zz__ft_z52schedulerz52, BgL_aux2906z00_1066); 
exit( -1 );} 
BgL_arg1502z00_1210 = 
FOREIGN_ID(BgL_auxz00_2327); } 
BgL_arg1503z00_1211 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_2324 = 
(BgL_arg1502z00_1210==BgL_arg1503z00_1211); }  else 
{ /* ./Llib/_scheduler.scm 392 */
BgL_testz00_2324 = ((bool_t)0)
; } 
if(BgL_testz00_2324)
{ /* ./Llib/_scheduler.scm 392 */
BgL_auxz00_2318 = BgL_aux2906z00_1066
; }  else 
{ /* ./Llib/_scheduler.scm 392 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)29)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_aux2906z00_1066); 
exit( -1 );} } } 
BgL_auxz00_2317 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_2318); } 
bglasync_scheduler_notify(BgL_auxz00_2317); } } 
BgL_g1487z00_439 = BUNSPEC; 
{ /* ./Llib/_scheduler.scm 387 */
obj_t BgL_arg1909z00_440;
{ /* ./Llib/_scheduler.scm 387 */
BgL_threadz00_bglt BgL_obj1003z00_766;
BgL_obj1003z00_766 = 
(BgL_threadz00_bglt)(BgL_scdlz00_35); 
BgL_arg1909z00_440 = 
(((BgL_threadz00_bglt)CREF(BgL_obj1003z00_766))->BgL_z52builtinz52); } 
{ /* ./Llib/_scheduler.scm 387 */
bglthread_t BgL_auxz00_2343;
{ /* ./Llib/_scheduler.scm 387 */
obj_t BgL_auxz00_2344;
{ /* ./Llib/_scheduler.scm 387 */
obj_t BgL_aux2922z00_1070;
if(
FOREIGNP(BgL_arg1909z00_440))
{ /* ./Llib/_scheduler.scm 387 */
BgL_aux2922z00_1070 = BgL_arg1909z00_440; }  else 
{ /* ./Llib/_scheduler.scm 387 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)29)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_arg1909z00_440); 
exit( -1 );} 
{ /* ./Llib/_scheduler.scm 387 */
bool_t BgL_testz00_2350;
if(
FOREIGNP(BgL_aux2922z00_1070))
{ /* ./Llib/_scheduler.scm 387 */
obj_t BgL_arg1502z00_1213;obj_t BgL_arg1503z00_1214;
{ /* ./Llib/_scheduler.scm 387 */
obj_t BgL_auxz00_2353;
if(
FOREIGNP(BgL_aux2922z00_1070))
{ /* ./Llib/_scheduler.scm 387 */
BgL_auxz00_2353 = BgL_aux2922z00_1070
; }  else 
{ /* ./Llib/_scheduler.scm 387 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)0)), BGl_string2995z00zz__ft_z52schedulerz52, BgL_aux2922z00_1070); 
exit( -1 );} 
BgL_arg1502z00_1213 = 
FOREIGN_ID(BgL_auxz00_2353); } 
BgL_arg1503z00_1214 = 
CNST_TABLE_REF(((long)1)); 
BgL_testz00_2350 = 
(BgL_arg1502z00_1213==BgL_arg1503z00_1214); }  else 
{ /* ./Llib/_scheduler.scm 387 */
BgL_testz00_2350 = ((bool_t)0)
; } 
if(BgL_testz00_2350)
{ /* ./Llib/_scheduler.scm 387 */
BgL_auxz00_2344 = BgL_aux2922z00_1070
; }  else 
{ /* ./Llib/_scheduler.scm 387 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)29)), BGl_string3001z00zz__ft_z52schedulerz52, BgL_aux2922z00_1070); 
exit( -1 );} } } 
BgL_auxz00_2343 = 
(bglthread_t)FOREIGN_TO_COBJ(BgL_auxz00_2344); } 
bglasync_asynchronize(BgL_auxz00_2343); } } 
return BgL_g1487z00_439;} } 
}



/* _%scheduler-add-broadcast! */
obj_t BGl__z52schedulerzd2addzd2broadcastz12z40zz__ft_z52schedulerz52(obj_t BgL_envz00_847, obj_t BgL_scdlz00_848, obj_t BgL_sigz00_849, obj_t BgL_valz00_850)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 386 */
{ /* ./Llib/_scheduler.scm 387 */
BgL_z52schedulerz52_bglt BgL_auxz00_2367;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_848, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/_scheduler.scm 387 */
BgL_auxz00_2367 = 
(BgL_z52schedulerz52_bglt)(BgL_scdlz00_848)
; }  else 
{ /* ./Llib/_scheduler.scm 387 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)30)), BGl_string3002z00zz__ft_z52schedulerz52, BgL_scdlz00_848); 
exit( -1 );} 
return 
BGl_z52schedulerzd2addzd2broadcastz12z40zz__ft_z52schedulerz52(BgL_auxz00_2367, BgL_sigz00_849, BgL_valz00_850);} } 
}



/* %scheduler-time */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2timez80zz__ft_z52schedulerz52(BgL_schedulerz00_bglt BgL_scdlz00_38)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 398 */
{ /* ./Llib/_scheduler.scm 399 */
BgL_ftenvz00_bglt BgL_obj1106z00_772;
{ /* ./Llib/_scheduler.scm 399 */
obj_t BgL_aux2938z00_1074;
BgL_aux2938z00_1074 = 
CAR(
(((BgL_schedulerz00_bglt)CREF(BgL_scdlz00_38))->BgL_envzb2zb2)); 
if(
BGl_iszd2azf3z21zz__objectz00(BgL_aux2938z00_1074, BGl_ftenvz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 399 */
BgL_obj1106z00_772 = 
(BgL_ftenvz00_bglt)(BgL_aux2938z00_1074); }  else 
{ /* ./Llib/_scheduler.scm 399 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)31)), BGl_string3006z00zz__ft_z52schedulerz52, BgL_aux2938z00_1074); 
exit( -1 );} } 
return 
BINT(
(((BgL_ftenvz00_bglt)CREF(BgL_obj1106z00_772))->BgL_instantz00));} } 
}



/* _%scheduler-time */
obj_t BGl__z52schedulerzd2timez80zz__ft_z52schedulerz52(obj_t BgL_envz00_851, obj_t BgL_scdlz00_852)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 398 */
{ /* ./Llib/_scheduler.scm 399 */
BgL_schedulerz00_bglt BgL_auxz00_2385;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_852, BGl_schedulerz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 399 */
BgL_auxz00_2385 = 
(BgL_schedulerz00_bglt)(BgL_scdlz00_852)
; }  else 
{ /* ./Llib/_scheduler.scm 399 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)32)), BGl_string2996z00zz__ft_z52schedulerz52, BgL_scdlz00_852); 
exit( -1 );} 
return 
BGl_z52schedulerzd2timez80zz__ft_z52schedulerz52(BgL_auxz00_2385);} } 
}



/* %scheduler-waiting-threads */
BGL_EXPORTED_DEF obj_t BGl_z52schedulerzd2waitingzd2threadsz52zz__ft_z52schedulerz52(BgL_z52schedulerz52_bglt BgL_scdlz00_39)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 405 */
{ 
obj_t BgL_envsz00_450;obj_t BgL_thsz00_451;
{ /* ./Llib/_scheduler.scm 407 */
obj_t BgL_arg1932z00_453;
{ /* ./Llib/_scheduler.scm 407 */
BgL_schedulerz00_bglt BgL_obj1104z00_773;
BgL_obj1104z00_773 = 
(BgL_schedulerz00_bglt)(BgL_scdlz00_39); 
BgL_arg1932z00_453 = 
(((BgL_schedulerz00_bglt)CREF(BgL_obj1104z00_773))->BgL_envzb2zb2); } 
{ /* ./Llib/_scheduler.scm 407 */
obj_t BgL_aux2972z00_1082;
BgL_envsz00_450 = BgL_arg1932z00_453; 
BgL_thsz00_451 = BNIL; 
BgL_loopz00_452:
if(
PAIRP(BgL_envsz00_450))
{ /* ./Llib/_scheduler.scm 410 */
obj_t BgL_arg1938z00_456;obj_t BgL_arg1939z00_457;
{ /* ./Llib/_scheduler.scm 410 */
obj_t BgL_pairz00_775;
if(
PAIRP(BgL_envsz00_450))
{ /* ./Llib/_scheduler.scm 410 */
BgL_pairz00_775 = BgL_envsz00_450; }  else 
{ /* ./Llib/_scheduler.scm 410 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)33)), BGl_string2997z00zz__ft_z52schedulerz52, BgL_envsz00_450); 
exit( -1 );} 
BgL_arg1938z00_456 = 
CDR(BgL_pairz00_775); } 
{ /* ./Llib/_scheduler.scm 410 */
obj_t BgL_arg1943z00_458;
{ /* ./Llib/_scheduler.scm 410 */
obj_t BgL_arg1946z00_459;
{ /* ./Llib/_scheduler.scm 410 */
obj_t BgL_auxz00_2403;
{ /* ./Llib/_scheduler.scm 410 */
BgL_schedulerz00_bglt BgL_obj1104z00_776;
BgL_obj1104z00_776 = 
(BgL_schedulerz00_bglt)(BgL_scdlz00_39); 
BgL_auxz00_2403 = 
(((BgL_schedulerz00_bglt)CREF(BgL_obj1104z00_776))->BgL_envzb2zb2); } 
BgL_arg1946z00_459 = 
CAR(BgL_auxz00_2403); } 
{ /* ./Llib/_scheduler.scm 410 */
BgL_ftenvz00_bglt BgL_auxz00_2407;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_arg1946z00_459, BGl_ftenvz00zz__ft_typesz00))
{ /* ./Llib/_scheduler.scm 410 */
BgL_auxz00_2407 = 
(BgL_ftenvz00_bglt)(BgL_arg1946z00_459)
; }  else 
{ /* ./Llib/_scheduler.scm 410 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)33)), BGl_string3006z00zz__ft_z52schedulerz52, BgL_arg1946z00_459); 
exit( -1 );} 
BgL_arg1943z00_458 = 
BGl_ftenvzd2threadszd2zz__ft_envz00(BgL_auxz00_2407); } } 
BgL_arg1939z00_457 = 
bgl_append2(BgL_arg1943z00_458, BgL_thsz00_451); } 
{ 
obj_t BgL_thsz00_2417;obj_t BgL_envsz00_2416;
BgL_envsz00_2416 = BgL_arg1938z00_456; 
BgL_thsz00_2417 = BgL_arg1939z00_457; 
BgL_thsz00_451 = BgL_thsz00_2417; 
BgL_envsz00_450 = BgL_envsz00_2416; 
goto BgL_loopz00_452;} }  else 
{ /* ./Llib/_scheduler.scm 409 */
BgL_aux2972z00_1082 = BgL_thsz00_451; } 
{ /* ./Llib/_scheduler.scm 407 */
bool_t BgL_testz00_2418;
if(
PAIRP(BgL_aux2972z00_1082))
{ /* ./Llib/_scheduler.scm 407 */
BgL_testz00_2418 = ((bool_t)1)
; }  else 
{ /* ./Llib/_scheduler.scm 407 */
BgL_testz00_2418 = 
NULLP(BgL_aux2972z00_1082)
; } 
if(BgL_testz00_2418)
{ /* ./Llib/_scheduler.scm 407 */
return BgL_aux2972z00_1082;}  else 
{ /* ./Llib/_scheduler.scm 407 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)33)), BGl_string3000z00zz__ft_z52schedulerz52, BgL_aux2972z00_1082); 
exit( -1 );} } } } } } 
}



/* _%scheduler-waiting-threads */
obj_t BGl__z52schedulerzd2waitingzd2threadsz52zz__ft_z52schedulerz52(obj_t BgL_envz00_853, obj_t BgL_scdlz00_854)
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 405 */
{ /* ./Llib/_scheduler.scm 406 */
BgL_z52schedulerz52_bglt BgL_auxz00_2425;
if(
BGl_iszd2azf3z21zz__objectz00(BgL_scdlz00_854, BGl_z52schedulerz52zz__ft_z52typesz52))
{ /* ./Llib/_scheduler.scm 406 */
BgL_auxz00_2425 = 
(BgL_z52schedulerz52_bglt)(BgL_scdlz00_854)
; }  else 
{ /* ./Llib/_scheduler.scm 406 */
BGl_bigloozd2typezd2errorz00zz__errorz00(
CNST_TABLE_REF(((long)34)), BGl_string3002z00zz__ft_z52schedulerz52, BgL_scdlz00_854); 
exit( -1 );} 
return 
BGl_z52schedulerzd2waitingzd2threadsz52zz__ft_z52schedulerz52(BgL_auxz00_2425);} } 
}



/* method-init */
obj_t BGl_methodzd2initzd2zz__ft_z52schedulerz52()
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 15 */
return BUNSPEC;} 
}



/* imported-modules-init */
obj_t BGl_importedzd2moduleszd2initz00zz__ft_z52schedulerz52()
{ AN_OBJECT;
{ /* ./Llib/_scheduler.scm 15 */
BGl_modulezd2initializa7ationz75zz__ft_debugz00(((long)45544), 
BSTRING_TO_STRING(BGl_string3015z00zz__ft_z52schedulerz52)); 
BGl_modulezd2initializa7ationz75zz__ft_typesz00(((long)55409), 
BSTRING_TO_STRING(BGl_string3015z00zz__ft_z52schedulerz52)); 
BGl_modulezd2initializa7ationz75zz__ft_z52typesz52(((long)35069), 
BSTRING_TO_STRING(BGl_string3015z00zz__ft_z52schedulerz52)); 
BGl_modulezd2initializa7ationz75zz__ft_schedulerz00(((long)58241), 
BSTRING_TO_STRING(BGl_string3015z00zz__ft_z52schedulerz52)); 
BGl_modulezd2initializa7ationz75zz__ft_z52threadz52(((long)38854), 
BSTRING_TO_STRING(BGl_string3015z00zz__ft_z52schedulerz52)); 
BGl_modulezd2initializa7ationz75zz__ft_envz00(((long)35934), 
BSTRING_TO_STRING(BGl_string3015z00zz__ft_z52schedulerz52)); 
BGl_modulezd2initializa7ationz75zz__ft_z52envz52(((long)51670), 
BSTRING_TO_STRING(BGl_string3015z00zz__ft_z52schedulerz52)); 
return 
BGl_modulezd2initializa7ationz75zz__ft_signalz00(((long)5725), 
BSTRING_TO_STRING(BGl_string3015z00zz__ft_z52schedulerz52));} 
}

